/* ============================== pwg.pjt.pdp.0.print.document.processing.h =============================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_0_PRINT_DOCUMENT_PROCESSING_H__
#define __PWG_PJT_PDP_0_PRINT_DOCUMENT_PROCESSING_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pdp.1.number.up.h"
#include "pwg.pjt.pdp.1.copies.h"
#include "pwg.pjt.pdp.1.font.name.requested.h"
#include "pwg.pjt.pdp.1.font.size.requested.h"
#include "pwg.pjt.xxx.N.media.h"
#include "pwg.pjt.pdp.1.orientation.requested.h"
#include "pwg.pjt.pdp.1.output.bin.h"
#include "pwg.pjt.pdp.1.page.ranges.h"
#include "pwg.pjt.pdp.1.print.content.optimize.h"
#include "pwg.pjt.pdp.1.print.color.mode.h"
#include "pwg.pjt.pdp.1.print.rendering.intent.h"
#include "pwg.pjt.pdp.1.quality.h"
#include "pwg.pjt.pdp.1.resolution.h"
#include "pwg.pjt.pdp.1.sheet.collate.h"
#include "pwg.pjt.pdp.1.sides.h"
#include "pwg.pjt.pdp.1.x.y.image.position.h"
#include "pwg.pjt.pdp.1.x.y.image.shift.h"

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
#include "pwg.pjt.pdp.2.cover.type.h"
#include "pwg.pjt.pdp.2.cover.back.front.h"
#include "pwg.pjt.pdp.2.feed.orientation.h"
#include "pwg.pjt.pdp.2.finishings.h"
#include "pwg.pjt.pdp.2.page.delivery.h"
#include "pwg.pjt.pdp.2.separator.sheets.h"

#endif

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
#include "pwg.pjt.pdp.3.presentation.direction.number.up.h"
#include "pwg.pjt.pdp.3.finishings.col.h"
#include "pwg.pjt.pdp.3.force.front.side.h"
#include "pwg.pjt.pdp.3.imposition.template.h"
#include "pwg.pjt.pdp.3.insert.sheet.h"
#include "pwg.pjt.pdp.1.output.device.h"
#include "pwg.pjt.pdp.3.pdl.init.file.h"

#endif

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Print Document Processing                                                                                */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.1 [page 16-18] PrintDocumentProcessing                                                           */
/* -----------------                                                                                        */
/* Figure 3 and Figure 4 show the elements that make up the PrintDocumentProcessing group of elements.  The */
/* subsections below show the complex PrintDocumentProcessing elements or data types.                       */
/*                                                                                                          */
/*                              + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +       */
/*                              .  PrintDocumentProcessingType                                      .       */
/*                              .                                                                   .       */
/*                              .     +------------+                                                .       */
/*                              . +---| attributes |                                                .       */
/*                              . |   +------------+                                                .       */
/*                              . |                                                                 .       */
/*                              . |                  + - - - - - + 123                              .       */
/*                              . |              + - ! NumberUp  !+                                 .       */
/*                              . |              !   I - - - - - M                                  .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - + 123                                .       */
/*                              . |              + - ! Copies  !+                                   .       */
/*                              . |              !   I - - - - M                                    .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! FontNameRequested !+                         .       */
/*                              . |              !   S - - - - - - - - - M                          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! FontSizeRequested !+                         .       */
/*                              . |              !   I - - - - - - - - - M                          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - + 123                                  .       */
/*                              . |              + - ! Media !+                                     .       */
/*                              . |              !   K - - - M  Required                            .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - + 123                              .       */
/*                              . |              + - ! MediaType !+                                 .       */
/*                              . |              !   K - - - - - M Required                         .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - + 123                  .       */
/*                              . |              + - ! OrientationRequested  !+                     .       */
/*                              . |              !   K - - - - - - - - - - - M  Required            .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - + 123                              .       */
/*                              . |              + - ! OutputBin !+                                 .       */
/*                              . |              !   K - - - - - M                                  .       */
/*                              . |              !                                                  .       */
/*                              . | /---------\  !   + - - - - - - + 123                            .       */
/*                              . +-| -o-o-o- |- + - ! PageRanges  !+                               .       */
/*                              . | \---------/  !   R - - - - - - M  Required                      .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - + 123                  .       */
/*                              . |              + - ! PrintContentOptimize  !+                     .       */
/*                              . |              !   K - - - - - - - - - - - M                      .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - + 123                        .       */
/*                              . |              + - ! PrintColorMode  !+                           .       */
/*                              . |              !   K - - - - - - - - M  Conditionally Required    .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - - - + 123                  .       */
/*                              . |              + - ! PrintRenderingIntent  !+                     .       */
/*                              . |              !   K - - - - - - - - - - - M                      .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - + 123                              .       */
/*                              . |              + - ! Quality   !+                                 .       */
/*                              . |              !   K - - - - - M                                  .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + 123                            .       */
/*                              . |              + - ! Resolution  !+                               .       */
/*                              . |              !   C - - - - - - M                                .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - + 123                          .       */
/*                              . |              + - ! SheetCollate  !+                             .       */
/*                              . |              !   K - - - - - - - M                              .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - + 123                                  .       */
/*                              . |              + - ! Sides !+                                     .       */
/*                              . |              !   K - - - M                                      .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - + 123                        .       */
/*                              . |              + - ! XImagePosition  !+                           .       */
/*                              . |              !   K - - - - - - - - M                            .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + 123                            .       */
/*                              . |              + - ! XImageShift !+                               .       */
/*                              . |              !   I - - - - - - M                                .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! XSide1ImageShift  !+                         .       */
/*                              . |              !   I - - - - - - - - - M                          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! XSide2ImageShift  !+                         .       */
/*                              . |              !   I - - - - - - - - - M                          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - + 123                        .       */
/*                              . |              + - ! YImagePosition  !+                           .       */
/*                              . |              !   K - - - - - - - - M                            .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + 123                            .       */
/*                              . |              + - ! YImageShift !+                               .       */
/*                              . |              !   I - - - - - - M                                .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! YSide1ImageShift  !+                         .       */
/*                              . |              !   I - - - - - - - - - M                          .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - - + 123                      .       */
/*                              . |              + - ! YSide2ImageShift  !+                         .       */
/*                              . |              !   I - - - - - - - - - M                          .       */
/*                              . |              !                                                  .       */
/* 2222222222222222222222222222222|222222222222222222222222222222222222222222222222222222222222222222222222 */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - + .23                            .       */
/*                              . |              + - ! CoverFront  !+                               .       */
/*                              . |              !   C - - - - - - M                                .       */
/*                              . |              !                                                  .       */
/*                              . |              !   + - - - - - - - - + .23                        .       */
/*                              . |              + - ! FeedOrientation !+                           .       */
/*                              . |              !   K - - - - - - - - M                            .       */
/*                              . |              !                                                  .       */
/* +-------------------------+  . |              !   + - - - - - + .23                              .       */
/* | PrintDocumentProcessing |--.-+              + - ! Finishing !+                                 .       */
/* +-------------------------+  .                !   CR- - - - - M  Conditionally Required          .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - + .23                              .       */
/*                              .                + - ! MediaCol  !+                                 .       */
/*                              .                !   C - - - - - M                                  .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - + .23                          .       */
/*                              .                + - ! PageDelivery  !+                             .       */
/*                              .                !   K - - - - - - - M                              .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - - - + .23                      .       */
/*                              .                + - ! SeparatorSheets   !+                         .       */
/*                              .                !   C - - - - - - - - - M                          .       */
/*                              .                !                                                  .       */
/* 33333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333 */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - - - - - - - - - + ..3          .       */
/*                              .                + - ! PresentationDirectionNumberUp !+             .       */
/*                              .                !   K - - - - - - - - - - - - - - - M              .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - + ..3                              .       */
/*                              .                + - ! CoverBack !+                                 .       */
/*                              .                !   C - - - - - M                                  .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - + ..3                            .       */
/*                              .                + - ! FinshingCol !+                               .       */
/*                              .                !   C - - - - - - M                                .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - - + ..3                        .       */
/*                              .                + - ! ForceFrontSide  !+                           .       */
/*                              .                !   L - - - - - - - - M                            .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - - - - + ..3                    .       */
/*                              .                + - ! ImpositionTemplate  !+                       .       */
/*                              .                !   K - - - - - - - - - - M                        .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - + ..3                            .       */
/*                              .                + - ! InsertSheet !+                               .       */
/*                              .                !   C - - - - - - M                                .       */
/*                              .                !      0..infinite                                 .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - - - - + ..3                    .       */
/*                              .                + - ! MediaInputTrayCheck !+                       .       */
/*                              .                !   K - - - - - - - - - - M                        .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - + ..3                          .       */
/*                              .                + - ! OutputDevice  !+                             .       */
/*                              .                !   S - - - - - - - M                              .       */
/*                              .                !                                                  .       */
/*                              .                !   + - - - - - - - + ..3                          .       */
/*                              .                + - ! PdlInitFiles  !+                             .       */
/*                              .                !   C - - - - - - - M                              .       */
/*                              .                !                                                  .       */
/* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
/*                              .                !                                                  .       */
/*                              .                !   / - - - - - - -\ 123                           .       */
/*                              .                + - ! any ##other  !                               .       */
/*                              .                    \ - - - - - - -/                               .       */
/*                              .                        0..infinite                                .       */
/*                              + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +       */
/*                                                                                                          */
/*                 Figure 3 PrintDocumentProcessing (1) and Figure 4 PrintDocumentProcessing (2)            */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + - - - - + 123                      ! = Optional    */
/*      ! Optional Element  !   | Required Element |   | Element | ^^^ Support Level        | = Required    */
/*      X - - - - - - - - - Y   X------------------Y   + - - - - +                                          */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
typedef struct {
                     pwgBIT32  numberUp;                    /* Number doc pages on single print pages side  */
                     pwgBIT32  copies;                      /* Number copies of Document(s) to be printed   */
     pwgFontNameRequestedEnum  fontNameReq;                 /* Specifies name of the font for document data */
                     pwgBIT32  fontSizeReq;                 /* Font size (n/72) to use to print a job       */
         pwgMediaSizeNameEnum  media;                       /* Media (size)                                 */
             pwgMediaTypeEnum  mediaType;                   /* Media Type                                   */
  pwgOrientationRequestedEnum  orientationRequested;        /* Orientation for printed pages for document   */
             pwgOutputBinEnum  outputBin;                   /* Output bin where the job is to be delivered. */
                 pwgPageRange  pageRanges[pwgMAX_PAGE_RANGES]; /* Range pages in document data to be output.*/
  pwgPrintContentOptimizeEnum  printContentOptimize;        /* Optimization/processing to perform on content*/
        pwgPrintColorModeEnum  printColorMode;              /* Specifies the color mode to use for printing.*/
  pwgPrintRenderingIntentEnum  printRenderingIntent;        /* Out-of-gamut colors mapping                  */
               pwgQualityEnum  quality;                     /* Output quality that the PrintService uses    */
                pwgResolution  resolution;                  /* Resolution that PrintService uses for the Job*/
          pwgSheetCollateEnum  sheetCollate;                /* Specifies sheets sequence of each copy       */
                 pwgSidesEnum  sides;                       /* How an impression is placed on media side(s) */

        pwgXImagePositionEnum  xImagePosition;              /* Finished-Page Image X position               */
                     pwgINT32  xImageShift;                 /* Finished-Page            Image shift: x-axis */
                     pwgINT32  xSide1ImageShift;            /* Finished-Page front side Image shift: x-axis */
                     pwgINT32  xSide2ImageShift;            /* Finished-Page back  side Image shift: x-axis */

        pwgYImagePositionEnum  yImagePosition;              /* Finished-Page Image Y position               */
                     pwgINT32  yImageShift;                 /* Finished-Page            Image shift: y-axis */
                     pwgINT32  ySide1ImageShift;            /* Finished-Page front side Image shift: y-axis */
                     pwgINT32  ySide2ImageShift;            /* Finished-Page back  side Image shift: y-axis */

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
           pwgCoverCollection  coverFront;                  /* The front cover to apply to this Document.   */
       pwgFeedOrientationEnum  feedOrientation;             /* Media edge fed into print engine from tray   */
            pwgFinishingsEnum  finishing;                   /* Finishings for each copy of Output Document  */
         pwgMediaDescTypeEnum  mediaDescType;               /* Type of media description used for this cover*/
            pwgMediaCollecton  mediaCol;                    /* Actual media description information         */
          pwgPageDeliveryEnum  pageDelivery;                /* Pages delivered to output bin                */
           pwgSeparatorSheets  separatorSheets;             /* Separator sheets printed with Document       */
#endif

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
          pwgPresDirNumUpEnum  presDirNumUp;                /* Layout ordering for Number Up                */
           pwgCoverCollection  coverBack;                   /* The back cover to apply this Document.       */
       pwgFinsihingsCollecton  finishingCol;                /* Fine granularity specification of finishings */
                     pwgBIT32  forceFrontSide[pwgMAX_FORCE_FRONT_PAGES]; /* Pages imaged on front of sheet  */
    pwgImpositionTemplateEnum  impositionTemplate;          /* Method for laying out finished page images   */
     pwgInsertSheetCollection  insertSheet[pwgMAX_INSERT_SHEEETS];  /* How Insert Sheets are to be inserted */
   pwgMediaInputTrayCheckEnum  mediaInputTrayCheck;         /* Media in identified tray must match "media"  */
                      pwgCHAR  outputDevice[pwgMAX_OUTPUT_DEVICE_NAME];/* Device Job/Doc will be printed.   */
               pwgPdlInitFile  pdfInitFiles[pwgMAX_PDL_INIT_FILES]; /* Controls init of  PDL interpreter.   */
#endif

                    VND_PRT_DOC_PROC_STRUCT

} pwgPrintDocumentProcessing;

typedef struct {
        pwgNUM_DEF* numberUpDef;                      /* Number doc pages on single print pages side        */
        pwgNUM_DEF* copiesDef;                        /* Number copies of Document(s) to be printed         */
    pwgNUM_RNG_DEF* fontNameReq;                      /* Specifies name of the font for document data       */
        pwgNUM_DEF* fontSizeReq;                      /* Font size (n/72) to use to print a job             */
    pwgNUM_RNG_DEF* mediaSizeNameDef;                 /* Media (size)                                       */
    pwgNUM_RNG_DEF* mediaTypeDef;                     /* Media Type                                         */
    pwgNUM_RNG_DEF* orientationRequested;             /* Orientation for printed pages for document         */
    pwgNUM_RNG_DEF* outputBin;                        /* Output bin where the job is to be delivered.       */
     pwgSTRUCT_DEF* pageRanges;                       /* Range of pages in document data to be output.      */
    pwgNUM_RNG_DEF* printContentOptimize;             /* Optimization/processing to perform on content      */
    pwgNUM_RNG_DEF* printColorMode;                   /* Specifies the color mode to use for printing.      */
    pwgNUM_RNG_DEF* printRenderingIntent;             /* Out-of-gamut colors mapping                        */
    pwgNUM_RNG_DEF* quality;                          /* Output quality that the PrintService uses          */
     pwgSTRUCT_DEF* resolution;                       /* Resolution that PrintService uses for the Job      */
    pwgNUM_RNG_DEF* sheetCollate;                     /* Specifies sheets sequence of each copy             */
    pwgNUM_RNG_DEF* sides;                            /* How an impression is placed on media side(s)       */
    pwgNUM_RNG_DEF* xImagePosition;                   /* Finished-Page Image X position                     */
        pwgNUM_DEF* xImageShift;                      /* Finished-Page            Image shift: x-axis       */
        pwgNUM_DEF* xSide1ImageShift;                 /* Finished-Page front side Image shift: x-axis       */
        pwgNUM_DEF* xSide2ImageShift;                 /* Finished-Page back  side Image shift: x-axis       */
    pwgNUM_RNG_DEF* yImagePosition;                   /* Finished-Page Image Y position                     */
        pwgNUM_DEF* yImageShift;                      /* Finished-Page            Image shift: y-axis       */
        pwgNUM_DEF* ySide1ImageShift;                 /* Finished-Page front side Image shift: y-axis       */
        pwgNUM_DEF* ySide2ImageShift;                 /* Finished-Page back  side Image shift: y-axis       */

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
     pwgSTRUCT_DEF* coverFrontDef;                    /* The front cover to apply to this Document.         */
    pwgNUM_RNG_DEF* feedOrientationDef;               /* Media edge fed into print engine from tray         */
    pwgNUM_RNG_DEF* finishingDef;                     /* Finishings for each copy of Output Document        */
    pwgNUM_RNG_DEF* mediaDescTypeDef;                 /* Type of media description used                     */
     pwgSTRUCT_DEF* mediaCollectionDef;               /* Actual media description information               */
    pwgNUM_RNG_DEF* pageDelivery;                     /* Pages delivered to output bin                      */
     pwgSTRUCT_DEF* separatorSheets;                  /* Separator sheets printed with Document             */
#endif

#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
    pwgNUM_RNG_DEF* presDirNumUpDef;                  /* Layout ordering for Number Up                      */
     pwgSTRUCT_DEF* coverBackDef;                     /* The back cover to apply this Document.             */
     pwgSTRUCT_DEF* finishingsCol;                    /* Fine granularity specification of finishings       */
        pwgARY_DEF* forceFrontSide;                   /* Input-Pages imaged on front side of sheet          */
    pwgNUM_RNG_DEF* impositionTemplate;               /* Method for laying out finished page images         */
     pwgSTRUCT_DEF* insertSheet;                      /* How Insert Sheets are to be inserted               */
    pwgNUM_RNG_DEF* mediaInputTrayCheck;              /* Media in identified tray must match "media"        */
       pwgINFO_DEF* outputDevice;                     /* Device where Job/Document will be printed.         */
     pwgSTRUCT_DEF* pdlInitFiles;                     /* Controls init of  PDL interpreter.                 */
#endif

                    VND_PRT_DOC_PROC_DEF_STRUCT

           pwgVOID* last;
} pwgPrintDocProcDefLst;


/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern pwgPrintDocProcDefLst pwgPrtDocPrcDefElem;
extern pwgSTRUCT_DEF         pwgDef_PrintDocumentProcessing;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_0_PRINT_DOCUMENT_PROCESSING_H__                                                    */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================== pwg.pjt.pdp.0.print.document.processing.h =============================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
