/* ================================= pwg.pjt.pdp.1.x.y.image.shift.h ====================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_1_X_Y_IMAGE_SHIFT_H__
#define __PWG_PJT_PDP_1_X_Y_IMAGE_SHIFT_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* X        Image Shift                                                                                     */
/* X Side 1 Image Shift                                                                                     */
/* X Side 2 Image Shift                                                                                     */
/*                                                                                                          */
/* Y        Image Shift                                                                                     */
/* Y Side 1 Image Shift                                                                                     */
/* Y Side 2 Image Shift                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 60] XImageShift                    */
/* -----------------                                                                                        */
/* Causes the Finished-Page Image to be shifted in position with respect to the x-axis of the media in      */
/* hundredths of a millimeter.                                                                              */
/* [PWG5100.3] §3.19.3                                                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 60] XSide1ImageShift               */
/* -----------------                                                                                        */
/* Causes each Finished-Page Image that would be placed on the front side of a sheet to be shifted in       */
/* position with respect to the x-axis of the media in hundredths of a millimeter.  The value's sign        */
/* indicates the direction of the shift.                                                                    */
/* [PWG5100.3] §3.19.4                                                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 60] XSide2ImageShift               */
/* -----------------                                                                                        */
/* Causes each Finished-Page Image that would be placed on the backside of a sheet to be shifted in         */
/* position with respect to the x-axis of the media in hundredths of a millimeter.  The value's sign        */
/* indicates the direction of the shift.                                                                    */
/* [PWG5100.3] §3.19.5                                                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 61] YImageShift                    */
/* -----------------                                                                                        */
/* Causes the Finished-Page Image to be shifted in position with respect to the y-axis of the media in      */
/* hundredths of a millimeter.                                                                              */
/* [PWG5100.3] §3.19.7                                                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 61] YSide1ImageShift               */
/* -----------------                                                                                        */
/* Causes each Finished-Page Image that would be placed on the front side of a sheet to be shifted in       */
/* position with respect to the y-axis of the media in hundredths of a millimeter.                          */
/* [PWG5100.3] §3.19.8                                                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 61] YSide2ImageShift               */
/* -----------------                                                                                        */
/* Causes each Finished-Page Image that would be placed on the backside of a sheet to be shifted in         */
/* position with respect to the y-axis of the media in hundredths of a millimeter.  The value's sign        */
/* indicates the direction of the shift.                                                                    */
/* [PWG5100.3] §3.19.9                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
    /*                                                                                                      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: Found more info on in Section 3.19 and 3.19.1 page 56 to 58 of PWG 5100.3.                */
    /*                                                                                                      */
    /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                       */
    /*                              Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
    /*      §3.19 and §3.19.1 [page 56-58] Image Shifting Attributes                                        */
    /* -----------------                                                                                    */
    /* 3.19 Image Shifting Attributes                                                                       */
    /* The attributes defined in this sub-section shift the Finished-Page Images as specified in the        */
    /* attribute definition, i.e., shift the pages that the end user sees in the Finished Document.         */
    /* Typical use cases for  shifting of Finished-Page Images are (1) to compensate for an application or  */
    /* scanning in some consistent direction for each Finished-Page Image and (2) to shift the              */
    /* Finished-Page Images toward or away from a binding edge.                                             */
    /*                                                                                                      */
    /* 3.19.1 Common Semantics for Image Shifting Attributes                                                */
    /*                                                                                                      */
    /* Note: To help understanding, the definitions of the Image Shifting Attributes are specified without  */
    /*       the complication of Imposition attributes, such as "imposition-template" (see section 3.4).    */
    /*       In order to take into account the interaction of the Image Shifting attributes with Imposition */
    /*       attributes, the reader should change the word media to Finished-Page-Image Cell in the         */
    /*       definitions in this section.  See section 2.3 for detailed definitions of Finished-Page-Image  */
    /*       Cell and Imposition.  The coordinate system for the Image Shifting attributes is relative to   */
    /*       the Finished-Page-Image Cell.  See section 2.4 for details of the coordinate system.           */
    /*                                                                                                      */
    /* The Printer determines the value for each attribute in this section as follows:                      */
    /*      a) if the client supplies a value and the Printer supports the attribute, the Printer uses that */
    /*         value,                                                                                       */
    /*      b) otherwise, if the corresponding "xxx-default" attribute is configured, the Printer uses that */
    /*         value,                                                                                       */
    /*      c) otherwise, the Printer uses the value of 0 for each integer valued attribute and 'none' for  */
    /*         each keyword-valued attribute. These values cause the Printer to position the image as it    */
    /*         normally would without these attributes.                                                     */
    /*                                                                                                      */
    /* To implement these attributes, the Printer first positions the Finished-Page Image using the values  */
    /* it obtains for the "x-image-position" and "y-image-position" attributes. Then it shifts the          */
    /* Finished-Page Image by the amount it obtains for the "x-image-shift" and "y-image-shift" attributes. */
    /* Finally, for a Finished-Page Image that would be placed on the front side of a sheet in the Finished */
    /* Document, it shifts the Finished-Page Image by the amount it obtains for the "x-side1-image-shift"   */
    /* and "y-side1-image-shift".  For a Finished-Page Image that would be placed on the back side of a     */
    /* sheet in the Finished Document, it shifts the Finished-Page Image by the amount it obtains for the   */
    /* "x-side2-image-shift" and "y-side2-image-shift" attributes.                                          */
    /*                                                                                                      */
    /* 3.19.1.1 Side1 and Side2                                                                             */
    /* For the "*-image-shift" attributes, the terms "side1" and "side2" describe those Finished-Page       */
    /* Images that would be on the front side or back side of a sheet in the Finished Document,             */
    /* respectively.  If the document is to be printed one-sided, all Finished-Page Images will be "side1"  */
    /* pages.   If the document is to be printed two-sided with one Finished-Page Image on each side of the */
    /* sheet of paper, this would result in odd Finished-Page Images printed on side1 (or right side in a   */
    /* book format) and even Finished-Page Images printed on side2 (or left side in a book format), with an */
    /* exception noted below.                                                                               */
    /*                                                                                                      */
    /* 3.19.1.2 Interaction between the Image Shifting and "number-up" and Imposition attributes            */
    /* Usually a print job will not combine the "number-up", image shifting, and Imposition attributes      */
    /* (such as the "imposition-template" attributes - see section 3.4), in a single document.  However,    */
    /* this section defines the interaction in case a client does supply more than one of these attributes. */
    /*                                                                                                      */
    /* The Printer MUST apply "number-up", image shifting, and Imposition attributes in the following       */
    /* order:                                                                                               */
    /*                                                                                                      */
    /*    (1) Create a Finished-Page Image by laying out the number of page images specified by the         */
    /*        "number-up" attribute (see [RFC2911] sections 4.2.9 and 15.3). If "number-up" is unsupported  */
    /*        or not applied, the Finished-Page Image is the same as the single page image.                 */
    /*                                                                                                      */
    /*    (2) shift the Finished-Page Image as specified by the image shifting attributes. If the           */
    /*        image-shifting attributes are unsupported or not applied, the Finished-Page Image is not      */
    /*        shifted.                                                                                      */
    /*                                                                                                      */
    /*    (3) layout the Finished-Pages Images onto the surfaces (i.e. sides) of a number of (larger)       */
    /*        sheets according to the Imposition attributes, such as the "imposition-template" attribute    */
    /*        (see section 3.4). If Imposition attributes are unsupported or not applied, an Impression is  */
    /*        a single Finished-Page Image and the "sides" attribute specifies whether one or both sides of */
    /*        the sheet are imaged.  See section 3.4.1 for the interaction of the "imposition-template"     */
    /*        attribute and the "sides" attribute.                                                          */
    /*                                                                                                      */
    /* Note: As with all Image Shifting attributes, if an Imposition attribute, such as                     */
    /*       "imposition-template" (see section 3.4) is also supplied, the word "media" in these Image      */
    /*       Shifting definitions should be interpreted to mean the Finished-Page-Image Cell (see           */
    /*       section 3.19.1.2).                                                                             */
    /*                                                                                                      */
    /* 3.19.1.3 Interaction between the Image Shifting and "force-front-side" attributes                    */
    /* If the "force-front-side" attribute (see section 3.3) is used, "side1" and "side2" apply to the      */
    /* Finished-Page images AFTER the "force-front-side" values are applied.  For example, a typical        */
    /* document without "number-up" starts with page 1 as a "side1" page and page 2 as a "side2" page.      */
    /* If "force-front-side" attribute is applied to Input Page 2, then Input Page 2 (and subsequent even   */
    /* pages) will become "side1" pages.  Input Page 3 (and subsequent odd pages) will become "side2" pages.*/
    /*                                                                                                      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /*                                                                                                      */
    /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                       */
    /*                              Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
    /*      §3.19.3 [page    60] x-image-shift (integer(MIN:MAX))                                           */
    /*      §3.19.4 [page 60-61] x-side1-image-shift (integer(MIN:MAX))                                     */
    /*      §3.19.5 [page    61] x-side2-image-shift (integer(MIN:MAX))                                     */
    /*      §3.19.7 [page    61] y-image-shift (integer(MIN:MAX))                                           */
    /*      §3.19.8 [page    61] y-side1-image-shift (integer(MIN:MAX))                                     */
    /*      §3.19.9 [page 61-62] y-side2-image-shift (integer(MIN:MAX))                                     */
    /* -----------------                                                                                    */
    /* 3.19.3 x-image-shift (integer(MIN:MAX))                                                              */
    /* This attribute causes the Finished-Page Image (whether it will be on the front side or back side of  */
    /* a sheet of the Finished Document)  to be shifted in position with respect to the media on which the  */
    /* Finished-Page Image is to be rendered.  The direction of shift MUST be along the x-axis of the       */
    /* Coordinate System (see section 2.4) with respect to the medium. The sign of the value indicates the  */
    /* direction of the shift.                                                                              */
    /*                                                                                                      */
    /* The unit of measure for this attribute is hundredths of a millimeter.  This is equivalent to         */
    /* 1/2540th of an inch resolution.                                                                      */
    /*                                                                                                      */
    /* As with all Image Shifting attributes, if an Imposition attribute (such as "imposition-template" -   */
    /* see section 3.4) is also supplied, the word media in this definition should be interpreted as        */
    /* Finished-Page-Image Cell (see section 3.19.1.2).                                                     */
    /*                                                                                                      */
    /* 3.19.4 x-side1-image-shift (integer(MIN:MAX))                                                        */
    /* This attribute causes each Finished-Page Image that would be placed on the front side of a sheet of  */
    /* the Finished Document to be shifted in position with respect to the media on which the Finished-Page */
    /* Image is to be rendered.  The direction MUST be along the x-axis of the Coordinate System (see       */
    /* section 2.4) with respect to the medium. The sign of the value indicates the direction of the shift. */
    /*                                                                                                      */
    /* If the bind edge is along the y-axis, then a bind edge image shift can be accomplished by applying   */
    /* shifts of equal magnitude, and opposite sign, to the "x-side1-image-shift" and "x-side2-image-shift" */
    /* attributes, respectively (assuming that the "sides" attribute is 'two-sided-long-edge' or imposition */
    /* has equivalent behavior).                                                                            */
    /*                                                                                                      */
    /* The unit of measure for this attribute is hundredths of a millimeter.  This is equivalent to         */
    /* 1/2540th of an inch resolution.                                                                      */
    /*                                                                                                      */
    /* As with all Image Shifting attributes, if an Imposition attribute (such as "imposition-template" -   */
    /* see section 3.4) is also supplied, the word media in this definition should be interpreted as        */
    /* Finished-Page-Image Cell (see section 3.19.1.2).                                                     */
    /*                                                                                                      */
    /* 3.19.5 x-side2-image-shift (integer(MIN:MAX))                                                        */
    /* This attribute causes a Finished-Page Image that would be placed on the back side of a sheet of the  */
    /* Finished Document to be shifted in position with respect to the media on which the Finished-Page     */
    /* Image is to be rendered.  The direction of shift MUST be along the x-axis of the Coordinate System   */
    /* (see section 2.4) with respect to the medium. The sign of the value indicates the direction of the   */
    /* shift.                                                                                               */
    /*                                                                                                      */
    /* If the bind edge is along the y-axis, then a bind edge image shift can be accomplished by applying   */
    /* shifts of equal magnitude, and opposite sign, to the "x-side1-image-shift" and "x-side2-image-shift" */
    /* attributes, respectively (assuming that the "sides" attribute is 'two-sided-long-edge' or imposition */
    /* has equivalent behavior).                                                                            */
    /*                                                                                                      */
    /* The unit of measure for this attribute is hundredths of a millimeter.  This is equivalent to         */
    /* 1/2540th of an inch resolution.                                                                      */
    /*                                                                                                      */
    /* As with all Image Shifting attributes, if an Imposition attribute (such as "imposition-template" -   */
    /* see section 3.4) is also supplied, the word media in this definition should be interpreted as        */
    /* Finished-Page-Image Cell (see section 3.19.1.2).                                                     */
    /*                                                                                                      */
    /* 3.19.7 y-image-shift (integer(MIN:MAX))                                                              */
    /* This attribute causes the Finished-Page Image (whether it will be on the front side or back side of  */
    /* a sheet of the Finished Document) to be shifted in position with respect to the media on which the   */
    /* Finished-Page Image is to be rendered.  The direction of shift MUST be along the y-axis of the       */
    /* Coordinate System (see section 2.4) with respect to the medium. The sign of the value indicates the  */
    /* direction of the shift.                                                                              */
    /*                                                                                                      */
    /* The unit of measure for this attribute is hundredths of a millimeter.  This is equivalent to         */
    /* 1/2540th of an inch resolution.                                                                      */
    /*                                                                                                      */
    /* As with all Image Shifting attributes, if an Imposition attribute (such as "imposition-template" -   */
    /* see section 3.4) is also supplied, the word media in this definition should be interpreted as        */
    /* Finished-Page-Image Cell (see section 3.19.1.2).                                                     */
    /*                                                                                                      */
    /* 3.19.8 y-side1-image-shift (integer(MIN:MAX))                                                        */
    /* This attribute causes each Finished-Page Image that would be placed on the front side of a sheet of  */
    /* the Finished Document to be shifted in position with respect to the media on which the Finished-Page */
    /* Image is to be rendered.  The direction of shift MUST be along the y-axis of the Coordinate System   */
    /* (see section 2.4) with respect to the medium. The sign of the value indicates the direction of the   */
    /* shift.                                                                                               */
    /*                                                                                                      */
    /* If the bind edge is along the x-axis, then a bind edge image shift can be accomplished by applying   */
    /* shifts of equal magnitude, and opposite sign, to the "y-side1-image-shift" and "y-side2-image-shift" */
    /* attributes, respectively (assuming that the "sides" attribute is 'two-sided-short-edge' or           */
    /* imposition has equivalent behavior).                                                                 */
    /*                                                                                                      */
    /* The unit of measure for this attribute is hundredths of a millimeter.  This is equivalent to         */
    /* 1/2540th of an inch resolution.                                                                      */
    /*                                                                                                      */
    /* As with all Image Shifting attributes, if an Imposition attribute (such as "imposition-template" -   */
    /* see section 3.4) is also supplied, the word media in this definition should be interpreted as        */
    /* Finished-Page-Image Cell (see section 3.19.1.2).                                                     */
    /*                                                                                                      */
    /* 3.19.9 y-side2-image-shift (integer(MIN:MAX))                                                        */
    /* This attribute causes each Finished-Page Image that would be placed on the back side of a sheet of   */
    /* the Finished Document to be shifted in position with respect to the media on which the Finished-Page */
    /* Image is to be rendered.  The direction of shift MUST be along the y-axis of the Coordinate System   */
    /* (see section 2.4) with respect to the medium. The sign of the value indicates the direction of the   */
    /* shift.                                                                                               */
    /*                                                                                                      */
    /* If the bind edge is along the x-axis, then bind edge image shift can be accomplished by applying     */
    /* shifts of equal magnitude, and opposite sign, to the "y-side1-image-shift" and "y-side2-image-shift" */
    /* attributes, respectively (assuming that the "sides" attribute is 'two-sided-short-edge' or           */
    /* imposition has equivalent behavior).                                                                 */
    /*                                                                                                      */
    /* The unit of measure for this attribute is hundredths of a millimeter.  This is equivalent to         */
    /* 1/2540th of an inch resolution.                                                                      */
    /*                                                                                                      */
    /* As with all Image Shifting attributes, if an Imposition attribute (such as "imposition-template" -   */
    /* see section 3.4) is also supplied, the word media in this definition should be interpreted as        */
    /* Finished-Page-Image Cell (see section 3.19.1.2).                                                     */
    /*                                                                                                      */
    /* ==================================================================================================== */
/* pwgINT32                 xImageShift;              /             Image shift with respect to x-axis      */
/* pwgINT32                 xSide1ImageShift;         /  Front side Image shift with respect to x-axis      */
/* pwgINT32                 xSide2ImageShift;         /  Back  side Image shift with respect to x-axis      */

extern  pwgNUM_DEF pwgDef_XImageShift;
extern  pwgNUM_DEF pwgDef_XSide1ImageShift;
extern  pwgNUM_DEF pwgDef_XSide2ImageShift;

/* pwgINT32                 yImageShift;              /             Image shift with respect to y-axis      */
/* pwgINT32                 ySide1ImageShift;         /  Front side Image shift with respect to y-axis      */
/* pwgINT32                 ySide2ImageShift;         /  Back  side Image shift with respect to y-axis      */

extern  pwgNUM_DEF pwgDef_YImageShift;
extern  pwgNUM_DEF pwgDef_YSide1ImageShift;
extern  pwgNUM_DEF pwgDef_YSide2ImageShift;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_1_X_Y_IMAGE_SHIFT_H__                                                              */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================= pwg.pjt.pdp.1.x.y.image.shift.h ====================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
