/* ================================ pwg.pjt.pdp.3.imposition.template.h =================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PDP_3_IMPOSITION_TEMPLATE_H__
#define __PWG_PJT_PDP_3_IMPOSITION_TEMPLATE_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Imposition Template                                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 47] ImpositionTemplate             */
/* -----------------                                                                                        */
/* Specifies imposition method for laying out finished page images onto the surface of output media.        */
/* [PWG5100.3] §3.4                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                       */
    /*                              Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
    /*          §3.4 [page 27] imposition-template (type3 keyword | name(MAX))                              */
    /* -----------------                                                                                    */
    /* This attribute identifies which imposition method the Printer MUST use to layout Finished-Page       */
    /* Images onto the surface of a series of one or more sheets (see section 2.3 for a more detailed       */
    /* definition of Imposition and examples).  The value of this attribute identifies the Imposition       */
    /* method to be used in an IMPLEMENTATION-DEFINED manner.  For example, the value (1) can identify a    */
    /* known algorithm implemented in software or (2) can be mapped to a file which contains the imposition */
    /* parameters or a script.                                                                              */
    /*                                                                                                      */
    /* Standard keyword values are:                                                                         */
    /*                                                                                                      */
    /*     'none'     No imposition template is applied.                                                    */
    /*  'signature'   The standard site signature template MUST be used.                                    */
    /*                                                                                                      */
    /* See section 2.3 for examples of different kinds of imposition.  See section 3.19.1.2 for the         */
    /* interaction of this attribute with the Image Shifting and "number-up" attributes.                    */
    /*                                                                                                      */
    /* 3.4.1	Interaction between the "imposition-template" and "sides" attributes                          */
    /* Whether or not the "sides" attribute (see [RFC2911] section 4.2.8) is overridden by this attribute   */
    /* DEPENDS ON IMPLEMENTATION, including the value supplied.                                             */
    /*                                                                                                      */
    /* 3.4.2	Interaction between the "imposition-template" and "number-up" attributes                      */
    /* See section 3.19.1.2 for the interaction between Imposition attributes and the "number-up" attribute */
    /* (see [RFC2911] section 4.2.9).                                                                       */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                          Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
        /*          §2.3 [page 11-14]   Number-up and Imposition                                            */
        /* -----------------                                                                                */
        /* The concepts of "number-up" (see RFC 2911 section ) and imposition are similar.  However, they   */
        /* have some important differences which are explained in this section.  The relevant terms from    */
        /* section 2.2 are presented again with more elaboration.                                           */
        /*                                                                                                  */
        /* Finished Page - One side of a sheet in a Finished Document, i.e., one side of a sheet as         */
        /*                 perceived by a person after any cutting, folding, and/or booklet making. The lay */
        /*                 term is 'page'.  See the right-most part of each of the figures in this section. */
        /*                                                                                                  */
        /* Finished-Page Image - The single image on a Finished Page, i.e. all the marks imaged on a        */
        /*                 Finished Page.                                                                   */
        /*                                                                                                  */
        /* Finished-Page-Image Cell - The region on the surface (i.e. side) of a sheet where the            */
        /*                 Finished-Page Image is placed.  When imposition is not applied, the              */
        /*                 Finished-Page-Image Cell coincides with the entire surface of one side of the    */
        /*                 sheet. When imposition is applied, a) the sheet is partitioned into multiple     */
        /*                 non-overlapping Finished-Page-Image Cells, typically in a rectangular grid, and  */
        /*                 b) the area near the edges of the sheet may not belong to any                    */
        /*                 Finished-Page-Image Cell.                                                        */
        /*                                                                                                  */
        /* Number Up -     The process of laying out multiple Input-Page images to produce a Finished-Page  */
        /*                 Image (see RFC 2911 "number-up" Job Template attribute).  Such page images are   */
        /*                 typically reduced in size, rotated, and placed in reading order in a             */
        /*                 Finished-Page Image.  People use a Number Up process to save paper or have a     */
        /*                 thinner document (see Figure 1).  When “number-up” is not applied, a              */
        /*                 Finished-Page Image is the same as a single page image (see Figure 2, Figure 3,  */
        /*                 Figure 4, and Figure 5).  This concept of Number Up is common in office printing,*/
        /*                 but not in production printing.                                                  */
        /* Impression -    The single image on one side of a sheet, i.e. all the marks that are imaged on   */
        /*                 one side of a sheet.  See the middle part of each of the figures in this section.*/
        /*                 When the printing process does not include Imposition, an Impression is the same */
        /*                 as a Finished-Page Image (see Figure 1). When the printing process includes      */
        /*                 Imposition, an Impression contains multiple Finished-Page images (see Figure 2,  */
        /*                 Figure 3, Figure 4, and Figure 5).                                               */
        /*                                                                                                  */
        /* Imposition -    The process of laying out multiple Finished-Page Images on the sides of one or   */
        /*                 more sheets (see "imposition-template" in section 3.4).  Imposition MAY also     */
        /*                 include, but is not limited to, rotation, scaling, shifting, cropping,           */
        /*                 replicating page images, and re-ordering Finished-Page Images to create output   */
        /*                 Impressions properly formatted for a specific finishing operation to make, say,  */
        /*                 a pamphlet or booklet.  The sheets are typically larger than the Finished-Page   */
        /*                 Images, so that the Finished-Page Images are not reduced in size.  However, some */
        /*                 impositions scale the Finished-Page Images, up or down.  The sheets are folded   */
        /*                 and possibly cut in order to produce a series of Finished Pages.  The concept of */
        /*                 Imposition was originated by the printing industry.  Examples of imposition      */
        /*                 include:                                                                         */
        /*                                                                                                  */
        /*          Signaturization lays out Finished-Page Images onto the surface of a series of sheets so */
        /*                 that when the sheets are folded (and possibly cut) they form a "signature".      */
        /*                 Books and booklets consist of one or more signatures bound together. There is    */
        /*                 exactly one Finished-Page Image per sheet surface (i.e., side) in the Finished   */
        /*                 Document. Typically there is one page image per Finished-Page Image.  If Number  */
        /*                 Up is also specified with a value greater than 1, there is more than one page    */
        /*                 image per Finished-Page Image.                                                   */
        /*                                                                                                  */
        /*          Z-fold lays out three portrait Finished-Page Images on each side of a sheet for a       */
        /*                 so-called z-fold brochure, with a concave and a convex fold between the page     */
        /*                 images.                                                                          */
        /*                                                                                                  */
        /*          Same-up lays out multiple copies of the same Finished-Page Image on the same side of a  */
        /*                 larger sheet for printing productivity, with the larger sheet then being cut     */
        /*                 into the target size.  This is a standard concept in production press printing.  */
        /*                                                                                                  */
        /* See section 3.19.1.2 for the interaction between "number-up" and Imposition attributes.          */
        /*                                                                                                  */
        /* 2.3.1	Figures Illustrating "number-up" and Imposition                                           */
        /* Typical number-up is shown in Figure 1 (with scaling) compared with typical Impositions shown    */
        /* in Figure 2, Figure 3, Figure 4, and Figure 5 (without scaling).  The first Impression (the      */
        /* first side of the first sheet) and the first Finished Page (the first page that a human would    */
        /* read) are shown for each figure.                                                                 */
        /*                                                                                                  */
        /* Figure 1 - number-up = 2                                                                         */
        /*                                                                                                  */
        /*              Input Pages                     1st Impression           1s Finished Page           */
        /*        |-------|   |-------|                 |-------------------|      |-------|-------|        */
        /*        |       |   |       |                 |                   |      |       |       |        */
        /*        |   ^   |   |   ^   |                 |      << 2 <<      |      |   ^   |   ^   |        */
        /*        |   ^   |   |   ^   |                 |                   |      |   ^   |   ^   |        */
        /*        |   1   |   |   2   |                 |-------------------|      |   1   |   2   |        */
        /*        |   ^   |   |   ^   |                 |                   |      |   ^   |   ^   |        */
        /*        |   ^   |   |   ^   |                 |      << 1 <<      |      |   ^   |   ^   |        */
        /*        |       |   |       |                 |                   |      |       |       |        */
        /*        |-------|   |-------|                 |-------------------|      |-------|-------|        */
        /*                                                                                                  */
        /* Figure 1 shows number-up with a value of 2 so that the Input-Page images, say, iso-a4, are being */
        /* scaled down to fit onto the same size media (iso-a4).  Note that consecutive Input-Page images   */
        /* are placed next to each other on an Impression.                                                  */
        /*                                                                                                  */
        /* Figure 2 - Imposition: 8-page, two-sheet signature                                               */
        /*                                                                                                  */
        /*              Input Pages                     1st Impression           1st Finished Page          */
        /*        |-------|   |-------|                 |-------|-------|           |-------|               */
        /*        |       |   |       |                 |       |       |           |       |               */
        /*        |   ^   |   |   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |   ^   |...|   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |   1   |...|   8   |                 |   8   |   1   |           |   1   |               */
        /*        |   ^   |...|   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |   ^   |   |   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |       |   |       |                 |       |       |           |       |               */
        /*        |-------|   |-------|                 |-------|-------|           |-------|               */
        /*                                                                                                  */
        /* Figure 2 shows a signature imposition that takes 8 Input-Page images and places them on both     */
        /* sides of two larger sheets without scaling.  Two Input-Page images, say iso-a4, appear side by   */
        /* side on each Impression on the twice as large medium (iso-a3).  Note, that unlike number-up,     */
        /* consecutive Input-Page images are not placed next to each other on an Impression.                */
        /*                                                                                                  */
        /* Figure 3 - Imposition: 8-page, one-sheet signature                                               */
        /*                                                                                                  */
        /*              Input Pages                     1st Impression           1st Finished Page          */
        /*        |-------|   |-------|                 |-------|-------|           |-------|               */
        /*        |       |   |       |                 |       |       |           |       |               */
        /*        |   ^   |   |   ^   |                 |   v   |   v   |           |   ^   |               */
        /*        |   ^   |...|   ^   |                 |   v   |   v   |           |   ^   |               */
        /*        |   1   |...|   8   |                 |   5   |   4   |           |   1   |               */
        /*        |   ^   |...|   ^   |                 |   v   |   v   |           |   ^   |               */
        /*        |   ^   |   |   ^   |                 |   v   |   v   |           |   ^   |               */
        /*        |       |   |       |                 |       |       |           |       |               */
        /*        |-------|   |-------|                 |-------|-------|           |-------|               */
        /*                                              |       |       |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |   8   |   1   |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |       |       |                                   */
        /*                                              |-------|-------|                                   */
        /*                                                                                                  */
        /* Figure 3 shows a signature imposition that takes 8 Input-Page images and places them on both     */
        /* sides of one larger sheet without scaling.  Four Input-Page images, say iso-a4, appear side by   */
        /* side on each Impression on the four-times as large medium (iso-a2).  Note, that unlike number-up,*/
        /* consecutive Input-Page images are not placed next to each other on an Impression.                */
        /*                                                                                                  */
        /* Figure 4 - Imposition: z-fold                                                                    */
        /*                                                                                                  */
        /*              Input Pages                     1st Impression           1st Finished Page          */
        /*        |-------|   |-------|            |-------|-------|-------|           |-------|            */
        /*        |       |   |       |            |       |       |       |           |       |            */
        /*        |   ^   |   |   ^   |            |   ^   |   ^   |   ^   |           |   ^   |            */
        /*        |   ^   |...|   ^   |            |   ^   |   ^   |   ^   |           |   ^   |            */
        /*        |   1   |...|   3   |            |   1   |   2   |   3   |           |   1   |            */
        /*        |   ^   |...|   ^   |            |   ^   |   ^   |   ^   |           |   ^   |            */
        /*        |   ^   |   |   ^   |            |   ^   |   ^   |   ^   |           |   ^   |            */
        /*        |       |   |       |            |       |       |       |           |       |            */
        /*        |-------|   |-------|            |-------|-------|-------|           |-------|            */
        /*                                                                                                  */
        /* Figure 4 shows a z-fold imposition that takes 3 Input-Page images and places them on both sides  */
        /* of one larger sheet without scaling.  Three Input-Page images are placed next to each other on   */
        /* an Impression.                                                                                   */
        /*                                                                                                  */
        /* Figure 5 - Imposition: same-up = 4                                                               */
        /*                                                                                                  */
        /*              Input Pages                     1st Impression           1st Finished Page          */
        /*        |-------|   |-------|                 |-------|-------|           |-------|               */
        /*        |       |   |       |                 |       |       |           |       |               */
        /*        |   ^   |   |   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |   ^   |...|   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |   1   |...|   4   |                 |   1   |   1   |           |   1   |               */
        /*        |   ^   |...|   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |   ^   |   |   ^   |                 |   ^   |   ^   |           |   ^   |               */
        /*        |       |   |       |                 |       |       |           |       |               */
        /*        |-------|   |-------|                 |-------|-------|           |-------|               */
        /*                                              |       |       |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |   1   |   1   |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |   ^   |   ^   |                                   */
        /*                                              |       |       |                                   */
        /*                                              |-------|-------|                                   */
        /*                                                                                                  */
        /* Figure 5 shows a same-up imposition that takes 4 copies of pairs of Input-Page images (actually  */
        /* Finished Page images), say iso-a4 size, and replicates them on both sizes of an iso-a2           */
        /* impressions.  Then the sheet is cut into four separate sheets of iso-a4 size.                    */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                      Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
            /*          §3.19.1.2 [page 57-58]  3.19.1.2	Interaction between the Image Shifting and        */
            /*                                            "number-up" and Imposition attributes             */
            /* -----------------                                                                            */
            /* Usually a print job will not combine the "number-up", image shifting, and Imposition         */
            /* attributes (such as the "imposition-template" attributes - see section 3.4), in a single     */
            /* document.  However, this section defines the interaction in case a client does supply more   */
            /* than one of these attributes.                                                                */
            /*                                                                                              */
            /* The Printer MUST apply "number-up", image shifting, and Imposition attributes in the         */
            /* following order:                                                                             */
            /*                                                                                              */
            /*    (1) Create a Finished-Page Image by laying out the number of page images specified by the */
            /*        "number-up" attribute (see [RFC2911] sections 4.2.9 and 15.3). If "number-up" is      */
            /*        unsupported or not applied, the Finished-Page Image is the same as the single page    */
            /*        image.                                                                                */
            /*                                                                                              */
            /*    (2) shift the Finished-Page Image as specified by the image shifting attributes. If the   */
            /*        image-shifting attributes are unsupported or not applied, the Finished-Page Image is  */
            /*        not shifted.                                                                          */
            /*                                                                                              */
            /*    (3) layout the Finished-Pages Images onto the surfaces (i.e. sides) of a number of        */
            /*        (larger) sheets according to the Imposition attributes, such as the                   */
            /*        "imposition-template" attribute (see section 3.4). If Imposition attributes are       */
            /*        unsupported or not applied, an Impression is a single Finished-Page Image and the     */
            /*        "sides" attribute specifies whether one or both sides of the sheet are imaged.  See   */
            /*        section 3.4.1 for the interaction of the "imposition-template" attribute and the      */
            /*        "sides" attribute.                                                                    */
            /*                                                                                              */
            /* Note: As with all Image Shifting attributes, if an Imposition attribute, such as             */
            /*       "imposition-template" (see section 3.4) is also supplied, the word "media" in these    */
            /*       Image Shifting definitions should be interpreted to mean the Finished-Page-Image Cell  */
            /*       (see section 3.19.1.2).                                                                */
            /*                                                                                              */
            /* ============================================================================================ */
typedef enum {
    PWG_IMPOSITION_TEMPLATE_RESERVED_0 = 0,
    PWG_IMPOSITION_TEMPLATE_RESERVED_1 = 1,
    PWG_IMPOSITION_TEMPLATE_UNKNOWN    = 2,

    PWG_IMPOSITION_TEMPLATE_NONE,
    PWG_IMPOSITION_TEMPLATE_SIGNATURE,        /* Book Signature */
    PWG_IMPOSITION_TEMPLATE_Z_FOLD,
    PWG_IMPOSITION_TEMPLATE_SAME_UP,

    VND_IMPS_TMPL_ENUM

    PWG_IMPOSITION_TEMPLATE_END
} pwgImpositionTemplateEnum;

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgCHAR* pwgImpositionTemplate_Keywords[];
extern         pwgCHAR* pwgImpositionTemplate_KWValues[];
extern         pwgBIT8  pwgImpositionTemplate_KWVLevel[];
extern         pwgBOOL  pwgImpositionTemplate_KWVSupported[];
extern pwgNUM_RNG_DEF   pwgDef_ImpositionTemplate;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PDP_3_IMPOSITION_TEMPLATE_H__                                                          */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pdp.3.imposition.template.h =================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
