/* ========================== pwg.pjt.pjd.2.document.format.details.supplied.h ============================ */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJD_2_DOCUMENT_FORMAT_DETAILS_SUPPLIED_H__
#define __PWG_PJT_PJD_2_DOCUMENT_FORMAT_DETAILS_SUPPLIED_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pjd.1.document.format[.supplied].h"
#include "pwg.pjt.pjd.1.document.format.version[.supplied].h"
#include "pwg.pjt.pjd.1.elements[.document].natural.language.h"
#include "pwg.pjt.pjd.2.document.format.device.id.h"
#include "pwg.pjt.pjd.2.document.source.application.name.h"
#include "pwg.pjt.pjd.2.document.source.application.version.h"
#include "pwg.pjt.pjd.2.document.source.os.name.h"
#include "pwg.pjt.pjd.2.document.source.os.version.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Document Format Details Supplied                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*   §6.2.1 [page 25-26] DocumentFormatDetailsSupplied Element                                              */
/* -----------------                                                                                        */
/* The DocumentFormatDetails datatype allows  greater details about the document format than is possible    */
/* with the  DocumentFormatSupplied and DocumentFormatVersionSupplied elements.  Figure 15 shows the        */
/* DocumentFormatDetails constituent elements. The values of any of the elements supplied must conform to   */
/* section 3.2.5 of [PWG5100.7]. Implementations that support  DocumentFormatDetails SHOULD support         */
/* DocumentFormatDeviceId.                                                                                  */
/*                                                                                                          */
/*    +~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+      */
/*                                                                                                          */
/*   +-------------------------------+     +------------+                                                   */
/*   | DocumentFormatDetailsSupplied |--+--| attributes |                                                   */
/*   +-------------------------------+  |  +------------+                                                   */
/*                                      |                                                                   */
/*                                      |  /---------\      +----------------+                              */
/*                                      +--| -o-o-o- |--+---| DocumentFormat |                              */
/*                                         \---------/  |   K----------------+                              */
/*                                                      |                                                   */
/*                                                      |   +-----------------------+                       */
/*                                                      +---| DocumentFormatVersion |                       */
/*                                                      !   S-----------------------+                       */
/*                                                      !                                                   */
/*                                                      !   + - - - - - - - - - - - - +                     */
/*                                                      + - ! DocumentFormatDeviceId  !                     */
/*                                                      !   S - - - - - - - - - - - - +                     */
/*                                                      !                                                   */
/*                                                      !   + - - - - - - - - - - - - +                     */
/*                                                      + - ! DocumentNaturalLanguage !                     */
/*                                                      !   K - - - - - - - - - - - - +                     */
/*                                                      !                                                   */
/*                                                      !   + - - - - - - - - - - - - - - - +               */
/*                                                      + - ! DocumentSourceApplicationName !               */
/*                                                      !   S - - - - - - - - - - - - - - - +               */
/*                                                      !                                                   */
/*                                                      !   + - - - - - - - - - - - - - - - - - +           */
/*                                                      + - ! DocumentSourceApplicationVersion  !           */
/*                                                      !   S - - - - - - - - - - - - - - - - - +           */
/*                                                      !                                                   */
/*                                                      !   + - - - - - - - - - - - +                       */
/*                                                      + - ! DocumentSourceOsName  !                       */
/*                                                      !   K - - - - - - - - - - - +                       */
/*                                                      !                                                   */
/*                                                      !   + - - - - - - - - - - - - +                     */
/*                                                      + - ! DocumentSourceOsVersion !                     */
/*                                                      !   S - - - - - - - - - - - - +                     */
/*                                                      !                                                   */
/*                                                      !   / - - - - - - - - - - - -\                      */
/*                                                      + - | any ##other             |                     */
/*                                                          \ - - - - - - - - - - - -/                      */
/*                                                                          0..infinite                     */
/*                                                                                                          */
/*                           Figure 15 DocumentFormatDetailsSupplied Datatype                               */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*   §Appendix A: PrintJobTicket Elements' Semantic Information [page 44] DocumentFormatDetailsSupplied     */
/* -----------------                                                                                        */
/* Summarizes the default distinct contained document formats.                                              */
/*    (Contains: DocumentSourceApplicationName, DocumentSourceApplicationVersion, DocumentSourceOsName,     */
/*               DocumentSourceOsVersion, DocumentFormat, DocumentFormatDeviceId, DocumentFormatVersion,    */
/*               DocumentNaturalLanguage)                                                                   */
/* [PWG5100.7] §5.2.4                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                     */
    /*                                   Standard for The Internet Printing Protocol (IPP): Job Extensions  */
    /*          §5.2.4 [page 28] document-format-details-supplied (1setOf collection)                       */
    /* -----------------                                                                                    */
    /* This OPTIONAL Job Description attribute specifies the default details of the document format(s) of   */
    /* the Document Object content.  The Printer sets this Job Description attribute from the corresponding */
    /* "document-format-details" Operation attribute (see section 3.2.5 for the semantics), if supplied by  */
    /* the client in the Job Creation operation.  If a Printer supports the "document-format-details"       */
    /* Operation attribute, the Printer MUST support this "document-format-details" Job Description         */
    /* attribute.                                                                                           */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                 */
        /*                               Standard for The Internet Printing Protocol (IPP): Job Extensions  */
        /*                                                                                  Job Extensions  */
        /*          §3.2.5 [page 16-18] document-format-details (1setOf collection)                         */
        /* -----------------                                                                                */
        /* This OPTIONAL Operation attribute supplied in Document Creation operations summarizes the        */
        /* details of the Document content, including any files contained in the Document.  This Operation  */
        /* attribute is intended to be supported by Printers that support a packaging document format, such */
        /* as 'application/zip' or 'multipart/related', in order to detail the contents.  However, this     */
        /* Operation attribute MAY be used with any document format.  See Table 6 for a list of the member  */
        /* attributes along with the client and Printer conformance requirements.                           */
        /*                                                                                                  */
        /* All member attributes, if supplied, MUST have contents.  The value MUST NOT be omitted.          */
        /*                                                                                                  */
        /* If a Printer supports a packaging MIME type, such as 'multipart/related' or 'application/zip',   */
        /* the Printer MUST support this "document-format-details" Operation attribute.  If a Printer does  */
        /* not support a packaging MIME type, it MAY omit support of the "document-format-details"          */
        /* Operation attribute and Description attribute.  The purpose of the "document-format-details"     */
        /* Operation attribute is to describe the details of the document format or formats in the supplied */
        /* Document, including the packaging format itself, so that the Printer knows what to expect.       */
        /*                                                                                                  */
        /* If a client supplies the "document-format-details" Operation attribute in a Document Creation    */
        /* request with member attributes and/or values that the Printer doesn't support, the Printer MUST  */
        /* perform one of the following actions depending on implementation:                                */
        /*                                                                                                  */
        /*    (1) reject the request OR                                                                     */
        /*    (2) accept the request and either                                                             */
        /*        (a) put the Job in the 'pending-held' state or                                            */
        /*        (b) process the job ignoring the attribute.                                               */
        /*                                                                                                  */
        /* See section 3 above for more details.  However, if the  "document-charset" or the                */
        /* "document-format" member attributes are the ones in question, the Printer MUST reject the        */
        /* request, same as for the "document-charset" and "document-format" Operation attributes (see      */
        /* sections 3.2.2 and 3.2.4) and return the 'client-error-charset-not-supported'  (see [rfc2911]    */
        /* section 13.1.4.16) or the  'client-error-document-format-not-supported' (see [rfc2911]           */
        /* section 13.1.4.11) status-codes, respectively.                                                   */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: See separate header files for "document-charset" & "document-format" & return values      */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
        /*                                                                                                  */
        /* For a packaging format, the "document-format-details" attribute does not provide means to        */
        /* associate each collection value with particular document in the archive file, so it does not     */
        /* provide a "manifest" [^8] of the packaging.  One of the packaging collection values MAY describe */
        /* the packaging format itself, in which case that collection value MUST be the first collection    */
        /* value.  The remaining collection values provide the summary of the details of the contained      */
        /* files in any order.                                                                              */
        /*                                                                                                  */
        /* [^8: If the client wants to achieve a “manifest”, that is a complete list of each file in a       */
        /*      packaging, then the client needs to extract each file from the package and submit each one  */
        /*      in a separate Document Creation operation.  Note: the client can re-compress each file      */
        /*      before sending, so the compression isn't lost when sending each document separately. ]      */
        /*                                                                                                  */
        /* There MUST NOT be any duplicate collection values, that is, no collection values with all the    */
        /* same member attribute values;  it's a set, not a sequence.  So 100 PostScript files with the     */
        /* same details in a .zip file:                                                                     */
        /*                                                                                                  */
        /*    (1) MAY have one collection value with the "document-format" member attribute =               */
        /*        'application/zip' MIME type value and MAY have additional member attributes that give     */
        /*        details about the .zip file itself and                                                    */
        /*    (2) MUST have one collection value containing a "document-format" member attribute =          */
        /*        'application/postscript' and MAY have additional member attributes that give the details  */
        /*        about the PostScript files.                                                               */
        /*                                                                                                  */
        /* If a file in a packaging file is itself a packaging file, the single "document-format-details"   */
        /* (1setOf collection) Operation attribute SHOULD contain the flattened distinct collection values  */
        /* for all files at all nested levels.  Therefore, the "document-format-details" collection         */
        /* attribute is not recursively defined and MUST NOT contain the "document-format-details"          */
        /* attribute as a member attribute.                                                                 */
        /*                                                                                                  */
        /*               Table 6 - "document-format-details" member Operation attributes                    */
        /*                                                                                                  */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | Member Attribute Name               |    Attribute   |  Client  | Printer |  Member   |  Top | */
        /* |                                     |      Syntax    | Supplies | Support | Attribute | Level| */
        /* |                                     |                |          |         |  Section  | Sect.| */
        /* +=====================================+================+==========+=========+===========+======+ */
        /* | document-source-application-name    |name(MAX)       | MAY      | MAY     | 3.2.5.1   | N/A  | */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-source-application-version | text(127)      | MAY      | MAY     | 3.2.5.2   | N/A  | */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-source-os-name             | name(40)       | MAY      | MAY     | 3.2.5.3   | N/A  | */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-source-os-version          | text(40)       | MAY      | MAY     | 3.2.5.4   | N/A  | */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-format                     | mimeMediaType  | MUST     | MUST    | 3.2.5.5   | 3.2.4| */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-format-device-id           | text(127)      | MAY      | MAY     | 3.2.5.6   | N/A  | */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-format-version             | text(127)      | SHOULD   | MUST    | 3.2.5.7   | 3.2.6| */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /* | document-natural-languages          | 1setOf         | MAY      | MAY     | 3.2.5.8   | 3.2.9| */
        /* |                                     | naturalLanguage|          |         |           |      | */
        /* +-------------------------------------+----------------+----------+---------+-----------+------+ */
        /*                                                                                                  */
        /* The client can determine which member attributes of the "document-format-details" are supported  */
        /* by querying the Printer's "document-format-details-supported" (1setOf type2 keyword) Printer     */
        /* Description attribute (see section 7.6).                                                         */
        /*                                                                                                  */
        /* Table 6 shows that three of the member attributes also have comparable top level Operation       */
        /* attributes defined with the same names.  See the sections listed in the rightmost column.  These */
        /* three high level attributes have corresponding "xxx-default" and "xxx-supported" Printer         */
        /* Description attributes.  These values are also for use with the corresponding three member       */
        /* attributes.  The remaining member attributes do not have any corresponding "xxx-default" and     */
        /* "xxx-supported" Printer Description attribute.                                                   */
        /*                                                                                                  */
        /* If a client supplies this "document-format-details" Operation attribute with a member attribute  */
        /* with a value that the Printer doesn't support, the Printer MUST perform one of the following     */
        /* actions:                                                                                         */
        /*                                                                                                  */
        /*    (1) reject the request OR                                                                     */
        /*    (2) accept the request and either                                                             */
        /*        (a) put the Job in the 'pending-held' state or                                            */
        /*        (b) process the job ignoring the attribute.  See section 3 above for more details.        */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved             */
            /*                           Standard for The Internet Printing Protocol (IPP): Job Extensions  */
            /*          §7.6 [page 32] document-format-details-supported (1setOf type2 keyword)             */
            /* -----------------                                                                            */
            /* This OPTIONAL Printer Description attribute lists the type2 keyword names of the member      */
            /* attributes of "document-format-details" that the Printer supports.  The Printer MUST support */
            /* this "document-format-details" (1setOf type2 keyword) Printer Description attribute, if the  */
            /* Printer supports the "document-format-details" (1setOf collection) Operation attribute (see  */
            /* section 3.2.5).  Table 11 lists the type2 keywords defined for use in the                    */
            /* "document-format-details-supported" Printer attribute.                                       */
            /*                                                                                              */
            /*      Table 11 - Keyword values of "document-format-details-supported Printer attribute       */
            /*                                                                                              */
            /*              +-------------------------------------+---------------------+                   */
            /*              | Type2 keyword values                | Printer conformance |                   */
            /*              +=====================================+=====================+                   */
            /*              | document-source-application-name    | MAY                 |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-source-application-version | MAY                 |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-source-os-name             | MAY                 |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-source-os-version          | MAY                 |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-format                     | MUST                |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-format-device-id           | MAY                 |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-format-version             | MUST                |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*              | document-natural-language           | MAY                 |                   */
            /*              +-------------------------------------+---------------------+                   */
            /*                                                                                              */
            /* ============================================================================================ */
typedef struct {
   pwgDocumentFormatEnum  docFormat;                        /* Document format for the Document content.    */
                 pwgCHAR  docFormatVersion[pwgMAX_DOC_FMT_VER_SIZE];  /* Document Format Version            */
                 pwgCHAR  docFormatDeviceId[pwgMAX_DOC_FMT_DEV_ID_SIZE]; /* Device doc was formatted for    */
  pwgDocumentNaturalLanguageEnum  docNaturalLanguage;       /* Natural language for document                */
                 pwgCHAR  docSourceApplicationName[pwgMAX_DOC_SRC_APP_NAMED_SIZE]; /* App that created doc  */
                 pwgCHAR  docSourceApplicationVersion[pwgMAX_DOC_SRC_APP_VER_SIZE]; /* Document App version */
                 pwgCHAR  docSourceOsName[pwgMAX_DOC_SRC_OS_NAME_SIZE]; /* Document Operating System Name   */
                 pwgCHAR  docSourceOsVersion[pwgMAX_DOC_SRC_OS_VER_SIZE]; /* Doc Operating System Version   */

                 VND_DOC_FMT_DTLS_STRUCT

} pwgDocumentFormatDetailsSupplied, pwgDFDS;

typedef struct {
          pwgNUM_RNG_DEF* docFormat;                  /* Document format for the Document content.          */
             pwgINFO_DEF* docFormatVersion;           /* Document Format Version                            */
             pwgINFO_DEF* docFormatDeviceId;          /* Device doc was formatted for                       */
          pwgNUM_RNG_DEF* docNaturalLanguage;         /* Natural language for document                      */
             pwgINFO_DEF* docSourceApplicationName;   /* App that created doc                               */
             pwgINFO_DEF* docSourceApplicationVersion;/* Document App version                               */
          pwgNUM_RNG_DEF* docSourceOsName;            /* Document Operating System Name                     */
             pwgINFO_DEF* docSourceOsVersion;         /* Doc Operating System Version                       */

            VND_DOC_FMT_DTLS_DEF_STRUCT

                 pwgVOID* last;
} pwgDocumentFormatDetailsSuppliedDefLst;


/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern  pwgDocumentFormatDetailsSuppliedDefLst  pwgDocumentFormatDetailsSuppliedDefElem;
extern  pwgSTRUCT_DEF                           pwgDef_DocumentFormatDetailsSupplied;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJD_2_DOCUMENT_FORMAT_DETAILS_SUPPLIED_H__                                             */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ========================== pwg.pjt.pjd.2.document.format.details.supplied.h ============================ */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
