/* ============================== pwg.pjt.pjd.2.job.originating.user.uri.h ================================ */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJD_2_JOB_ORIGINATING_USER_URI_H__
#define __PWG_PJT_PJD_2_JOB_ORIGINATING_USER_URI_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Originating User URI                                                                                 */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 48] JobOriginatingUserUri          */
/* -----------------                                                                                        */
/* URI of the User that submitted the Job creation request.  The PrintService sets this element to the most */
/* authenticated user URI available.  This element differs from JobOriginatingUserName which is a human     */
/* readable name.  This element is a URI (e.g., urn:uuid:f92eface-7dec-21c3-ab55-12d3c91eabff,              */
/* mailto:pzehler@example.com).                                                                             */
/* [PWG 5100.13] §5.3.6                                                                                     */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:  [PWG 5100.13] §5.3.3                                                                     */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                         */
    /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)      */
    /*      §5.3.3 [page 30] job-originating-user-uri (uri)                                                 */
    /* -----------------                                                                                    */
    /* The REQUIRED "job-originating-user-uri" READ-ONLY Job attribute contains the most authenticated URI  */
    /* of the end user that submitted the job creation request as defined in section 6.1.                   */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                     */
        /*                                                  IPP: Job and Printer Extensions - Set 3 (JPS3)  */
        /*      §6.1 [page 55] All Operations: "requesting-user-uri"                                        */
        /* -----------------                                                                                */
        /* If the Printer supports the "requesting-user-uri" (section 5.1.6) operation attribute, Clients   */
        /* MAY supply it in a Create-Job, Create-Job-Subscription, Create-Printer-Subscription,             */
        /* Print-Job, or Print-URI operation. The Printer object sets the "job-originating-user-uri"        */
        /* (section 5.3.3) or "notify-subscriber-user-uri" (section 5.4.2) attribute as needed to the most  */
        /* authenticated URI that it can obtain from the authentication service over which the IPP          */
        /* operation was received. Only if such an authenticated URI is not available, does the Printer     */
        /* object use the value supplied by the Client in the "requesting-user-uri" operation of the        */
        /* operation (see Sections 4.4.2, 4.4.3, and 8 of the IPP/1.1 Model and Semantics [RFC2911])        */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable                 */
            /*                                              IPP: Job and Printer Extensions - Set 3 (JPS3)  */
            /*      §5.1.6 [page 26] requesting-user-uri (uri)                                              */
            /* -----------------                                                                            */
            /* The REQUIRED "requesting-user-uri" operation attribute contains the URI of the end user that */
            /* is submitting the request. The value is typically a UUID encoded as defined in A Universally */
            /* Unique IDentifier (UUID) URN Namespace [RFC4122] or an email address encoded as defined in   */
            /* The "mailto:" URI scheme [RFC6068], although any valid URI may be supplied.                  */
            /*                                                                                              */
            /* The intent of this attribute is to provide an unambiguous user identifier since the          */
            /* "requesting-user-name" operation attribute is often not unique, e.g., "John Doe". However,   */
            /* because both of the attributes can be supplied by the Client, the Printer object may modify  */
            /* the values supplied based on information obtained from an authentication service (see        */
            /* Sections 4.4.2, 4.4.3, and 8 of the IPP/1.1 Model and Semantics [RFC2911]).                  */
            /*                                                                                              */
            /* The "requesting-user-uri-supported" (section 5.6.42) Printer attribute specifies whether the */
            /* "requesting-user-uri" operation attribute is supported.                                      */
            /*                                                                                              */
            /* ============================================================================================ */
                /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable             */
                /*                                          IPP: Job and Printer Extensions - Set 3 (JPS3)  */
                /*      §5.6.42 [page 54] requesting-user-uri-supported (boolean)                           */
                /* -----------------                                                                        */
                /* The REQUIRED "requesting-user-uri-supported" Printer attribute specifies whether the     */
                /* "requesting-user-uri" (section 5.1.6) operation, "job-originating-user-uri"              */
                /* (section 5.3.3) Job Description, and "notify-subscriber-user-uri" (section 5.4.2)        */
                /* Subscription Description attributes are supported. Printers MUST support this attribute  */
                /* with a value of 'true'.                                                                  */
                /*                                                                                          */
                /* ======================================================================================== */
                    /* [PWG 5100.13] July 27, 2012: Candidate Standard 5100.13-2012  Status: Stable         */
                    /*                                      IPP: Job and Printer Extensions - Set 3 (JPS3)  */
                    /*      §5.4.2 [page 31] notify-subscriber-user-uri (uri)                               */
                    /* -----------------                                                                    */
                    /* The CONDITIONALLY REQUIRED "notify-subscriber-user-uri" READ-ONLY Subscription       */
                    /* attribute contains the most authenticated URI of the end user that submitted the     */
                    /* subscription creation request as defined in section 6.1. This attribute is REQUIRED  */
                    /* if IPP:Event Notifications and Subscriptions [RFC3995] are supported.                */
                    /*                                                                                      */
                    /* ==================================================================================== */
            /* ============================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §4.4.2 [page 127] uri-authentication-supported (1setOf type2 keyword)                   */
            /* -----------------                                                                            */
            /* This REQUIRED Printer attribute MUST have the same cardinality (contain the same number of   */
            /* values) as the "printer-uri-supported" attribute.  This attribute identifies the Client      */
            /* Authentication  mechanism associated with each URI listed in the "printer-uri-supported"     */
            /* attribute. The Printer object uses the specified mechanism to identify the authenticated     */
            /* user (see section 8.3).  The "i th" value in "uri-authentication-supported" corresponds to   */
            /* the "i th" value in "printer-uri-supported" and it describes the authentication mechanisms   */
            /* used by the Printer when accessed via that URI.  See [RFC2910] for more details on Client    */
            /* Authentication.                                                                              */
            /*                                                                                              */
            /* The following standard keyword values are defined:                                           */
            /*                                                                                              */
            /*  |-----------------------|---------------------------------------------------------------|   */
            /*  | none                  | There is no authentication mechanism associated with the URI. |   */
            /*  |                       | The Printer object assumes that the authenticated user is     |   */
            /*  |                       | "anonymous".                                                  |   */
            /*  |-----------------------|---------------------------------------------------------------|   */
            /*  | requesting-user-name  | When a client performs an operation whose target is the       |   */
            /*  |                       | associated URI, the Printer object assumes that the           |   */
            /*  |                       | authenticated user is specified by the "requesting-user-name" |   */
            /*  |                       | Operation attribute (see section 8.3). If the                 |   */
            /*  |                       | "requesting-user-name" attribute is absent in a request, the  |   */
            /*  |                       | Printer object assumes that the authenticated user is         |   */
            /*  |                       | "anonymous".                                                  |   */
            /*  |-----------------------|---------------------------------------------------------------|   */
            /*  | basic                 | When a client performs an operation whose target is the       |   */
            /*  |                       | associated URI, the Printer object challenges the client with |   */
            /*  |                       | HTTP basic authentication [RFC2617]. The Printer object       |   */
            /*  |                       | assumes that the authenticated user is the name received via  |   */
            /*  |                       | the basic authentication mechanism.                           |   */
            /*  |-----------------------|---------------------------------------------------------------|   */
            /*  | digest                | When a client performs an operation whose target is the       |   */
            /*  |                       | associated URI, the Printer object challenges the client with |   */
            /*  |                       | HTTP digest authentication [RFC2617]. The Printer object      |   */
            /*  |                       | assumes that the authenticated user is the name received via  |   */
            /*  |                       | the digest authentication mechanism.                          |   */
            /*  |-----------------------|---------------------------------------------------------------|   */
            /*  | certificate           | When a client performs an operation whose target is the       |   */
            /*  |                       | associated URI, the Printer object expects the client to      |   */
            /*  |                       | provide a certificate. The Printer object assumes that the    |   */
            /*  |                       | authenticated user is the textual name contained within the   |   */
            /*  |                       | certificate.                                                  |   */
            /*  |-----------------------|---------------------------------------------------------------|   */
            /*                                                                                              */
            /* ============================================================================================ */
                /* [rfc2911] September 2000: Standards Track                                                */
                /*                              Internet Printing Protocol/1.1: Model and Semantics         */
                /*      §8.3 [page 160-161] URIs for each authentication mechanisms                         */
                /* -----------------                                                                        */
                /* Each URI has an authentication mechanism associated with it. If the URI is the i'th      */
                /* element of "printer-uri-supported", then authentication mechanism is the "i th" element  */
                /* of "uri-authentication-supported". For a list of possible authentication mechanisms, see */
                /* section 4.4.2.                                                                           */
                /*                                                                                          */
                /* The Printer object uses an authentication mechanism to determine the name of the user    */
                /* performing an operation. This user is called the "authenticated user". The credibility   */
                /* of authentication depends on the mechanism that the Printer uses to obtain the user's    */
                /* name. When the authentication mechanism is 'none', all authenticated users are           */
                /*  "anonymous".                                                                            */
                /*                                                                                          */
                /* During job creation operations, the Printer initializes the value of the                 */
                /* "job-originating-user-name" attribute (see section 4.3.6) to be the authenticated user.  */
                /* The authenticated user is this case is called the "job owner".                           */
                /*                                                                                          */
                /* If an implementation can be configured to support more than one authentication mechanism */
                /* (see section 4.4.2), then it MUST implement rules for determining equality of            */
                /* authenticated user names which have been authenticated via different authentication      */
                /* mechanisms.  One possible policy is that identical names that are authenticated via      */
                /* different mechanisms are different. For example, a user can cancel his job only if he    */
                /* uses the same authentication mechanism for both Cancel-Job and Print-Job.  Another       */
                /* policy is that identical names that are authenticated via different mechanism are the    */
                /* same if the authentication mechanism for the later operation is not less strong than the */
                /* authentication mechanism for the earlier job creation operation.  For example, a user    */
                /* can cancel his job only if he uses the same or stronger authentication mechanism for     */
                /* Cancel-Job and Print-Job. With this second policy a job submitted via                    */
                /* 'requesting-user-name' authentication could be canceled via 'digest' authentication.     */
                /* With the first policy, the job could not be canceled in this way.                        */
                /*                                                                                          */
                /* A client is able to determine the authentication mechanism used to create a job. It is   */
                /* the i'th value of the Printer's "uri-authentication-supported" attribute (see            */
                /* section 4.4.2), where i is the index of the element of the Printer's                     */
                /* "printer-uri-supported" attribute (see section 4.4.1) equal to the job's                 */
                /* "job-printer-uri" attribute (see section 4.3.3).                                         */
                /*                                                                                          */
                /* ======================================================================================== */
                    /* [rfc2911] September 2000: Standards Track                                            */
                    /*                              Internet Printing Protocol/1.1: Model and Semantics     */
                    /*      §4.4.1 [page 126-127] printer-uri-supported (1setOf uri)                        */
                    /* -----------------                                                                    */
                    /* This REQUIRED Printer attribute contains at least one URI for the Printer object.    */
                    /* It OPTIONALLY contains more than one URI for the Printer object.    An administrator */
                    /* determines a Printer object's URI(s) and configures this attribute to contain those  */
                    /* URIs by some means outside the scope of this IPP/1.1 document.  The precise format   */
                    /* of this URI is implementation dependent and depends on the protocol.  See the next   */
                    /* two sections for a description of the "uri-security-supported" and                   */
                    /* "uri-authentication-supported" attributes, both of which are the REQUIRED companion  */
                    /* attributes to this "printer-uri-supported" attribute.  See section 2.4 on Printer    */
                    /* object identity and section 8.2 on security and URIs for more information.           */
                    /*                                                                                      */
            /* ============================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §4.3.3 [page 108] job-printer-uri (uri)                                                 */
            /* -----------------                                                                            */
            /* This REQUIRED attribute identifies the Printer object that created this Job object.  When a  */
            /* Printer object creates a Job object, it populates this attribute with the Printer object URI */
            /* that was used in the create request.  This attribute permits a client to identify the        */
            /* Printer object that created this Job object when only the Job object's URI is available to   */
            /* the client.  The client queries the creating Printer object to determine which languages,    */
            /* charsets, operations, are supported for this Job.                                            */
            /*                                                                                              */
            /* For a description of this attribute and its relationship to "job-uri" and "job-id" attribute,*/
            /* see the discussion in section 2.4 on "Object Identity".                                      */
            /*                                                                                              */
            /* ============================================================================================ */
                /* [rfc2911] September 2000: Standards Track                                                */
                /*                              Internet Printing Protocol/1.1: Model and Semantics         */
                /*      §2.4 [page 17-20] Object Identity                                                   */
                /* -----------------                                                                        */
                /* All Printer and Job objects are identified by a Uniform Resource Identifier (URI)        */
                /* [RFC2396] so that they can be persistently and unambiguously referenced.  Since every    */
                /* URL is a specialized form of a URI, even though the more generic term URI is used        */
                /* throughout the rest of this document, its usage is intended to cover the more specific   */
                /* notion of URL as well.                                                                   */
                /*                                                                                          */
                /* An administrator configures Printer objects to either support or not support             */
                /* authentication and/or message privacy using Transport Layer Security (TLS) [RFC2246]     */
                /* (the mechanism for security configuration is outside the scope of this IPP/1.1 document).*/
                /* In some situations, both types of connections (both authenticated and unauthenticated)   */
                /* can be established using a single communication channel that has some sort of            */
                /* negotiation mechanism.  In other situations, multiple communication channels are used,   */
                /* one for each type of security configuration.  Section 8 provides a full description of   */
                /* all security considerations and configurations.                                          */
                /*                                                                                          */
                /* If a Printer object supports more than one communication channel, some or all of those   */
                /* channels might support and/or require different security mechanisms.  In such cases, an  */
                /* administrator could expose the simultaneous support for these multiple communication     */
                /* channels as multiple URIs for a single Printer object where each URI represents one of   */
                /* the communication channels to the Printer object. To support this flexibility, the IPP   */
                /* Printer object type defines a multi-valued identification attribute called the           */
                /* "printer-uri-supported" attribute.  It MUST contain at least one URI.  It MAY contain    */
                /* more than one URI.  That is, every Printer object will have at least one URI that        */
                /* identifies at least one communication channel to the Printer object, but it may have     */
                /* more than one URI where each URI identifies a different communication channel to the     */
                /* Printer object.  The "printer-uri-supported" attribute has two companion attributes, the */
                /* "uri-security-supported" attribute and the "uri-authentication-supported". Both have the */
                /* same cardinality as "printer-uri-supported".  The purpose of the                         */
                /* "uri-security-supported" attribute is to indicate the security mechanisms (if any) used  */
                /* for each URI listed in "printer-uri-supported". The purpose of the                       */
                /* "uri-authentication-supported" attribute is to indicate the authentication mechanisms    */
                /* (if any) used for each URI listed in "printer-uri-supported".  These three attributes    */
                /* are fully described in sections 4.4.1, 4.4.2, and 4.4.3.                                 */
                /*                                                                                          */
                /* When a job is submitted to the Printer object via a create request, the client supplies  */
                /* only a single Printer object URI.  The client supplied Printer object URI MUST be one of */
                /* the values in the "printer-uri-supported" Printer attribute.                             */
                /*                                                                                          */
                /* IPP/1.1 does not specify how the client obtains the client supplied URI, but it is       */
                /* RECOMMENDED that a Printer object be registered as an entry in a directory service.      */
                /* End-users and programs can then interrogate the directory searching for Printers.        */
                /* Section 16 defines a generic schema for Printer object entries in the directory service  */
                /* and describes how the entry acts as a bridge to the actual IPP Printer object.  The      */
                /* entry in the directory that represents the IPP Printer object includes the possibly many */
                /* URIs for that Printer object as values in one its attributes.                            */
                /*                                                                                          */
                /* When a client submits a create request to the Printer object, the Printer object         */
                /* validates the request and creates a new Job object. The Printer object assigns the new   */
                /* Job object a URI which is stored in the "job-uri" Job attribute.  This URI is then used  */
                /* by clients as the target for subsequent Job operations.  The Printer object generates a  */
                /* Job URI based on its configured security policy and the URI used by the client in the    */
                /* create request.                                                                          */
                /*                                                                                          */
                /* For example, consider a Printer object that supports both a communication channel        */
                /* secured by the use of SSL3 (using HTTP over SSL3 with an "https" schemed URI) and        */
                /* another open communication channel that is not secured with SSL3 (using a simple "http"  */
                /* schemed URI).  If a client were to submit a job using the secure URI, the Printer object */
                /* would assign the new Job object a secure URI as well.  If a client were to submit a job  */
                /* using the open-channel URI, the Printer would assign the new Job object an open-channel  */
                /* URI.                                                                                     */
                /*                                                                                          */
                /* In addition, the Printer object also populates the Job object's "job-printer-uri"        */
                /* attribute.  This is a reference back to the Printer object that created the Job object.  */
                /* If a client only has access to a Job object's "job-uri" identifier, the client can query */
                /* the Job's "job-printer-uri" attribute in order to determine which Printer object created */
                /* the Job object.  If the Printer object supports more than one URI, the Printer object    */
                /* picks the one URI supplied by the client when creating the job to build the value for    */
                /* and to populate the Job's "job-printer-uri" attribute.                                   */
                /*                                                                                          */
                /* Allowing Job objects to have URIs allows for flexibility and scalability.  For example,  */
                /* in some implementations, the Printer   object might create Jobs that are processed in    */
                /* the same local environment as the Printer object itself.  In this case, the Job URI      */
                /* might just be a composition of the Printer's URI and some unique component for the Job   */
                /* object, such as the unique 32-bit positive integer mentioned later in this paragraph.    */
                /* In other implementations, the Printer object might be a central clearing-house for       */
                /* validating all Job object creation requests, but the Job object itself might be created  */
                /* in some environment that is remote from the Printer object. In this case, the Job        */
                /* object's URI may have no physical-location relationship at all to the Printer object's   */
                /* URI.  Again, the fact that Job objects have URIs allows for flexibility and scalability, */
                /* however, many existing printing systems have local models or interface constraints that  */
                /* force print jobs to be identified using only a 32-bit positive integer rather than an    */
                /* independent URI.  This numeric Job ID is only unique within the context of the Printer   */
                /* object to which the create request was originally submitted.  Therefore, in order to     */
                /* allow both types of client access to IPP Job objects (either by Job URI or by numeric    */
                /* Job ID), when the Printer object successfully processes a create request and creates a   */
                /* new Job object, the Printer object MUST generate both a Job URI and a Job ID.  The Job   */
                /* ID (stored in the "job-id" attribute) only has meaning in the context of the Printer     */
                /* object to which the create request was originally submitted. This requirement to support */
                /* both Job URIs and Job IDs allows all types of clients to access Printer objects and Job  */
                /* objects no matter the local constraints imposed on the client implementation.            */
                /*                                                                                          */
                /* In addition to identifiers, Printer objects and Job objects have names ("printer-name"   */
                /* and "job-name").  An object name NEED NOT be unique across all instances of all objects. */
                /* A Printer object's name is chosen and set by an administrator through some mechanism     */
                /* outside the scope of this IPP/1.1 document.  A Job object's name is optionally chosen    */
                /* and supplied by the IPP client submitting the job.   If the client does not supply a     */
                /* Job object name, the Printer object generates a name for the new Job object.  In all     */
                /* cases, the name only has local meaning.                                                  */
                /*                                                                                          */
                /* To summarize:                                                                            */
                /*                                                                                          */
                /*      - Each Printer object is identified with one or more URIs.  The Printer's           */
                /*        "printer-uri-supported" attribute contains the URI(s).                            */
                /*      - The Printer object's "uri-security-supported" attribute identifies the            */
                /*        communication channel security protocols that may or may not have been configured */
                /*        for the various Printer object URIs (e.g., 'tls' or 'none').                      */
                /*      - The Printer object's "uri-authentication-supported" attribute identifies the      */
                /*        authentication mechanisms that may or may not have been configured for the        */
                /*        various Printer object URIs (e.g.,'digest' or 'none').                            */
                /*      - Each Job object is identified with a Job URI.  The Job's "job-uri" attribute      */
                /*        contains the URI.                                                                 */
                /*      - Each Job object is also identified with Job ID which is a 32-bit, positive        */
                /*        integer.  The Job's "job-id" attribute contains the Job ID.  The Job ID is only   */
                /*        unique within the context of the Printer object which created the Job object.     */
                /*      - Each Job object has a "job-printer-uri" attribute which contains the URI of the   */
                /*        Printer object that was used to create the Job object.  This attribute is used to */
                /*        determine the Printer object that created a Job object when given only the URI    */
                /*        for the Job object.  This linkage is necessary to determine the languages,        */
                /*        charsets, and operations which are supported on that Job (the basis for such      */
                /*        support comes from the creating Printer object).                                  */
                /*      - Each Printer object has a name (which is not necessarily unique).  The            */
                /*        administrator chooses and sets this name through some mechanism outside the scope */
                /*        of this IPP/1.1 document.  The Printer object's "printer-name" attribute contains */
                /*        the name.                                                                         */
                /*      - Each Job object has a name (which is not necessarily unique). The client          */
                /*        optionally supplies this name in the create request. If the client does not       */
                /*        supply this name, the Printer object generates a name for the Job object. The     */
                /*        Job object's "job-name" attribute contains the name.                              */
                /*                                                                                          */
                /* ======================================================================================== */
                /* [rfc2911] September 2000: Standards Track                                                */
                /*                              Internet Printing Protocol/1.1: Model and Semantics         */
                /*      §8.2 [page 160] URIs in Operation, Job, and Printer attributes                      */
                /* -----------------                                                                        */
                /*    The "printer-uri-supported" attribute contains the Printer object's URI(s).  Its      */
                /* companion attribute, "uri-security-supported", identifies the security mechanism used    */
                /* for each URI listed in the "printer-uri-supported" attribute.  For each Printer          */
                /* operation request, a client MUST supply only one URI in the "printer-uri" operation      */
                /* attribute.  In other words, even though the Printer supports more than one URI, the      */
                /* client only interacts with the Printer object using one if its URIs.  This duality is    */
                /* not needed for Job objects, since the Printer objects is the factory for Job objects,    */
                /* and the Printer object will generate the correct URI for new Job objects depending on    */
                /* the Printer object's security configuration.                                             */
                /*                                                                                          */
                /* ======================================================================================== */
/* pwgCHAR   jobOriginatingUserUri[pwgMAX_URI_SIZE];  /  URI reference to the end user for the job          */

extern  pwgINFO_DEF pwgDef_JobOriginatingUserUri;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJD_2_JOB_ORIGINATING_USER_URI_H__                                                     */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================== pwg.pjt.pjd.2.job.originating.user.uri.h ================================ */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
