/* ================================ pwg.pjt.pjp.1.job.copies.h ============================================ */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_1_JOB_COPIES_H__
#define __PWG_PJT_PJP_1_JOB_COPIES_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Copies                                                                                               */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 48] JobCopies                      */
/* -----------------                                                                                        */
/* The number of copies of the Job to be printed.                                                           */
/* [PWG5100.7] §4.1.1                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                     */
    /*                                   Standard for The Internet Printing Protocol (IPP): Job Extensions  */
    /*          §4.1.1.x [page 21-22] job-copies (integer(1:MAX))                                           */
    /* -----------------                                                                                    */
    /* This OPTIONAL Job Template attribute specifies the number of job copies, i.e., with all of the       */
    /* Documents taken together.  Its interpretation is independent of the value of the                     */
    /* "multiple-document-handling" Job Template attribute.  See the "copies" Job Template attribute        */
    /* defined in [rfc2911] section 4.2.5 that switches between job copies and document copies depending    */
    /* on the value of the "multiple-document-handling" Job Template attribute ([rfc2911] section 4.2.4).   */
    /*                                                                                                      */
    /* For example assume a Job has two documents.  The "copies" attribute has a value of '3' and           */
    /* "job-copies" has a value of "2".  With "multiple-document-handling" set to                           */
    /* 'separate-documents-collated-copies' the resulting printout would have two sets (i.e. job-copies=2). */
    /* The first set would be 3 copies of Document 1 and then 3 copies of Document 2.  The second set would */
    /* be identical to the first.  If a similar Job was run with "multiple-documents-handling" set to       */
    /* 'single-document-new-sheet' it would also produce two set.  In this case however each set would      */
    /* contain Document 1, Document 2, Document 1, Document 2, Document 1, Document 2 (i.e copies=3).       */
    /* The "copies" and "job-copies" become more interesting when Documents within the Job each have their  */
    /* own value of "copies".  This can be accomplished via the Document object [pwg5100.5] or Overrides    */
    /* [pwg5100.6].                                                                                         */
    /*                                                                                                      */
    /* 4.1.1.1 job-copies-default (integer(1:MAX))                                                          */
    /* This OPTIONAL Job Template Printer attribute specifies the default number of copies for the job as   */
    /* a whole.  The Printer MUST support this attribute if it supports the "job-copies" Job Template       */
    /* attribute.                                                                                           */
    /*                                                                                                      */
    /* 4.1.1.2 job-copies-supported (rangeOfInteger(1:MAX))                                                 */
    /* This OPTIONAL Job Template Printer attribute specifies the supported range of the number of copies   */
    /* for the job as a whole.  The Printer MUST support this attribute if it supports the "job-copies" Job */
    /* Template attribute.                                                                                  */
    /*                                                                                                      */
    /* 4.1.1.3 job-copies-actual (1setof Integer(1:MAX))                                                    */
    /* This OPTIONAL Job Description attribute specifies the number of copies that the Printer actually     */
    /* printed for the job as a whole.  The Printer MAY support this attribute even if it does not support  */
    /* the "job-copies" Job Template attribute.                                                             */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §4.2.4 [page 96-98] multiple-document-handling (type2 keyword)                              */
        /* -----------------                                                                                */
        /* ################################################################################################ */
        /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
        /* This attribute is relevant only if a job consists of two or more documents. This attribute MUST  */
        /* be supported with at least one value if the Printer supports multiple documents per job (see     */
        /* ################################################################################################ */
        /* VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV */
        /* Errata ID: 3072  | Reported By: Michael Sweet  | Date Reported: 2012-01-04                       */
        /*                                                                                                  */
        /* Section 4.2.4 says:                                                                              */
        /*                                                                                                  */
        /* This attribute is relevant only if a job consists of two or more documents. This attribute MUST  */
        /* be supported with at least one value                                                             */
        /*                                                                                                  */
        /* It should say:                                                                                   */
        /*                                                                                                  */
        /* This attribute is relevant to jobs consisting of one or more documents. This attribute MUST be   */
        /* supported with at least one value                                                                */
        /*                                                                                                  */
        /* Notes: Per consensus of the IPP working group in the Printer Working Group, the                  */
        /*        "multiple-document-handling" attribute *is* applicable to single-document jobs since it   */
        /*        is the only common attribute that can be used to request copy collation.                  */
        /*                                                                                                  */
        /*        The other collation attribute ("sheet-collate" from RFC3381])interacts with               */
        /*        "multiple-document-handling" in some non-obvious ways and requires clients and printers   */
        /*        to support two different attributes for simple collation. The "sheet-collate" attribute   */
        /*        also does not address how finishing options are applied to copies while                   */
        /*        "multiple-document-handling" does.                                                        */
        /* ###############################################################################################  */
        /* This attribute is relevant to jobs consisting of one or more documents. This attribute MUST be   */
        /* supported with at least one value if the Printer supports multiple documents per job (see        */
        /* sections 3.2.4 and 3.3.1).  The attribute controls finishing operations and the placement of one */
        /* or more print-stream pages into impressions and onto media sheets.  When the value of the        */
        /* "copies" attribute exceeds 1, it also controls the order in which the copies that result from    */
        /* processing the documents are produced. For the purposes of this explanations, if "a" represents  */
        /* an instance of document data, then the result of processing the data in document "a" is a        */
        /* sequence of media sheets represented by "a(*)".                                                  */
        /*                                                                                                  */
        /* Standard keyword values are:                                                                     */
        /*                                                                                                  */
        /*    'single-document': If a Job object has multiple documents, say, the document data is called a */
        /*        and b, then the result of processing all the document data (a and then b) MUST be treated */
        /*        as a single sequence of media sheets for finishing operations; that is, finishing would   */
        /*        be performed on the concatenation of the sequences a(*),b(*).  The Printer object MUST    */
        /*        NOT force the data in each document instance to be formatted onto a new print-stream page,*/
        /*        nor to start a new impression on a new media sheet. If more than one copy is made, the    */
        /*        ordering of the sets of media sheets resulting from processing the document data MUST be  */
        /*        a(*), b(*), a(*), b(*), start on a new media sheet.                                       */
        /*                                                                                                  */
        /*    'separate-documents-uncollated-copies': If a Job object has multiple documents, say, the      */
        /*        document data is called a and b, then the result of processing the data in each document  */
        /*        instance MUST be treated as a single sequence of media sheets for finishing operations;   */
        /*        that is, the sets a(*) and b(*) would each be finished separately. The Printer object     */
        /*        MUST force each copy of the result of processing the data in a single document to start   */
        /*        on a new media sheet. If more than one copy is made, the ordering of the sets of media    */
        /*        sheets resulting from processing the document data MUST be a(*), a(*), ..., b(*),         */
        /*        b(*) ... .                                                                                */
        /*                                                                                                  */
        /*    'separate-documents-collated-copies': If a Job object has multiple documents, say, the        */
        /*        document data is called a and b, then the result of processing the data in each document  */
        /*        instance MUST be treated as a single sequence of media sheets for finishing operations;   */
        /*        that is, the sets a(*) and b(*) would each be finished separately. The Printer object     */
        /*        MUST force each copy of the result of processing the data in a single document to start   */
        /*        on a new media sheet.  If more than one copy is made, the ordering of the sets of media   */
        /*        sheets resulting from processing the document data MUST be a(*), b(*), a(*), b(*), ... .  */
        /*                                                                                                  */
        /*    'single-document-new-sheet':  Same as 'single-document', except that the Printer object MUST  */
        /*        ensure that the first impression of each document instance in the job is placed on a new  */
        /*        media sheet.  This value allows multiple documents to be stapled together with a single   */
        /*        staple where each document starts on a new sheet.                                         */
        /*                                                                                                  */
        /* The 'single-document' value is the same as 'separate-documents-collated-copies' with respect to  */
        /* ordering of print-stream pages, but not media sheet generation, since 'single-document' will put */
        /* the first page of the next document on the back side of a sheet if an odd number of pages have   */
        /* been produced so far for the job, while 'separate-documents-collated- copies' always forces the  */
        /* next document or document copy on to a new sheet.  In addition, if the "finishings" attribute    */
        /* specifies 'staple', then with 'single-document', documents a and b are stapled together as a     */
        /* single document with no regard to new sheets, with 'single-document-new-sheet', documents a and  */
        /* b are stapled together as a single document, but document b starts on a new sheet, but with      */
        /* 'separate-documents-uncollated-copies' and 'separate-documents-collated-copies', documents a and */
        /* b are stapled separately.                                                                        */
        /*                                                                                                  */
        /* Note: None of these values provide means to produce uncollated sheets within a document, i.e.,   */
        /*       where multiple copies of sheet n are produced before sheet n+1 of the same document.       */
        /*                                                                                                  */
        /* The relationship of this attribute and the other attributes that control document processing is  */
        /* described in section 15.3.                                                                       */
        /*                                                                                                  */
        /* ================================================================================================ */
/* pwgBIT32                 jobCopies;                /  The number of copies of the Job to be printed.     */

extern pwgNUM_DEF pwgDef_JobCopies;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_1_JOB_COPIES_H__                                                                   */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.1.job.copies.h ============================================ */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
