/* ================================ pwg.pjt.pjp.3.job.cover.back.h ======================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_JOB_COVER_BACK_H__
#define __PWG_PJT_PJP_3_JOB_COVER_BACK_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pdp.2.cover.back.front.h"
#include "pwg.pjt.pdp.2.cover.type.h"
#include "pwg.pjt.xxx.N.media.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Cover Back                                                                                           */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 48] JobCoverBack                   */
/* -----------------                                                                                        */
/* The back cover to apply this Job. (Contains Media/MediaType or MediaCol, CoverType)                      */
/* [PWG5100.7] §4.1.2                                                                                       */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG5100.7] October 31, 2003: Candidate Standard 5100.07-2003 - Status: Approved                     */
    /*                                   Standard for The Internet Printing Protocol (IPP): Job Extensions  */
    /*          §4.1.2 [page 22] job-cover-back (collection)                                                */
    /* -----------------                                                                                    */
    /* This OPTIONAL Job Template attribute specifies the cover for the back of the job, i.e., with all of  */
    /* the Documents taken together and is independent of the value of the "multiple-document-handling" Job */
    /* Template attribute.  The member attributes are the same as "cover-back" (see [pwg5100.3] section 3.1)*/
    /* and with the same conformance requirements.  However, the "cover-back" Job Template attribute        */
    /* switches between a job back cover and a document back cover depending on the value of the            */
    /* "multiple-document-handling" Job Template attribute ([rfc2911] section 4.2.4).  The "job-cover-back" */
    /* Job Template attribute is equivalent to "cover-back" with "multiple-document-handling" =             */
    /* 'single-document-new-sheet'.                                                                         */
    /*                                                                                                      */
    /*    4.1.2.1 job-cover-back-default (collection)                                                       */
    /*        This OPTIONAL Job Template Printer attribute specifies the default the cover for the back of  */
    /*        the job.  The Printer MUST support this attribute if it supports the "job-cover-back" Job     */
    /*        Template attribute.                                                                           */
    /*                                                                                                      */
    /*    4.1.2.2 job-cover-back-supported (1setOf type2 keyword)                                           */
    /*        This OPTIONAL Job Template Printer attribute specified the supported member attributes of the */
    /*        "job-cover-back" Job Template collection attributes.  The Printer MUST support this attribute */
    /*        if it supports the "job-cover-back" Job Template attribute.                                   */
    /*                                                                                                      */
    /*    4.1.2.3 job-cover-back-actual (1setOf collection)                                                 */
    /*        This OPTIONAL Job Description attribute specifies the "job-cover-back" that the Printer       */
    /*        actually used in producing the job.  The Printer MAY support this attribute even if it does   */
    /*        not support the "job-cover-back" Job Template attribute.                                      */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                                   */
        /*                          Internet Printing Protocol(IPP): Production Printing Attributes - Set1  */
        /*      §3.1 [page 19-22] cover-front (collection) and cover-back (collection)                      */
        /* -----------------                                                                                */
        /* These two attributes specify how covers are to be applied to each copy of each printed document  */
        /* within a job.  Presence of the "cover-front" attribute indicates that a front cover is           */
        /* requested, and similarly, the presence of the "cover-back" attribute indicates that a back cover */
        /* is requested.  Each of the "cover-front" and "cover-back" attributes includes where printing     */
        /* should be applied on the cover (if any), and what media should be used for the cover.            */
        /*                                                                                                  */
        /* Both the "cover-front" and "cover-back" attributes are affected by the                           */
        /* "multiple-document-handling" attribute.  In the case of the 'single-document' and                */
        /* 'single-document-new-sheet' values, the covers MUST be applied to each copy of the composite     */
        /* (single) document.  When the value is either 'separate-documents-collated-copies' or             */
        /* 'separate-documents-uncollated-copies', then the covers MUST be applied to each document copy    */
        /* individually.                                                                                    */
        /*                                                                                                  */
        /* The sheets in the rendered output that represent the covers are treated like any other sheet in  */
        /* the document copy.  For example, if the "finishings" attribute (see [RFC2911] section 4.2.6) has */
        /* a value of 'staple,' then the staple would bind the covers, along with all of the other sheets   */
        /* in the output.                                                                                   */
        /*                                                                                                  */
        /* A client SHOULD use this attribute rather than the "page-overrides" attribute with the "media"   */
        /* attribute overridden for the first and last page of each Output-Document. A Printer MAY perform  */
        /* some special function with covers that it wouldn't perform for "page-overrides".                 */
        /*                                                                                                  */
        /* Both the "cover-front" and "cover-back" attributes are defined by the following collection:      */
        /*                                                                                                  */
        /*                       Table 2 - "cover-front" and "cover-back" member attributes                 */
        /* |---------------------|----------------------------|--------------------|-----------------------|*/
        /* | Attribute name      |  attribute syntax          |     request        |   Printer Support     |*/
        /* |=====================|============================|====================|=======================|*/
        /* | media               |  type3 keyword | name(MAX) |  MAY be neither    |   MUST                |*/
        /* |---------------------|----------------------------|  or one of, but    |-----------------------|*/
        /* | media-col           |  collection                |  Not both          |   MAY                 |*/
        /* |---------------------|----------------------------|--------------------|-----------------------|*/
        /* | cover-type          |  type2 keyword             |  MUST              |   MUST                |*/
        /* |---------------------|----------------------------|--------------------|-----------------------|*/
        /*                                                                                                  */
        /* 3.1.1 media (type3 keyword | name(MAX)) or media-col (collection)                                */
        /* Either the "media" (defined in [RFC2911] section 4.2.11) or the "media-col" member attribute is  */
        /* used to indicate what media that the Printer MUST use for the specified cover.  The member       */
        /* attributes are the same as those for the "media-col" attribute shown in Table 10.                */
        /*                                                                                                  */
            /* INSERT TABLE 10. FROM PAGE 40  (FOR REFERENCE)                                               */
            /*                                                                                              */
            /*                        Table 10 - "media-col" member attributes                              */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | Attribute name      | attribute syntax           |  request  |  Printer Support |          */
            /* |=====================|============================|===========|==================|          */
            /* | media-key           |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-type          |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-info          |  text(255)                 |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-color         |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-pre-printed   |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-hole-count    |  integer(0:MAX)            |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-order-count   |  integer(1:MAX)            |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-size          |  collection                |    MAY    |         MUST     |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-weight-metric |  integer(0:MAX)            |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-back-coating  |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-front-coating |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
            /* | media-recycled      |  type3 keyword | name(MAX) |    MAY    |         MAY      |          */
            /* |---------------------|----------------------------|-----------|------------------|          */
        /*                                                                                                  */
        /* If the client omits both the "media" and the "media-col" member attributes, then the media       */
        /* currently being used by the Printer object for the document copy SHOULD also be used for the     */
        /* cover.  The client MUST NOT supply both the "media" and the "media-col" member attributes.  If   */
        /* the client supplies such a mal-formed request by supplying both, the Printer MUST either         */
        /*                                                                                                  */
        /*    (1) reject the request and return the 'client-error-bad-request' status code (see [RFC2911]   */
        /*        section 13.1.4.1) or                                                                      */
        /*    (2) use either the "media" or the "media-col" member attribute, independent of the value of   */
        /*        the "ipp-attribute-fidelity" attribute supplied by the client.                            */
        /*                                                                                                  */
        /* Since this "media" member attribute has the same name as the "media" Job Template attribute      */
        /* defined in [RFC2911] section 4.2.11), the "media-supported" (1setOf (type3 keyword | name(MAX))) */
        /* Printer attribute (also defined in [RFC2911] section 4.2.11) identifies the values of this       */
        /* "media" member attribute (as well as the values of the "media" Job Template attribute) that the  */
        /* Printer supports, i.e., the names of the supported media.                                        */
        /*                                                                                                  */
        /* Since this "media-col" member attribute has the same name as the "media-col" Job Template        */
        /* attribute defined in section 3.13), the "media-col-supported" Printer attribute (defined in      */
        /* section 3.13.14) identifies the keyword names of the member attributes supported in this         */
        /* "media-col" member attribute (as well as the keyword names of the "media-col" Job Template       */
        /* attribute), i.e., the names of the member attributes in Table 10 that the Printer supports.      */
        /*                                                                                                  */
        /* 3.1.2 cover-type (type2 keyword)                                                                 */
        /* The "cover-type" member attribute indicates whether covers are wanted and which sides of the     */
        /* cover MUST contain print-stream pages.  The print-stream pages used for printing on a cover come */
        /* from the document data.                                                                          */
        /*                                                                                                  */
        /*        Standard keyword values for "cover-type" are:                                             */
        /*                                                                                                  */
        /*            +---------------+-------------------------------------------------------------------| */
        /*            | 'no-cover'    | No covers are to be produced.                                     | */
        /*            +---------------+-------------------------------------------------------------------| */
        /*            | 'print-none'  | No printing on either side of the cover.                          | */
        /*            +---------------+-------------------------------------------------------------------| */
        /*            | 'print-front' | The front side (side one) of the cover MUST contain a             | */
        /*            |               | print-stream page.                                                | */
        /*            |               |                                                                   | */
        /*            |               | For a front cover ("cover-front") the first print-stream page     | */
        /*            |               | MUST be placed on side one of the front cover sheet (this is the  | */
        /*            |               | outside of the front cover).  The Printer MUST place the second   | */
        /*            |               | print stream page on side one of the first sheet of the output    | */
        /*            |               | document.                                                         | */
        /*            |               |                                                                   | */
        /*            |               | For back cover ("cover-back") the last print-stream page MUST be  | */
        /*            |               | placed on side one of the back cover sheet (this is the inside of | */
        /*            |               | the back cover).  The Printer MUST place the second to last print | */
        /*            |               | stream page on the front or back side of the last sheet of the    | */
        /*            |               | output document depending on whether there are an odd or an even  | */
        /*            |               | number of print stream pages.                                     | */
        /*            +---------------+-------------------------------------------------------------------| */
        /*            | 'print-back'  | The back side (side two) of the cover MUST contain a print-stream | */
        /*            |               | page.                                                             | */
        /*            |               |                                                                   | */
        /*            |               | For a front cover ("cover-front") the first print-stream page     | */
        /*            |               | MUST be placed on side two of the front cover sheet (this is the  | */
        /*            |               | inside of the front cover).  The Printer MUST place the second    | */
        /*            |               | print stream page on side one of the first sheet of the output    | */
        /*            |               | document.                                                         | */
        /*            |               |                                                                   | */
        /*            |               | For a back cover ("cover-back") the last print-stream page MUST   | */
        /*            |               | be placed on side two of the back cover sheet (this is the        | */
        /*            |               | outside of the back cover).  The Printer MUST place the second to | */
        /*            |               | last print stream page on the front or back side of the last      | */
        /*            |               | sheet of the output document depending on whether there are an    | */
        /*            |               | odd or an even number of print stream pages.                      | */
        /*            +---------------+-------------------------------------------------------------------| */
        /*            | 'print-both'  | Both the front and back sides of the cover MUST contain a         | */
        /*            |               | print-stream page.                                                | */
        /*            |               |                                                                   | */
        /*            |               | The front cover MUST contain the first and second print-stream    | */
        /*            |               | pages on the front and back sides of the front cover sheet,       | */
        /*            |               | respectively.  The Printer MUST place the third print stream page | */
        /*            |               | on side one of the first sheet of the output document.            | */
        /*            |               |                                                                   | */
        /*            |               | The back cover MUST contain the second to last and last           | */
        /*            |               | print-stream pages on the front and back sides of the back cover  | */
        /*            |               | sheet, respectively.  The Printer MUST place the third to last    | */
        /*            |               | print stream page on the front or back side of the last sheet of  | */
        /*            |               | the output document depending on whether there are an odd or an   | */
        /*            |               | even number of print stream pages.                                | */
        /*            +---------------+-------------------------------------------------------------------| */
        /*                                                                                                  */
        /* When printing on the back side (side two) of a cover, the value of the "sides" attribute SHOULD  */
        /* be used to determine which edge is the reference edge (i.e., long or short edge).  In the case   */
        /* wehre the "sides" attribute is 'one-sided,' then the reference edge SHOULD be the long edge.     */
        /*                                                                                                  */
        /*    NOTE: If referencing the "sides" attribute is insufficient for determining the reference edge */
        /*          printing on the back side of a cover, then an additional member attribute could be      */
        /*          defined that indicates which edge to reference.  However, the predominate use cases are */
        /*          covered without this additional member attribute.                                       */
        /*                                                                                                  */
        /* In cases where the document data does not contain enough print-stream pages to satisfy the       */
        /* "cover-front" or "cover-back" request, the behavior is implementation dependent.                 */
        /*                                                                                                  */
        /* The "cover-type-supported" (1setOf type2 keyword) Printer attribute identifies the values that   */
        /* the Printer supports, i.e., the keyword cover types supported.                                   */
        /*                                                                                                  */
        /* 3.1.3 cover-front-default (collection) and cover-back-default (collection)                       */
        /* the "cover-front-default" and "cover-back-default" specify the cover that the Printer will       */
        /* provide, if any, if the client omits the "cover-front" or "cover-back" Job Template attribute,   */
        /* respectively.  The member attributes are defined in Table 2.  A Printer MUST support the same    */
        /* member attributes and values for these default attributes as it supports for the corresponding   */
        /* "cover-front" and "cover-back" Job Template attributes.                                          */
        /*                                                                                                  */
        /* 3.1.4 cover-front-supported (1setOf type2 keyword), cover-back-supported (1setOf type2 keyword)  */
        /* The "cover-front-supported" and "cover-back-supported" attributes identify the keyword names of  */
        /* the member attributes supported in the "cover-front" and "cover-back" collection Job Template    */
        /* attributes, respectively, i.e., the keyword names of the member attributes in Table 2 that the   */
        /* Printer supports.                                                                                */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §4.2.11 [page 104-105] media (type3 keyword | name(MAX))                                */
            /* -----------------                                                                            */
            /*  This attribute identifies the medium that the Printer uses for all impressions of the Job.  */
            /*                                                                                              */
            /* The values for "media" include medium-names, medium-sizes, input-trays and electronic forms  */
            /* so that one attribute specifies the media.  If a Printer object supports a medium name as a  */
            /* value of this attribute, such a medium name implicitly selects an input-tray that contains   */
            /* the specified medium.  If a Printer object supports a medium size as a value of this         */
            /* attribute, such a medium size implicitly selects a medium name that in turn implicitly       */
            /* selects an input-tray that contains the medium with the specified size.  If a Printer object */
            /* supports an input-tray as the value of this attribute, such an input-tray implicitly selects */
            /* the medium that is in that input-tray at the time the job prints.  This case includes        */
            /* manual-feed input-trays.  If a Printer object supports an electronic form as the value of    */
            /* this attribute, such an electronic form implicitly selects a medium-name that in turn        */
            /* implicitly selects an input-tray that contains the medium specified by the electronic form.  */
            /* The electronic form also implicitly selects an image that the Printer MUST merge with the    */
            /* document data as its prints each page.                                                       */
            /*                                                                                              */
            /* Standard keyword values are taken from ISO DPA [ISO10175], the Printer MIB [RFC1759], and    */
            /* ASME-Y14.1M [ASME-Y14.1M] and are listed in section 14.  An administrator MAY define         */
            /* additional values using the 'name' or 'keyword' attribute syntax, depending on               */
            /* implementation.                                                                              */
            /*                                                                                              */
    /* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /* author's note: DUE TO THE SIZE & CHANGES OF THE MEDIA TABLE INFO IN RFC2911, IT HAS NOT BEEN INCLUDED*/
    /* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
            /*                                                                                              */
            /* There is also an additional Printer attribute named "media-ready" which differs from         */
            /* "media-supported" in that legal values only include the subset of "media-supported" values   */
            /* that are physically loaded and ready for printing with no operator intervention required. If */
            /* an IPP object supports "media-supported", it NEED NOT support "media-ready".                 */
            /*                                                                                              */
            /* The relationship of this attribute and the other attributes that control document processing */
            /* is described in section 15.3.                                                                */
            /*                                                                                              */
            /* ============================================================================================ */
            /*                                                                                              */
    /* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /* author's note: RFC 2911: Section 15.3 HAS NO RELEVANCE TO THIS ELEME                                 */
    /* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
            /*                                                                                              */
            /* ============================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §13.1.4.1 [page 180] client-error-bad-request (0x0400)                                  */
            /* -----------------                                                                            */
            /* The request could not be understood by the IPP object due to malformed syntax (such as the   */
            /* value of a fixed length attribute whose length does not match the prescribed length for that */
            /* attribute - see the Implementer's Guide [IPP-IIG] ).  The IPP application SHOULD NOT repeat  */
            /* the request without modifications.                                                           */
            /*                                                                                              */
            /* ============================================================================================ */
            /* [PWG 5100.3] February 12, 2001: Candidate Standard 5100.3-2001                               */
            /*                              Internet Printing Protocol(IPP): Production Printing Attributes */
            /*                                  - Set1                                                      */
            /*      §3.13.14 [page 48] media-col-supported (1setOf type2 keyword)                           */
            /* -----------------                                                                            */
            /* The "media-col-supported" Printer attribute identifies the keyword names of the member       */
            /* attributes supported in the "media-col" collection Job Template attribute, i.e., the keyword */
            /* names of the member attributes in Table 10 that the Printer supports.                        */
            /*                                                                                              */
            /* ============================================================================================ */
  /* pwgCoverCollection     jobCoverBack;             /  The back cover to apply this Job.                  */

typedef struct {
        pwgNUM_RNG_DEF* coverTypeDef;                 /* Covers requested and side(s)                       */
        pwgNUM_RNG_DEF* mediaDescTypeDef;             /* Type of media description used                     */
        pwgNUM_RNG_DEF* mediaSizeNameDef;             /* Media (size)                                       */
        pwgNUM_RNG_DEF* mediaTypeDef;                 /* Media Type                                         */
         pwgSTRUCT_DEF* mediaCollectionDef;           /* Actual media description information               */

        VND_JOB_CVR_BACK_DEF_STRUCT

               pwgVOID* last;
} pwgJobCoverBackDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern pwgJobCoverBackDefLst  pwgJobCoverBackDefElem;
extern pwgSTRUCT_DEF          pwgDef_JobCoverBack;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_JOB_COVER_BACK_H__                                                               */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.3.job.cover.back.h ======================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
