/* ================================ pwg.pjt.pjp.3.job.save.disposition.h ================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_JOB_SAVE_DISPOSITION_H__
#define __PWG_PJT_PJP_3_JOB_SAVE_DISPOSITION_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pjp.3.save.disposition.h"
#include "pwg.pjt.pjp.3.save.info.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Job Save Disposition                                                                                     */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.3.3: [page 29] JobSaveDisposition Element                                                        */
/* -----------------                                                                                        */
/* Figure 19 shows the constituent elements of the JobSaveDisposition element.                              */
/*                                                                                                          */
/*                        + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . + */
/*                        . JobSaveDispositionType                                                        . */
/*                        .                                                                               . */
/* +--------------------+ .    +------------+                                                             . */
/* | JobSaveDisposition |-.-+--| attributes |                                                             . */
/* +--------------------+ . |  +------------+                                                             . */
/*                        . |                                                                             . */
/*                        . |  /---------\      + - - - - - - - - +                                       . */
/*                        . +--| -o-o-o- |- + - ! SaveDisposition !                                       . */
/*                        .    \---------/  !   K - - - - - - - - M                                       . */
/*                        .                 !                                                             . */
/*                        .                /             + . . . . . . . . . . . . . . . . . . . . . . +  . */
/*                        .              /               .  SaveInfoType                               .  . */
/*                        .             !                .                                             .  . */
/*                        .             !                .    +------------+                           .  . */
/*                        .             !                . +--| attributes |                           .  . */
/*                        .             !                . |  +------------+                           .  . */
/*                        .             !   + - - - - -+ . |                   + - - - - - - - - - -+  .  . */
/*                        .             + - ! SaveInfo !-.-+               + - ! SaveDocumentFormat !+ .  . */
/*                        .             !   C - - - - -M . |               !   S - - - - - - - - - -M  .  . */
/*                        .             !                . |               !                           .  . */
/*                        .             !                . |  /---------\  !   + - - - - - - - +       .  . */
/*                        .             !                . +--| -o-o-o- |- + - ! SaveLocation  !       .  . */
/*                        .             !                .    \---------/  !   U - - - - - - - M       .  . */
/*                        .             !                .                 !                           .  . */
/*                        .             !                .                 !   + - - - - - +           .  . */
/*                        .             !                .                 + - ! SaveName  !           .  . */
/*                        .             !                .                 !   S - - - - - M           .  . */
/*                        .             !                .                 !                           .  . */
/*                        .             !                .                 !   / - - - - - - -\        .  . */
/*                        .             !                .                 + - ! any ##other  !        .  . */
/*                        .             !                .                     \ - - - - - - -/        .  . */
/*                        .             !                .                         0..infinite         .  . */
/*                        .             !                .                                             .  . */
/*                        .             !                + . . . . . . . . . . . . . . . . . . . . . . +  . */
/*                        .             !                                                                 . */
/*                        .             !   / - - - - - - -\                                              . */
/*                        .             + - | any ##other  |                                              . */
/*                        .                 \ - - - - - - -/                                              . */
/*                        .                     0..infinite                                               . */
/*                        .                                                                               . */
/*                        + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . + */
/*                                                                                                          */
/*                                     Figure 19 JobSaveDisposition                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 50] JobSaveDisposition             */
/* -----------------                                                                                        */
/* Specifies that the PrintService is to save the job as a file that can be re-printed on demand anytime in */
/* the future. (Contains SaveDisposition, SaveInfo)                                                         */
/* [PWG5100.11] §7.9                                                                                        */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                      */
    /*                           Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
    /*      §7.9 [page 39-48] job-save-disposition (collection)                                             */
    /* -----------------                                                                                    */
    /* The OPTIONAL "job-save-disposition" Job Template attribute is used to archive/save the Document Data */
    /* of a job, such that the job can be re-printed on demand at some undefined time in the future. See    */
    /* also section 4.3 of this specification for a detailed description of the Job Save and Reprint        */
    /* Feature.  If the Printer supports the "job-save-disposition" attribute for Saving Jobs, then it      */
    /* MUST also support the "proof-print" attribute for proofing jobs.  However, if the Printer supports   */
    /* the "proof-print" attribute, it NEED NOT support the "job-save-disposition" attribute.               */
    /*                                                                                                      */
    /* If a Printer object is able to save a Job in a particular document format, the Printer MUST be able  */
    /* to process that document format for reprint using the Reprocess-Job and Resubmit-Job operations. See */
    /* section 12.4 Conformance Requirements for the OPTIONAL "job-save-disposition" Job Template attribute */
    /* for additional conformance requirements for clients and Printers.                                    */
    /*                                                                                                      */
    /* Interaction with "job-hold-until" and "job-hold-until-time": The "job-hold-until" attribute causes   */
    /* the job to be moved to the 'pending-held' state, which prevents processing of the job. The           */
    /* "job-save-disposition" attribute on the other hand does not become relevant until the job is moved   */
    /* to the 'processing' state. These two attributes can be used together in the same Job Creation        */
    /* operation with no adverse interactions.                                                              */
    /*                                                                                                      */
    /*    7.9.1  Member Attributes for the "job-save-disposition" Job Template Attribute                    */
    /*        The member attributes of the "job-save-disposition" attribute are:                            */
    /*                                                                                                      */
    /*                           Table 7 - "job-save-disposition" member attributes                         */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              | Member Attribute Name | Attribute Syntax  | Request | Printer Support |               */
    /*              +=======================+===================+=========+=================+               */
    /*              |   save-disposition    |   type3 keyword   |   MUST  |      MUST       |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              |   save-info           | 1setOf collection |   MAY   |      MUST       |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*                                                                                                      */
    /*      7.9.1.1  save-disposition (type3 keyword)                                                       */
    /*          The "save-disposition" member attribute specifies whether or not the job MUST be printed    */
    /*          and/or saved. When a job moves into the 'processing' state, the value of the member         */
    /*          attribute "save-disposition" is checked to determine what is to happen during the           */
    /*          'processing' state.                                                                         */
    /*                                                                                                      */
    /*          The "save-disposition" member attribute specifies processing steps that either MUST occur   */
    /*          or that are prohibited.  However, other processing steps MAY occur during the 'processing'  */
    /*          state, provided they are not prohibited by the value of the "save-disposition" member       */
    /*          attribute.                                                                                  */
    /*                                                                                                      */
    /*          When a Saved Job is reprinted using any of the operations that reprint a Retained Job       */
    /*          (e.g., Reprocess-Job or Resubmit-Job), the Printer MUST NOT copy the "job-save-disposition" */
    /*          attribute from the Saved Job to the copy of the Saved Job so that the job is not re-saved   */
    /*          again.                                                                                      */
    /*                                                                                                      */
    /*              Note: The copy of the Saved Job will be saved again, if the Resubmit-Job operation      */
    /*                    supplies its own "save-job-disposition" attribute.                                */
    /*                                                                                                      */
    /*          Standard keyword values are:                                                                */
    /*                                                                                                      */
    /*              +--------------+---------------------------------------------------------------------+  */
    /*              | Keyword      | Description                                                         |  */
    /*              +==============+=====================================================================+  */
    /*              | 'none'       | The Printer MUST print the job. The Printer MUST NOT save any       |  */
    /*              |              | portion of the job except for processing purposes. The Printer MUST |  */
    /*              |              | NOT apply the  "job-save-disposition-default" attribute.            |  */
    /*              |              |                                                                     |  */
    /*              |              | If the print was successful, the Printer MUST add the               |  */
    /*              |              | 'job-completed-successfully' value to the job's "job-state-reasons" |  */
    /*              |              | attribute.                                                          |  */
    /*              |              |                                                                     |  */
    /*              |              | If the printing had (1) warnings or (2) errors (possibly with       |  */
    /*              |              | warnings), the Printer MUST add the 'job-completed-with-warnings'   |  */
    /*              |              | or 'job-completed-with-errors' value, respectively, to the job's    |  */
    /*              |              | "job-state-reasons" attribute.                                      |  */
    /*              +--------------+---------------------------------------------------------------------+  */
    /*              | 'save-only'  |    The following constraints apply to the 'processing' of the job:  |  */
    /*              |              |                                                                     |  */
    /*              |              |          * The job MUST NOT be printed.                             |  */
    /*              |              |          * The Document Data MUST be saved to the location          |  */
    /*              |              |            specified by the "save-location" member attribute.       |  */
    /*              |              |                                                                     |  */
    /*              |              | The Printer's job scheduling algorithm MAY depend on whether or not |  */
    /*              |              | the job is 'save-only'. However, the Printer MUST save the job      |  */
    /*              |              | while the job is in the 'processing' state (the job's "job-state"   |  */
    /*              |              | attribute is set to 'processing'). Thus the Printer MUST move the   |  */
    /*              |              | job (typically from the 'pending' state) to 'processing' state and  |  */
    /*              |              | add the 'job-saving' value (see description of new                  |  */
    /*              |              | "job-state-reasons" later in section 11.3) to the job's             |  */
    /*              |              | "job-state-reasons" attribute.                                      |  */
    /*              |              |                                                                     |  */
    /*              |              | When the Printer completes saving the job, the Printer MUST move    |  */
    /*              |              | the job to the 'completed' state by setting the job's "job-state"   |  */
    /*              |              | attribute to the 'completed' value and removing the 'job-saving'    |  */
    /*              |              | value (see description of new "job-state-reasons" later in          |  */
    /*              |              | section 11.3) from the job's "job-state-reasons" attribute.         |  */
    /*              |              |                                                                     |  */
    /*              |              | If the save was not successful, the Printer MUST add the            |  */
    /*              |              | 'job-saved-with-warnings' or  'job-saved-with-errors' value to the  |  */
    /*              |              | job's "job-state-reasons" attribute (see description of new         |  */
    /*              |              | "job-state-reasons" later in section 11.3). If the Printer          |  */
    /*              |              | encounters an error during saving, such that a reprint of that job  |  */
    /*              |              | using the Reprocess-Job (see section 4.3.1.1) or Resubmit-Job (see  |  */
    /*              |              | section 4.3.1.2) operations will not produce complete results, the  |  */
    /*              |              | Printer MUST reject the Reprocess-Job or Resubmit-Job with the      |  */
    /*              |              | error client-error-not-possible.                                    |  */
    /*              +--------------+---------------------------------------------------------------------+  */
    /*              | 'print-save' | The following constraints apply to the 'processing' of the job:     |  */
    /*              |              |                                                                     |  */
    /*              |              |          * The job MUST be printed.                                 |  */
    /*              |              |          * The Document Data MUST be saved to the location          |  */
    /*              |              |            specified by the "save-location" member attribute.       |  */
    /*              |              |                                                                     |  */
    /*              |              | The order of the processing steps required for the 'print-save'     |  */
    /*              |              | disposition is implementation dependent. However, the Printer MUST  |  */
    /*              |              | save the job during the same period that it prints the job, namely, |  */
    /*              |              | while the job is in the 'processing' state (the job's "job-state"   |  */
    /*              |              | attribute is set to 'processing'). Thus the Printer MUST move the   |  */
    /*              |              | job (typically from the 'pending' state) to 'processing' state and  |  */
    /*              |              | add the 'job-printing' and 'job-saving' value (see description of   |  */
    /*              |              | new "job-state-reasons" later in section 11.3) to the job's         |  */
    /*              |              | "job-state-reasons" attribute at the appropriate times.             |  */
    /*              |              |                                                                     |  */
    /*              |              | When the Printer completes saving the job, then the Printer MUST    |  */
    /*              |              | move the job to the 'completed' state by setting the job's          |  */
    /*              |              | "job-state" attribute to the 'completed' value and removing the     |  */
    /*              |              | 'job-printing' and 'job-saving' (see description of new             |  */
    /*              |              | "job-state-reasons" later in section 11.3) values from the job's    |  */
    /*              |              | "job-state-reasons" attribute.                                      |  */
    /*              |              |                                                                     |  */
    /*              |              | If both the save and the print were successful, the Printer MUST    |  */
    /*              |              | add the 'job-completed-successfully' value to the job's             |  */
    /*              |              | "job-state-reasons" attribute.                                      |  */
    /*              |              |                                                                     |  */
    /*              |              | If the printing had (1) warnings or (2) errors (possibly with       |  */
    /*              |              | warnings), the Printer MUST add the 'job-completed-with-warnings'   |  */
    /*              |              | or 'job-completed-with-errors' value, respectively.                 |  */
    /*              |              |                                                                     |  */
    /*              |              | As with the 'save-only' value, if the save was not successful, the  |  */
    /*              |              | Printer MUST add the 'job-saved-with-warnings' or                   |  */
    /*              |              | 'job-saved-with-errors' value to the job's "job-state-reasons"      |  */
    /*              |              | attribute (see description of new "job-state-reasons" later in      |  */
    /*              |              | section 11.3).                                                      |  */
    /*              +--------------+---------------------------------------------------------------------+  */
    /*                                                                                                      */
    /*        7.9.1.1.1  save-disposition-supported (1setOf type3 keyword)                                  */
    /*            The "save-disposition-supported (1setOf type3 keyword)" Printer attribute defines the     */
    /*            save dispositions supported by the Printer for the "save-disposition" member attribute    */
    /*            (see standard keyword values in above table).                                             */
    /*                                                                                                      */
    /*      7.9.1.2  save-info (1setOf collection)                                                          */
    /*          The "save-info" member attribute is a collection that contains the attributes that tell the */
    /*          printer how to save the job.  This includes the format in which the Document Data MUST be   */
    /*          saved, and the location to which these are saved.  Multiple save locations or document      */
    /*          formats MAY be saved by specifying multiple collections within this attribute.              */
    /*                                                                                                      */
    /*          If the client supplies the "job-save-disposition" Job Template attribute, but omits the     */
    /*          "save-info" member attribute, the Printer supplies a single collection value for the        */
    /*          "save-info" member attribute from the values of its "save-location-default" attribute, the  */
    /*          job's "job-name", and its "save-document-format-default" attribute (see descriptions        */
    /*          immediately below).                                                                         */
    /*                                                                                                      */
    /*          A client MUST supply in a request a number of collections not to exceed the maximum number  */
    /*          supported specified in the "max-save-info-supported" Printer Description attribute (see     */
    /*          "max-save-info-supported" description in section 10.6). As with any Job Template attribute, */
    /*          if the client does supply more values than the Printer supports and the values of the       */
    /*          "ipp-attribute-fidelity" is 'false' (or omitted), the Printer MUST accept the job, return   */
    /*          the 'successful-ok-ignored-or-substituted-attributes' status code, return the ignored       */
    /*          values in the Ignored Attributes group, use the first n-values, and ignore the remaining    */
    /*          values. If the client does supply more values than the Printer supports and the values of   */
    /*          the "ipp-attribute-fidelity" is 'true', the Printer MUST reject the request and return the  */
    /*          'client-error-request-entity-too-large' status code.                                        */
    /*                                                                                                      */
    /*        7.9.1.2.1  There is no save-info-default Printer attribute                                    */
    /*            There is no "save-info-default" Printer attribute. If the client supplies the             */
    /*            "job-save-disposition" Job Template attribute, but omits the "save-info" member attribute,*/
    /*            the Printer creates a single collection value for the "save-info" member attribute using  */
    /*            from the Printer's "save-location-default" and "save-document-format-default" Printer     */
    /*            attributes and the job's "job-name" attribute (see "save-info" description above).        */
    /*                                                                                                      */
    /*        7.9.1.2.2  save-info-supported (1setOf type2 keyword)                                         */
    /*            The "save-info-supported (1setOf type2 keyword)" attribute identifies the names of the    */
    /*            member attributes supported in the "save-info" collection attribute, i.e., the names of   */
    /*            the member attributes in Table 8 that the Printer supports.                               */
    /*                                                                                                      */
    /*        7.9.1.2.3  Member Attributes for the "save-info" member attribute                             */
    /*            The "save-info" collection member attributes are:                                         */
    /*                                                                                                      */
    /*                              Table 8 - "save-info" member attributes                                 */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              | Member Attribute Name | Attribute Syntax  | Request | Printer Support |               */
    /*              +=======================+===================+=========+=================+               */
    /*              |      save-location    |        uri        |    MAY  |       MUST      |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              |      save-name        |      name(MAX)    |    MAY  |       MAY       |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              |  save-document-format |    mimeMediaType  |    MAY          MUST      |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*                                                                                                      */
    /*          7.9.1.2.3.1  save-location (uri)                                                            */
    /*              The "save-location" member attribute specifies the path to the directory as a URI where */
    /*              the Printer MUST save the Document Data and other information.                          */
    /*                                                                                                      */
    /*              The "save-location" and ("save-location-default" and "save-location-supported")         */
    /*              attribute value MUST be an Absolute URI [RFC2396]. Absolute URIs are specified with a   */
    /*              URI scheme, an optional authority component, and an absolute path (e.g.,                */
    /*              'ftp://printhost.printco.com/var/spool/jobdir/' or 'file:///job-repository/jobdir/').   */
    /*                                                                                                      */
    /*                  Note: As any other member attribute of a Job Template attribute, the Printer        */
    /*                        validates the "save-location" member attribute as follows: If the client      */
    /*                        supplies the "save-location" member attribute, the value MUST match one       */
    /*                        of the values of the Printer's "save-location-supported" (1setOf uri)         */
    /*                        attribute. If the value does not match, the Printer's action depends on       */
    /*                        the value of the job's "ipp-attribute-fidelity" (boolean) attribute: If       */
    /*                        "ipp-attribute-fidelity" is 'false' or omitted, the Printer MUST accept       */
    /*                        the job, return the 'successful-ok-ignored-or-substituted-attributes'         */
    /*                        status code, return the ignored attributes in the Unsupported Attributes      */
    /*                        Group, and perform one of the following actions                               */
    /*                                                                                                      */
    /*                            DEPENDING ON IMPLEMENTATION:                                              */
    /*                                                                                                      */
    /*                                (1) ignore the attribute and not save the job,                        */
    /*                                                                                                      */
    /*                                (2) put the job in the 'held' state and let the operator fix          */
    /*                                    the problem, either by changing the job's "save-location"         */
    /*                                    attribute value or adding the value to the Printer's              */
    /*                                    "save-location-supported" attribute, or                           */
    /*                                                                                                      */
    /*                                (3) substitute the job's "save-location" value with one of the        */
    /*                                    values of the Printer's "save-location-supported" values.         */
    /*                                    If "ipp-attribute-fidelity" is 'true', the Printer MUST           */
    /*                                    reject the request, return the                                    */
    /*                                    'client-error-attributes-or-values-not-supported' status          */
    /*                                    code, along with the "job-save-disposition" attribute in          */
    /*                                    the Unsupported Attributes Group.                                 */
    /*                                                                                                      */
    /*              If the client wants to put the saved job in a sub-directory (whether it exists or not)  */
    /*              of one of the directories specified by the "save-location-supported" Printer attribute, */
    /*              the client supplies that sub-directory name as part of the "save-name" attribute (see   */
    /*              "save-name" description below), not as part of the "save-location" member attribute.    */
    /*                                                                                                      */
    /*                  Note: As with any other 'name', 'integer', 'uri', or 'collection' Job Template      */
    /*                        or Job Template member attribute, the administrator can suspend validation    */
    /*                        by configuring the Printer's "user-defined-values-supported" attribute        */
    /*                        with the 'save-location' keyword (see "user-defined-values-supported"         */
    /*                        description in [PWG5100.3]), so that the user can specify an arbitrary        */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:                             ^^^^^^^^^ Section 5.1 page 65.  Not critical to this file.    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /*                        path and the Printer will accept the job. If the Printer cannot process       */
    /*                        the job using the specified value for "save-location", then the Printer       */
    /*                        MUST hold the job so that an operator can attempt to create the necessary     */
    /*                        sub-directories to populate the path, if they don't already exist, or         */
    /*                        change the job's "save-location" attribute value. See Table 10 below          */
    /*                        entitled "Printer actions for various Job and Printer attribute values",      */
    /*                        at the end of the "job-save-disposition" description.                         */
    /*                                                                                                      */
    /*              If the client supplies the "save-info" member attribute, but omits the "save-location"  */
    /*              member attribute, the Printer supplies the "save-location" member attribute value from  */
    /*              its "save-location-default" attribute (see "save-location-default" description below).  */
    /*                                                                                                      */
    /*              Defined Job Save URI Schemes for use in the "save-location" member attribute include:   */
    /*                                                                                                      */
    /*                          Table 9 - URI Schemes for "save-location" member attribute                  */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*               | URI Scheme | Description                                       | Printer Support |   */
    /*               +============+===================================================+=================+   */
    /*               |    ftp     | Use IETF FTP protocol [RFC959], [RFC2228],        |      SHOULD     |   */
    /*               |            | [RFC2640]                                         |                 |   */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*               |    file    | Use the Printer's configured file system. Since   |       MAY       |   */
    /*               |            | the 'file:' URI scheme cannot be separated from   |                 |   */
    /*               |            | the Printer object's native file system, the      |                 |   */
    /*               |            | semantic of the 'file:' URI scheme is             |                 |   */
    /*               |            | IMPLEMENTATION DEPENDENT. Also the 'file:' URI    |                 |   */
    /*               |            | scheme on some Printer objects MAY be limited to  |                 |   */
    /*               |            | the local file system, while on other Printer     |                 |   */
    /*               |            | objects it MAY be configured to use a network     |                 |   */
    /*               |            | file system.                                      |                 |   */
    /*               |            |                                                   |                 |   */
    /*               |            | The Printer implementation MAY allow the system   |                 |   */
    /*               |            | administrator to configure where the 'file:'      |                 |   */
    /*               |            | scheme is based in the file system.  However, the |                 |   */
    /*               |            | base for the 'file:' scheme MUST be the same as   |                 |   */
    /*               |            | for all other uses of the 'file': scheme, such as |                 |   */
    /*               |            | the value of the "document-uri" operation         |                 |   */
    /*               |            | attribute in a Printer-URI operation (for print   |                 |   */
    /*               |            | by reference of a saved document - see [RFC2911]  |                 |   */
    /*               |            | section 3.2.2 Print-URI operation).               |                 |   */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*               | http       | Use HTTP protocol with the Put operation to save  |      SHOULD     |   */
    /*               |            | the job.                                          |                 |   */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*                                                                                                      */
    /*              It is RECOMMENDED that for each URI scheme supported for saving jobs, that all of these */
    /*              values have the first token in the file path be 'job-repository'. Then an administrator */
    /*              that has to manage the saved jobs for several Printers will have a consistent naming    */
    /*              schemes for locating all the saved jobs by whatever means used to access the saved jobs.*/
    /*              For example, for the 'file:' scheme, all of the values SHOULD start out with:           */
    /*              file:///job-repository/ and for the 'ftp:' scheme, all of the values SHOULD start out   */
    /*              with: ftp://xxx/job-repository/.                                                        */
    /*                                                                                                      */
    /*                  (Note: In URIs, the final "/" is redundant, and the Printer MUST behave the same    */
    /*                         whether or not the final "/" is present).                                    */
    /*                                                                                                      */
    /*            7.9.1.2.3.1.1  save-location-default (uri)                                                */
    /*                The "save-location-default (uri)" Printer attribute indicates the value that the      */
    /*                Printer supplies, if the client omits the "save-location" member attribute from the   */
    /*                "save-info" member attribute.                                                         */
    /*                                                                                                      */
    /*            7.9.1.2.3.1.2  save-location-supported (1setOf uri)                                       */
    /*                The "save-location-supported (1setOf uri)" Printer attribute defines a list of URI    */
    /*                values supported by the Printer object for the "save-location" member attribute (see  */
    /*                above description). The client MUST supply a value of the "save-location" member      */
    /*                attribute that completely matches one of these values. Note: The administrator can    */
    /*                configure the "save-location-supported" to have separate directories for individuals, */
    /*                groups, projects, or MAY just have one directory for all saved jobs. Whether or not   */
    /*                access control is applied to these directories is IMPLEMENTATION DEPENDENT.           */
    /*                                                                                                      */
    /*          7.9.1.2.3.2  save-name (name(MAX))                                                          */
    /*              The "save-name" member attribute specifies the name of the saved job in the directory   */
    /*              specified by the "save-location" member attribute. The client can supply a "save-name"  */
    /*              attribute value that is either a simple file name or a relative path where each         */
    /*              component of the path is separated by a FORWARD SLASH ("/") character.  The             */
    /*              "save-name-subdirectory-supported" Printer Description attribute indicates whether or   */
    /*              not the Printer supports a FORWARD-SLASH ("/") in the "save-name" value. Whether the    */
    /*              FORWARD SLASH when supported is actually implemented as a sub-directory is              */
    /*              IMPLEMENTATION DEPENDENT.                                                               */
    /*                                                                                                      */
    /*              There is no requirement that the "save-name" attribute value in combination with the    */
    /*              "save-location" attribute value specify an identification that is unique. Thus, if the  */
    /*              "save-name" attribute value in combination with the "save-location" attribute value     */
    /*              specifies a handle that already exists, the Printer MUST accept the job and save the    */
    /*              job with the duplicate "save-name" value. This requirement is because a Saved Job is    */
    /*              referenced for re-printing using the "job-id" attribute value assigned by the Printer   */
    /*              that is unique at least with respect to that Printer.                                   */
    /*                                                                                                      */
    /*              If the "save-name" member attribute is not specified by the client in the               */
    /*              "job-save-disposition" Job Template attribute, the Printer object MUST generate a       */
    /*              "save-name" attribute value for the job using the job's "job-name" attribute value.     */
    /*                                                                                                      */
    /*                  Note: Printers MUST generate a "job-name" value, when the client does not supply    */
    /*                        a "job-name" operation attribute (see [RFC2911] section 4.3.5 "job-name",     */
    /*                        so there is always a "job-name" value.                                        */
    /*                                                                                                      */
    /*            7.9.1.2.3.2.1  There is no "save-name-default" Printer attribute                          */
    /*                There is no "save-name-default". If the client omits the "save-name" member attribute */
    /*                when supplying the "save-info" member attribute, the Printer uses the job's           */
    /*                "job-name" attribute as the value of the "save-name" attribute (described above).     */
    /*                                                                                                      */
    /*            7.9.1.2.3.2.2  save-name-supported (boolean)                                              */
    /*                The "save-name-supported (boolean)" attribute indicates support for the OPTIONAL      */
    /*                "save-name" member attribute of the "save-info" member attribute.                     */
    /*                                                                                                      */
    /*                  Note: The means to query the Printer to see what saved jobs it has is a potential   */
    /*                        future extension.                                                             */
    /*                                                                                                      */
    /*            7.9.1.2.3.2.3  save-name-subdirectory-supported (boolean)                                 */
    /*                The "save-name-subdirectory-supported" (boolean) Printer Description attribute        */
    /*                indicates whether the Printer supports a FORWARD SLASH ("/") character in the         */
    /*                "save-name" (name(MAX)) member attribute. If the value is 'false' and the client      */
    /*                supplies a FORWARD-SLASH ("/") in the "save-name" value, the Printer MUST reject the  */
    /*                request and return the 'client-error-attributes-or-values-not-supported'.             */
    /*                                                                                                      */
    /*          7.9.1.2.3.3  save-document-format (mimeMediaType)                                           */
    /*              The "save-document-format" member attribute indicates the document format in which the  */
    /*              job content (Document Data) MUST be saved. If the "job-save-disposition" attribute is   */
    /*              supported, the printer object MUST support the "save-document-format" member attribute. */
    /*                                                                                                      */
    /*              If the client supplies the "save-info" member attribute, but omits the                  */
    /*              "save-document-format" member attribute, the Printer MUST use the value of its          */
    /*              "save-document-format-default" attribute (see above "save-info" description).           */
    /*                                                                                                      */
    /*              Although there can be a many-to-one relationship of documents to a job, all documents   */
    /*              in a job specified with a disposition of 'save' or 'print-save' MUST be saved in the    */
    /*              same format as specified by the "save-document-format" attribute value. A job MAY be    */
    /*              saved to multiple formats by specifying multiple collection values for the "save-info"  */
    /*              member attribute.                                                                       */
    /*                                                                                                      */
    /*              The "job-save-disposition" member attribute (and the "save-document-format" member      */
    /*              attribute) is NOT defined to be used with the "page-overrides" attribute (see           */
    /*              [PWG5100.6]). Thus all documents MUST be saved in the same document format in each      */
    /*              saved job.                                                                              */
    /*                                                                                                      */
    /*              The 'mimeMediaType' values defined for the "save-document-format" attribute are listed  */
    /*              in the Table below. All values MUST include saving PDL data. A Printer MUST support at  */
    /*              least one value. However, at this time, this specification does NOT REQUIRE a Printer   */
    /*              to support any particular formats for saving jobs.                                      */
    /*                                                                                                      */
    /*              If the saved job is submitted to a different make-and-model printer that supports the   */
    /*              same document-format (i.e., the same value of the "document-format" operation attribute */
    /*              in the Document Creation request), then the Printer MUST be able to print the job, but  */
    /*              the output cannot be guaranteed to appear exactly the same as the original output.      */
    /*                                                                                                      */
    /*                +-------------------+-------------------------------------------------------+         */
    /*                | MIME Media Type   | Description                                           |         */
    /*                +===================+=======================================================+         */
    /*                | any PDL document  | If any PDL document-format value is supplied from the |         */
    /*                | format            | Printer's "document-format-supported" attribute, such |         */
    /*                |                   | as 'application/postscript', then the Printer         |         */
    /*                |                   | MUST save the PDL data in that document format.       |         */
    /*                |                   |                                                       |         */
    /*                |                   | Printer implementations are free to store the saved   |         */
    /*                |                   | data in any form they want for convenient, fast,      |         */
    /*                |                   | and/or compact re-printing using Reprocess-Job or     |         */
    /*                |                   | Resubmit-Job, and NEED NOT be identified by a         |         */
    /*                |                   | distinct mimeMediaType value in the                   |         */
    /*                |                   | "save-document-format-supported" Printer attribute. I |         */
    /*                |                   |                                                       |         */
    /*                |                   | The 'application/octet-stream' value MUST NOT be      |         */
    /*                |                   | supplied for this attribute since it doesn't make any |         */
    /*                |                   | sense for saving jobs.                                |         */
    /*                +-------------------+-------------------------------------------------------+         */
    /*                                                                                                      */
    /*              The referenced specifications that define the saved format MUST meet the conformance    */
    /*              requirements listed in section 12.4.2.1.                                                */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:                                  ^^^^^^^^^ Section 12.4.2 page 72.                        */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /*                                                                                                      */
    /*            7.9.1.2.3.3.1  save-document-format-default (mimeMediaType)                               */
    /*                If the client supplies the "save-info" member attribute, but omits the                */
    /*                "save-document-format" member attribute (see above description), the Printer MUST use */
    /*                the value of its "save-document-format-default" (mimeMediaType) attribute.            */
    /*                                                                                                      */
    /*            7.9.1.2.3.3.2  save-document-format-supported (1setOf mimeMediaType)                      */
    /*                The "save-document-format-supported" (1setOf mimeMediaType) attribute specifies the   */
    /*                document formats which a Printer supports for saving jobs.                            */
    /*                                                                                                      */
    /*                If a Printer supports this Job Save & Reprint Feature, the Printer SHOULD be able to  */
    /*                Reprint using the Resubmit-Job operation (see Section 4.3.1.2) for all the formats in */
    /*                which it is capable of saving jobs, i.e., the mimeMediaType values of the Printer's   */
    /*                "document-format-supported" Printer Description attribute SHOULD be a superset of the */
    /*                values of the Printer's "save-document-format-supported" attribute. For example, if   */
    /*                a Printer supports the 'application/X-single-page-tiff' format for saving jobs, it    */
    /*                SHOULD also accept and support a Resubmit-Job operation to reprint that job.          */
    /*                                                                                                      */
    /*          7.9.1.2.3.4  Printer actions for various combinations of attributes                         */
    /*              This section lists the Printer actions for various combinations of "save-location"      */
    /*              (uri), "save-name" (name(MAX)), "save-location-supported" (1setOf uri), existing saved  */
    /*              jobs, ipp-attribute-fidelity (boolean), "user-defined-values-supported" (1setOf         */
    /*              keyword) and Printer actions.                                                           */
    /*                                                                                                      */
    /*              The possible Printer actions are (see above descriptions of "save-location" and         */
    /*              "save-name" for details):                                                               */
    /*                                                                                                      */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | Print Action      | Description                                               |   */
    /*                  +===================+===========================================================+   */
    /*                  |  reject           | The Printer rejects the Job Creation request, returns the |   */
    /*                  |                   | 'client-error-attributes-or-values-not-supported' status  |   */
    /*                  |                   | code and the "job-save-disposition" attribute and value   |   */
    /*                  |                   | in the Unsupported Attributes group.                      |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | accept-save       | The Printer accepts the Job Creation request, returns the |   */
    /*                  |                   | 'successful-ok' status code, and attempts to create all   |   */
    /*                  |                   | necessary files and sub-directories.                      |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | accept-substitute | The Printer accepts the Job Creation request, returns the |   */
    /*                  |                   | 'successful-ok-ignored-or-substituted-attributes' status  |   */
    /*                  |                   | code and the "job-save-disposition" attribute and value   |   */
    /*                  |                   | in the Unsupported Attributes group, and, DEPENDING ON    |   */
    /*                  |                   | IMPLEMENTATION:                                           |   */
    /*                  |                   |     (1) ignores the attribute and does not perform the    |   */
    /*                  |                   |         save,                                             |   */
    /*                  |                   |     (2) puts the job in the 'held' state and let the      |   */
    /*                  |                   |         operator fix the problem, either by changing the  |   */
    /*                  |                   |         job's "save-location" attribute value or adding   |   */
    /*                  |                   |         the value to the Printer's                        |   */
    /*                  |                   |         "save-location-supported" attribute, or           |   */
    /*                  |                   |     (3) substitutes the job's "save-location" value with  |   */
    /*                  |                   |         one of the values of the Printer's                |   */
    /*                  |                   |         "save-location-supported" values.                 |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | accept-hold       | The Printer accepts the Job Creation request, returns the |   */
    /*                  |                   | 'successful-ok' status code, and holds the job for the    |   */
    /*                  |                   | operator to resolve the conflict so that the job can be   |   */
    /*                  |                   | saved.                                                    |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                                                                                                      */
    /*              Table 10 shows the Printer actions for the various possible value combinations of the   */
    /*              other Job and Printer attributes. In the example, there is already one saved job:       */
    /*              'a/bar'. The Printer supports three save-location directories: a, b, c.                 */
    /*                                                                                                      */
    /*                   Table 10 - Printer actions for various Job and Printer attribute values            */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | MIME  | save- | save-     | existing | ipp-       | user-defined-    | Printer           | */
    /*         | Media | name  | location- | saved    | attribute- | values-supported | action            | */
    /*         | Type  |       | supported | jobs     | fidelity   |                  |                   | */
    /*         +=======+=======+===========+==========+============+==================+===================+ */
    /*         | a     | foo   | a, b, c   | a/bar    | T or F     | none             | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | d/foo | a, b, c   | a/bar    | T or F     | none             | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | bar   | a, b, c   | a/bar    | T or F     | none             | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | F          | none             | accept-substitute | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | T          | none             | reject            | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | F          | none             | accept-substitute | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | T          | none             | reject            | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | foo   | a, b, c   | a/bar    | T or F     | save-location    | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | d/foo | a, b, c   | a/bar    | T or F     | save-location    | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | bar   | a, b, c   | a/bar    | T or F     | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | F          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | T          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | F          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | T          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*                                                                                                      */
    /*    7.9.2  job-save-disposition-default (collection)                                                  */
    /*        The "job-save-disposition-default (collection)" attribute specifies the                       */
    /*        "job-save-disposition" member attributes and values that the Printer will provide, if any, if */
    /*        the client omits the "job-save-disposition" collection attribute. A Printer MUST support the  */
    /*        same member attributes for these default attributes as it supports for the corresponding Job  */
    /*        Template attributes (see Table 7).                                                            */
    /*                                                                                                      */
    /*        The "save-info" (1setOf collection) member attribute of the "job-save-disposition-default"    */
    /*        Printer attribute specifies the save information member attributes and values that the        */
    /*        Printer will provide, if any, if the client omits the "job-save-disposition" Job Template     */
    /*        attribute entirely. A Printer MUST support the same member attributes for these default       */
    /*        attributes as it supports for the corresponding Job Template attributes (see Table 7 and      */
    /*        Table 8), with the single exception, that the "save-name" member attribute MUST NOT be        */
    /*        supported (since the Printer MUST use the "job-name" attribute to generate the default        */
    /*        "save-name").                                                                                 */
    /*                                                                                                      */
    /*        If the client supplies the "job-save-disposition" Job Template attribute, but omits the       */
    /*        "save-info" member attribute, the Printer uses its "save-location-default" and                */
    /*        "save-disposition-default" Printer attributes and the job's "job-name" attribute to create    */
    /*        the job's "save-info" member attribute, rather than using the "save-info" member attribute    */
    /*        of the Printer's "job-save-disposition-default" attribute (see "save-info" description above).*/
    /*                                                                                                      */
    /*    7.9.3  job-save-disposition-supported (1setOf type2 keyword)                                      */
    /*        The "job-save-disposition-supported (1setOf type2 keyword)" attribute identifies the names    */
    /*        of the member attributes supported in the "job-save-disposition" collection attribute, i.e.,  */
    /*        the names of the member attributes in Table 7 that the Printer supports.  The RECOMMENDED way */
    /*        for a client to determine whether or not a Printer support saving jobs, is to query this      */
    /*        Printer attribute.                                                                            */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*      §4.3 [page 18-19] Job Save and Reprint OPTIONAL Feature                                     */
        /* -----------------                                                                                */
        /* The Job Save and Reprint Feature is additional OPTIONAL functionality to allow a user to save a  */
        /* print job as part of job processing and print a copy of it at another time.  A client requests   */
        /* a Printer to save a print job by supplying the "job-save-disposition" (collection) Job Template  */
        /* attribute (see section 7.9) when submitting the job. In this case, the Printer retains the job   */
        /* indefinitely in the so-called Job Retention Phase (see [RFC2911] section 4.3.7.2 Partitioning of */
        /* Job Sates) in the job's terminal state ('completed', 'aborted', or 'canceled') after processing  */
        /* it, rather than aging the job out after an implementation-defined period. In other words, a      */
        /* Saved Job is just a Retained Job that the Printer is retaining indefinitely. When saving a job,  */
        /* a user MAY specify saving the Document Data, and specify the format in which the print data is   */
        /* saved. These semantics necessitate the definition of additional values for the                   */
        /* "job-state-reasons" Job Description attribute, the "job-save-printer-make-and-model" Job         */
        /* Description attribute (see section 9.1), and the use of the Reprocess-Job and Resubmit-Job       */
        /* operations to print these saved jobs.                                                            */
        /*                                                                                                  */
        /* This section, in conjunction with the description of the "job-save-disposition" Job Template     */
        /* attribute (see section 7.9) fully describe the Job Save and Reprint Feature. If a Printer        */
        /* supports the Job Save and Reprint Feature, then it MUST also support the Proof Print Feature     */
        /* (see section 4.4). See section 12.4 Conformance Requirements for the OPTIONAL                    */
        /* "job-save-disposition" Job Template attribute for additional conformance requirements for        */
        /* clients and Printers.                                                                            */
        /*                                                                                                  */
        /*    4.3.1  Reprinting Saved Jobs                                                                  */
        /*        This section defines the method by which to reprint a copy of the Saved Job using the     */
        /*        Reprocess-Job and Resubmit-Job operations. The Reprocess-Job operation is defined in      */
        /*        [RFC3998] and Resubmit-Job is defined in this document and operates on any Retained       */
        /*        Job, whether or not it is a Saved Job.                                                    */
        /*                                                                                                  */
        /*      4.3.1.1  Reprinting using the Reprocess-Job operation                                       */
        /*          The Reprocess-Job operation [RFC3998] re-processes a copy of any Retained Job after     */
        /*          processing was completed, canceled, or aborted. In order to prevent the Printer from    */
        /*          aging out a Retained Job, the client can supply a "job-save-disposition" Job Template   */
        /*          attribute (see section 7.9) in a job submission. In this case the Printer retains the   */
        /*          job (until removed by a Delete-Job or Purge-Jobs operation ) as a Saved Job, so that a  */
        /*          client can reprint the job using Reprocess-Job any time subsequently. When reprinting a */
        /*          Saved Job, the Printer MUST NOT copy the "job-save-disposition" attribute to the copy;  */
        /*          otherwise, the job would be saved again. Similarly, when reprinting a Proof Print Job,  */
        /*          the Printer MUST NOT copy the "proof-print" attribute to the job copy; otherwise, the   */
        /*          job would be proofed again.                                                             */
        /*                                                                                                  */
        /*      4.3.1.2  Reprinting using the Resubmit-Job operation                                        */
        /*          The Resubmit-Job operation (see section 5.4 below for a complete description)           */
        /*          re-processes a copy of any Retained Job in the same way as Reprocess-Job (see           */
        /*          section 4.3.1.1), with the addition of being able to supply additional operation and    */
        /*          Job Template attributes that will affect the processing of that copy of the job by      */
        /*          either override the values of existing attributes or providing additional attributes.   */
        /*          The Resubmit-Job operation has the same structure as the Print-URI operation (see       */
        /*          [RFC2911] section 3.2.2) except that the "job-id" (integer(1:MAX)) operation attribute  */
        /*          MUST take the place of the "document-uri" (uri) operation attribute.                    */
        /*                                                                                                  */
        /* ================================================================================================ */
            /* [rfc2911] September 2000: Standards Track                                                    */
            /*                              Internet Printing Protocol/1.1: Model and Semantics             */
            /*      §4.3.7.2 [page 112-113] Partitioning of Job States                                      */
            /* -----------------                                                                            */
            /* This section partitions the 7 job states into phases:                                        */
            /*                                                                                              */
            /*    Job Not Completed,                                                                        */
            /*    Job Retention,                                                                            */
            /*    Job History, and                                                                          */
            /*    Job Removal.                                                                              */
            /*                                                                                              */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: The 7 Job States are:                                                                     */
/*                    pending                                                                               */
/*                    pending-held                                                                          */
/*                    processing                                                                            */
/*                    processing-stopped                                                                    */
/*                    canceled                                                                              */
/*                    aborted                                                                               */
/*                    completed                                                                             */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
            /*                                                                                              */
            /* This section also explains the 'job-restartable' value of the "job-state-reasons" Job        */
            /* Description attribute for use with the Restart-Job operation.                                */
            /*                                                                                              */
            /*    Job Not Completed: When a job is in the 'pending', 'pending-held', 'processing', or       */
            /*                       'processing-stopped' states, the job is not completed.                 */
            /*                                                                                              */
            /*    Job Retention:     When a job enters one of the three terminal job states:  'completed',  */
            /*                       'canceled', or 'aborted', the IPP Printer object MAY "retain" the job  */
            /*                       in a restartable condition for an implementation-defined time period.  */
            /*                       This time period MAY be zero seconds and MAY depend on the terminal    */
            /*                       job state.  This phase is called Job Retention.  While in the Job      */
            /*                       Retention phase, the job's document data is retained and a client may  */
            /*                       restart the job using the Restart-Job operation.  If the IPP object    */
            /*                       supports the Restart-Job operation, then it SHOULD indicate that the   */
            /*                       job is restartable by adding the 'job-restartable' value to the job's  */
            /*                       "job-state-reasons" attribute (see Section 4.3.8) during the Job       */
            /*                       Retention phase.                                                       */
            /*                                                                                              */
            /*    Job History:       After the Job Retention phase expires for a job, the Printer object    */
            /*                       deletes the document data for the job and the job becomes part of the  */
            /*                       Job History.  The Printer object MAY also delete any number of the     */
            /*                       job attributes.  Since the job is no longer restartable, the Printer   */
            /*                       object MUST remove the 'job-restartable' value from the job's          */
            /*                       "job-state-reasons" attribute, if present.                             */
            /*                                                                                              */
            /*    Job Removal:       After the job has remained in the Job History for an                   */
            /*                       implementation-defined time, such as when the number of jobs exceeds a */
            /*                       fixed number or after a fixed time period (which MAY be zero seconds), */
            /*                       the IPP Printer removes the job from the system.                       */
            /*                                                                                              */
            /* Using the Get-Jobs operation and supplying the 'not-completed' value for the "which-jobs"    */
            /* operation attribute, a client is requesting jobs in the Job Not Completed phase.  Using the  */
            /* Get-Jobs operation and supplying the 'completed' value for the "which-jobs" operation        */
            /* attribute, a client is requesting jobs in the Job Retention and Job History phases.  Using   */
            /* the Get-Job-Attributes operation, a client is requesting a job in any phase except Job       */
            /* Removal.  After Job Removal, the Get-Job-Attributes and Get-Jobs operations no longer are    */
            /* capable of returning any information about a job.                                            */
            /*                                                                                              */
            /* ============================================================================================ */
            /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                              */
            /*                   Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
            /*      §4.4 [page 19] Job Proof Print REQUIRED Feature                                         */
            /* -----------------                                                                            */
            /* The Proof Print Feature is additional REQUIRED functionality to allow a user to print a      */
            /* Proof Print Job and to save it as part of job processing in such a way that users can submit */
            /* a request to print a copy of the Proof Print Job at a later time. A client requests a        */
            /* Printer to print and save a Proof Print Job by supplying the "proof-print" (collection) Job  */
            /* Template attribute (see section 7.11) when submitting the job. In this case, the Printer     */
            /* retains the Proof Print Job indefinitely in the so-called Job Retention Phase (see [RFC2911] */
            /* section 4.3.7.2 Partitioning of Job Sates) in the job's terminal state ('completed',         */
            /* 'aborted',* or 'canceled') after processing it, rather than aging the job out after an       */
            /* implementation-defined period. In other words, a Proof Print Job is just a Retained Job that */
            /* the Printer is retaining indefinitely.  A client can then request the Printer to reprint a   */
            /* copy of the Proof Print Job using the Reprocess-Job operation (using the original "copies"   */
            /* and "media" attributes - see section 4.3.1.1) and a modified copy of the job using the       */
            /* Resubmit-Job operation (see section 4.3.1.2).  See section 12.5 Conformance Requirements for */
            /* the REQUIRED "proof-print" Job Template attribute for additional conformance requirements    */
            /* for clients and Printers.                                                                    */
            /*                                                                                              */
        /* ================================================================================================ */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*      §11.3 [page 63-66] job-state-reasons (1setOf type2 keyword) Job Description attribute       */
        /* -----------------                                                                                */
        /* The following table defines additional keyword values for the IPP "job-state-reasons" Job        */
        /* Description attribute (see [RFC2911], [RFC3998], [PWG5100.3], and [PWG5100.6]. The descriptions  */
        /* indicate conditional conformance, if any.                                                        */
        /*                                                                                                  */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  | Keyword                           | Description                                             | */
        /*  +===================================+=========================================================+ */
        /*  |'job-delay-output-until-specified' | The value of the job's "job-delay-output-until" or      | */
        /*  |                                   | "job-delay-output-until-time" Job Template attribute    | */
        /*  |                                   | was specified with a time period or date-time,          | */
        /*  |                                   | respectively, that is still in the future. The job MUST | */
        /*  |                                   | NOT produce output before this reason is removed        | */
        /*  |                                   | (whether or not the implementation holds the job - see  | */
        /*  |                                   | sections 7.4 and 7.5). This value MUST be supported if  | */
        /*  |                                   | the "job-delay-output-until" or                         | */
        /*  |                                   | "job-delay-output-until-time" Job Template attribute is | */
        /*  |                                   | supported.                                              | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-password-wait'                | The job is currently being held until the correct       | */
        /*  |                                   | password is entered at the device. If the               | */
        /*  |                                   | "job-password" Operation attribute (See section 6.1) is | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-printed-successfully'         | The job was successfully printed, but was not           | */
        /*  |                                   | successfully saved as indicated by                      | */
        /*  |                                   | 'job-saved-with-warnings' or 'job-saved-with-errors'.   | */
        /*  |                                   | If the job was not requested to be saved, then use the  | */
        /*  |                                   | 'job-completed-successfully' value instead. If the      | */
        /*  |                                   | "job-save-disposition" Job Template attribute is        | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-printed-with-errors'          | The job was printed with errors, but was successfully   | */
        /*  |                                   | saved as indicated by 'job-saved-successfully' or was   | */
        /*  |                                   | not successfully saved as indicated by                  | */
        /*  |                                   | 'job-saved-with-warnings' or 'job-saved-with-errors'.   | */
        /*  |                                   | If the job was not requested to be saved, then use the  | */
        /*  |                                   | 'job-completed-with-errors' value instead. If the       | */
        /*  |                                   | "job-save-disposition" Job Template attribute is        | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-printed-with-warnings'        | The job was printed with warnings, but was successfully | */
        /*  |                                   | saved as indicated by 'job-saved-successfully' or was   | */
        /*  |                                   | not successfully saved as indicated by                  | */
        /*  |                                   | 'job-saved-with-warnings' or 'job-saved-with-errors'.   | */
        /*  |                                   | If the job was not requested to be saved, then use the  | */
        /*  |                                   | 'job-completed-with-warnings' value instead. If the     | */
        /*  |                                   | "job-save-disposition" Job Template attribute is        | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-resuming'                     | The printer is in the process of moving the job from a  | */
        /*  |                                   | suspended condition to a candidate for processing. If   | */
        /*  |                                   | the Resume-Job operation [RFC3998] is supported, this   | */
        /*  |                                   | value MUST be supported.                                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-saved-successfully'           | The job was successfully saved. The Printer MUST also   | */
        /*  |                                   | supply 'job-completed-successfully', except when        | */
        /*  |                                   | "save-disposition" = 'save-only'.  If the               | */
        /*  |                                   | "job-save-disposition" Job Template attribute is        | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-saved-with-errors'            | The job did not save successfully (whether or not it    | */
        /*  |                                   | was printed successfully, printed with warnings,        | */
        /*  |                                   | printed with errors, or not printed).  The Printer MUST | */
        /*  |                                   | ensure that none of the saved job is accessible, if it  | */
        /*  |                                   | was unable to successfully save all of the job. If the  | */
        /*  |                                   | "job-save-disposition" Job Template attribute is        | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-saved-with-warnings'          | The job was saved with warnings. If the                 | */
        /*  |                                   | "job-save-disposition" Job Template attribute is        | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-saving'                       | The printer is transmitting the job to the save         | */
        /*  |                                   | location. This is similar to the 'job-printing' value.  | */
        /*  |                                   | If the "job-save-disposition" Job Template attribute is | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-spooling'                     | Same as 'job-incoming' with the specialization that the | */
        /*  |                                   | Printer is spooling the document data before processing | */
        /*  |                                   | it. This value corresponds to the 'spool' or 'automatic'| */
        /*  |                                   | value of the "job-spooling-supported" Printer           | */
        /*  |                                   | Description attribute.                                  | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-streaming'                    | Same as 'job-incoming' with the specialization that the | */
        /*  |                                   | Printer is processing the document data as it is being  | */
        /*  |                                   | received (that is, the job is not being spooled, but    | */
        /*  |                                   | rather is being processed in chunks by the output       | */
        /*  |                                   | device and is being imaged during reception). This      | */
        /*  |                                   | value corresponds to the 'stream' or 'automatic' value  | */
        /*  |                                   | of the "job-spooling-supported" Printer Description     | */
        /*  |                                   | attribute.                                              | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-suspended-by-operator'        | The job has been indefinitely suspended by the printer  | */
        /*  |                                   | operator. If the Suspend-Current-Job operation          | */
        /*  |                                   | [RFC3998] is supported, this value MUST be supported.   | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-suspended-by-system'          | The job has been indefinitely suspended by the          | */
        /*  |                                   | Printer's system software during normal processing of   | */
        /*  |                                   | the job.                                                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-suspended-by-user'            | The job has been indefinitely suspended by the user. If | */
        /*  |                                   | the Suspend-Current-Job operation [RFC3998] is          | */
        /*  |                                   | supported, this value MUST be supported.                | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  |'job-suspending'                   | The printer is in the process of moving the job from a  | */
        /*  |                                   | processing condition to a suspended condition where     | */
        /*  |                                   | other jobs can be processed. If the Suspend-Current-Job | */
        /*  |                                   | operation [RFC3998] is supported, this value MUST be    | */
        /*  |                                   | supported.                                              | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*                                                                                                  */
        /*      NOTE: The semantics of this attribute or the set of valid values may be different for       */
        /*            different document formats.                                                           */
        /*                                                                                                  */
        /*    11.3.1 Additional Semantics for "job-state-reasons" attribute for                             */
        /*           "job-hold-until-time" attribute                                                        */
        /*        This section adds additional semantics to the 'job-hold-until-specified' value defined in */
        /*        other standards:                                                                          */
        /*                                                                                                  */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*  | Keyword                           | Description                                             | */
        /*  +===================================+=========================================================+ */
        /*  | 'job-hold-until-specified'        | The value of the job's "job-hold-until" [RFC2911] or    | */
        /*  |                                   | "job-hold-until-time" (see section 7.6 above) Job       | */
        /*  |                                   | Template attribute was specified with a time period     | */
        /*  |                                   | that is still in the future. The job MUST NOT be a      | */
        /*  |                                   | candidate for processing before this reason is removed  | */
        /*  |                                   | and there are no other reasons to hold the job. This    | */
        /*  |                                   | value SHOULD be supported if the "job-hold-until" Job   | */
        /*  |                                   | Template attribute is supported.                        | */
        /*  +-----------------------------------+---------------------------------------------------------+ */
        /*                                                                                                  */
        /*    11.3.2 Additional Semantics for "job-state-reasons" attribute for                             */
        /*           "job-save-disposition" attribute                                                       */
        /*        This section defines additional values that are defined in support of the                 */
        /*        "job-save-disposition" attribute in section 7.9).                                         */
        /*                                                                                                  */
        /*        Many of the existing "job-state-reasons" attribute values can apply to a 'save-only' job  */
        /*        as well as a job submitted for printing. If the value of the "job-disposition" attribute  */
        /*        is 'save-only', the "job-state-reasons" attribute MAY be set with existing values such    */
        /*        as 'job-incoming', 'resources-are-not-ready' (such as a font), 'job-interpreting', and    */
        /*        'job-queued'. Likewise, errors that occur on a saved job MAY have existing                */
        /*        "job-state-reasons" attribute values such as 'job-data-insufficient',                     */
        /*        'document-access-error', 'submission-interrupted', 'job-canceled-by-user',                */
        /*        'aborted-by-system', etc.                                                                 */
        /*                                                                                                  */
        /*        There are also new four new "job-state-reasons" keyword values REQUIRED that support a    */
        /*        saved job -- 'job-saving', 'job-saved-successfully', 'job-saved-with-warnings', and       */
        /*        'job-saved-with-errors' -- and these have been added to the list defined above. The       */
        /*        existing 'job-completed-successfully', job-completed-with-warnings', and                  */
        /*        'job-completed-with-errors' values are also clarified in the list above for               */
        /*        implementations that support the "job-save-disposition" Job Template attribute, in such   */
        /*        a way that these values remain compatible with Printers and clients that do not support   */
        /*        job saving.                                                                               */
        /*                                                                                                  */
        /*        Table 14 enumerates the possible combinations of print and save success, warning, and     */
        /*        error conditions.  Note that two values occur only when there are print warnings/errors   */
        /*        and a save error.                                                                         */
        /*                                                                                                  */
        /*              Table 14 - Values of "job-state-reasons" attribute for various job conditions       */
        /*            +------------------+-------------------+-------------------+--------------------+     */
        /*            |                  |         Not       |       Save was    |      Save was      |     */
        /*            |                  |       Saving      |      Successful   |     Unsuccessful   |     */
        /*            +==================+===================+===================+====================+     */
        /*            |   Not printing   | <not possible>    | 'job-completed-   | 'job-saved-        |     */
        /*            |                  |                   |    successfully'  |    with-errors'    |     */
        /*            +------------------+-------------------+-------------------+--------------------+     */
        /*            | Print successful | 'job-completed-   |'job-completed-    | 'job-saved         |     */
        /*            |                  |    successfully'  |   successfully'   |    with-errors'    |     */
        /*            +------------------+-------------------+-------------------+--------------------+     */
        /*            | Print warnings   | 'job-completed-   | 'job-completed-   | 'job-completed-    |     */
        /*            |                  |    with-warnings' |    with-warnings' |    with-warnings', |     */
        /*            |                  |                   |                   | 'job-saved-        |     */
        /*            |                  |                   |                   |    with-errors'    |     */
        /*            +------------------+-------------------+-------------------+--------------------+     */
        /*            | Print errors     | 'job-completed-   | 'job-completed-   | 'job-completed     |     */
        /*            |                  |    with-errors'   |    with-errors'   |    with-errors',   |     */
        /*            |                  |                   |                   | 'job-saved-        |     */
        /*            |                  |                   |                   |    with-errors'    |     */
        /*            +------------------+-------------------+-------------------+--------------------+     */
        /*            | Print warnings   | 'job-completed-   | 'job-completed-   | 'job-completed-    |     */
        /*            |    and errors    |    with-errors'   |    with-errors'   |    with-errors',   |     */
        /*            |                  |                   |                   | 'job-saved-        |     */
        /*            |                  |                   |                   |    with-errors'    |     */
        /*            +------------------+-------------------+-------------------+--------------------+     */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*      §10.6 [page 58] max-save-info-supported (integer(1:MAX))                                    */
        /* -----------------                                                                                */
        /* This attribute specifies the maximum number of "save-info" member attribute collections that a   */
        /* Printer can accept in a job request. If the number of "save-info" member attribute collections   */
        /* supplied by a client in a Job Creation operation exceeds the value of this attribute, the        */
        /* Printer MUST accept or reject the request as described in the "save-info" description in the     */
        /* "job-save-disposition" description (see description in section 7.9). If the Printer only         */
        /* supports one "save-info" collection, then the Printer MAY either                                 */
        /*                                                                                                  */
        /*    (1) support this attribute with a value of '1' or                                             */
        /*    (2) omit support of this attribute.                                                           */
        /*                                                                                                  */
        /* The RECOMMENDED way for a client to determine whether or not a Printer supports saving jobs, is  */
        /* to query the "job-save-disposition-supported" Printer attribute (see description in              */
        /* section 7.9.3).                                                                                  */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §3.2.2 [page 48-49] Print-URI Operation                                                     */
        /* -----------------                                                                                */
        /* This OPTIONAL operation is identical to the Print-Job operation (section 3.2.1) except that a    */
        /* client supplies a URI reference to the document data using the "document-uri" (uri) operation    */
        /* attribute (in Group 1) rather than including the document data itself.  Before returning the     */
        /* response, the Printer MUST validate that the Printer supports the retrieval method (e.g., http,  */
        /* ftp, etc.) implied by the URI, and MUST check for valid URI syntax.  If the client-supplied URI  */
        /* scheme is not supported, i.e. the value is not in the Printer object's                           */
        /* "referenced-uri-scheme-supported" attribute, the Printer object MUST reject the request and      */
        /* return the 'client-error-uri-scheme-not-supported' status code.                                  */
        /*                                                                                                  */
        /* The IPP Printer MAY validate the accessibility of the document as part of the operation or       */
        /* subsequently.  If the Printer determines an accessibility problem before returning an operation  */
        /* response, it rejects the request and returns the 'client-error-document-access-error' status     */
        /* code.  The Printer MAY also return a specific document access error code using the               */
        /* "document-access-error" operation attribute (see section 3.1.6.4).                               */
        /*                                                                                                  */
        /* If the Printer determines this document accessibility problem after accepting the request and    */
        /* returning an operation response with one of the successful status codes, the Printer adds the    */
        /* 'document-access-error' value to the job's "job-state-reasons" attribute and MAY populate the    */
        /* job's "job-document-access-errors" Job Description attribute (see section 4.3.11).  See The      */
        /* Implementer's Guide [IPP-IIG] for suggested additional checks.                                   */
        /*                                                                                                  */
        /* If the Printer object supports this operation, it MUST support the                               */
        /* "reference-uri-schemes-supported" Printer attribute (see section 4.4.27).                        */
        /*                                                                                                  */
        /* It is up to the IPP object to interpret the URI and subsequently "pull" the document from the    */
        /* source referenced by the URI string.                                                             */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §4.3.5 [page 108-109] job-name (name(MAX))                                                  */
        /* -----------------                                                                                */
        /* This REQUIRED attribute is the name of the job.  It is a name that is more user friendly than    */
        /* the "job-uri" attribute value.  It does not need to be unique between Jobs.  The Job's           */
        /* "job-name" attribute is set to the value supplied by the client in the "job-name" operation      */
        /* attribute in the create request (see Section 3.2.1.1).   If, however, the "job-name" operation   */
        /* attribute is not supplied by the client in the create request, the Printer object, on creation   */
        /* of the Job, MUST generate a name.  The printer SHOULD generate the value of the Job's "job-name" */
        /* attribute from the first of the following sources that produces a value:                         */
        /*                                                                                                  */
        /*    1) the "document-name" operation attribute of the first (or only) document,                   */
        /*                                                                                                  */
        /*    2) the "document-URI" attribute of the first (or only) document, or                           */
        /*                                                                                                  */
        /*    3) any other piece of Job specific and/or Document Content information.                       */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*   §12.4.2 [page 72-73] Printer Conformance Requirements for the 'job-save-disposition" attribute */
        /* -----------------                                                                                */
        /* In order to claim conformance for the OPTIONAL "job-save-dispositions" Job Template attribute,   */
        /* Printers:                                                                                        */
        /*                                                                                                  */
        /*    1. MUST support the "job-save-disposition" (collection) Job Template attribute according to   */
        /*       the description in section 7.9, including the member attributes as REQUIRED by Table 7 and */
        /*       the "job-save-disposition-default" attribute and the "job-save-disposition-supported"      */
        /*       attribute.                                                                                 */
        /*                                                                                                  */
        /*    2. MUST support all of the "save-disposition" member attribute values defined in the          */
        /*       "job-save-disposition" description section 7.9.                                            */
        /*                                                                                                  */
        /*    3. MUST support the "save-info" (collection) member attribute according to the                */
        /*       "job-save-disposition" attribute description in section 7.9, including the member          */
        /*       attributes as REQUIRED by Table 8 and the "save-location-supported",                       */
        /*       "save-name-supported", "save-document-format-supported", and "save-info-supported" Printer */
        /*       attributes.                                                                                */
        /*                                                                                                  */
        /*    4. SHOULD support the 'ftp:', and 'http:' schemes and MAY support 'file:' scheme for use in   */
        /*       the "save-location" member attribute as defined in the "job-save-disposition" attribute    */
        /*       description in section 7.9.                                                                */
        /*                                                                                                  */
        /*    5. MUST support at least one "save-document-format" (mimeMediaType) attribute value, as       */
        /*       defined in the "job-save-disposition" attribute description in section 7.9, for use in the */
        /*       "save-document-format" member attribute.                                                   */
        /*                                                                                                  */
        /*    6. SHOULD support a superset of the values of the Printer's "save-document-format-supported"  */
        /*       attribute (section 7.9.1.2.3.3.2) as the values of the Printer's                           */
        /*       "document-format-supported" attribute ([RFC2911] section 4.4.22).                          */
        /*                                                                                                  */
        /*    7. MUST support the "job-save-printer-make-and-model" Job Description attribute (see          */
        /*       section 9.1).                                                                              */
        /*                                                                                                  */
        /*    8. MUST support the "which-jobs-supported" Printer Description attribute (see section 10.9)   */
        /*       and the 'saved' keyword values (see section 11.2).                                         */
        /*                                                                                                  */
        /*    9. MUST support the 'job-saving', 'job-saved-successfully', 'job-saved-with-warnings', and    */
        /*       'job-saved-with-errors' values of the "job-state-reasons" Job Description attribute as     */
        /*       defined in the "job-state-reasons" attribute description in section 11.3.                  */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef struct {
    pwgSaveDispositionEnum  saveDisposition;          /* Must the PrintService print and/or save the job.   */
               pwgSaveInfo  saveInfo;                 /* A sets of elements for each copy of the saved job. */

               VND_JOB_SAV_DISP_STRUCT

} pwgJobSaveDisposition, *pwgJSDID;

typedef struct {
            pwgNUM_RNG_DEF* saveDisposition;          /* Must the PrintService print and/or save the job.   */
             pwgSTRUCT_DEF* saveInfo;                 /* A sets of elements for each copy of the saved job. */

            VND_JOB_SAV_DISP_DEF_STRUCT

                   pwgVOID* last;
} pwgJobSaveDispositionDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern  pwgJobSaveDispositionDefLst pwgJobSaveDispositionDefElem;
extern  pwgSTRUCT_DEF               pwgDef_JobSaveDisposition;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_JOB_SAVE_DISPOSITION_H__                                                         */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.3.job.save.disposition.h ================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
