/* ================================ pwg.pjt.pjp.3.overrides.h ============================================= */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_OVERRIDES_H__
#define __PWG_PJT_PJP_3_OVERRIDES_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

#include "pwg.pjt.pjp.3.pages.h"
#include "pwg.pjt.pjp.3.document.copies.h"
#include "pwg.pjt.pjp.3.document.numbers.h"
#include "pwg.pjt.pjp.3.overriding.elements.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Overrides                                                                                                */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §6.4.1 [page 30] Overrides Element                                                                  */
/* -----------------                                                                                        */
/* Figure 21 shows the constituent elements of the Overrides element.                                       */
/*                                                                                                          */
/*               + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +    */
/*               . OverridesType                                                                       .    */
/*               .                                                                                     .    */
/* +-----------+ .    +------------+                                                                   .    */
/* | Overrides |-.-+--| attributes |                                                                   .    */
/* +-----------+ . |  +------------+                                                                   .    */
/*               . |                                                                                   .    */
/*               . | /---------\     +----------+                                                      .    */
/*               . +-| -o-o-o- |-----| Override |                                                      .    */
/*               .   \---------/     C--+-------M                                                      .    */
/*               .                      | 0..infinite                                                  .    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
/* author's note:   There is element CopiesRange; DocumentCopies is a RangeOfInteger                        */
/*               .                      |                                                              .    */
/*               .                      |    /---------\      + - - - - - - - -+                       .    */
/*               .                      + ---| -o-o-o- |- + - | DocumentCopies |                       .    */
/*               .                           \---------/  |   R - + - - - - - -M                       .    */
/*               .                                        |       |                                    .    */
/*               .                                        |       |   /---------\    +-------------+   .    */
/*               .                                        |       +---! -o-o-o- !----| CopiesRange |+  .    */
/*               .                                        |           \---------/    +-------------M   .    */
/*               .                                        |                              0..infinite   .    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*               .                      |                                                              .    */
/*               .                      |    /---------\      + - - - - - - - -+                       .    */
/*               .                      + ---| -o-o-o- |- + - | DocumentCopies |                       .    */
/*               .                           \---------/  |   R - - - - - - - -M                       .    */
/*               .                                        |          0..infinite                       .    */
/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
/* author's note:   There is element NumberRange; DocumentNumbers is a RangeOfInteger                        */
/*               .                                        |   + - - - - - - - - +                      .    */
/*               .                                        + - ! DocumentNumbers !                      .    */
/*               .                                        |   R - + - - - - - - M                      .    */
/*               .                                        |       |                                    .    */
/*               .                                        |       |   /---------\    +-------------+   .    */
/*               .                                        |       +---| -o-o-o- |----| NumberRange |+  .    */
/*               .                                        |           \---------/    +-------------M   .    */
/*               .                                        |                              0..infinite   .    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*               .                                        |   + - - - - - - - - +                      .    */
/*               .                                        + - ! DocumentNumbers !                      .    */
/*               .                                        |   R - - - - - - - - M                      .    */
/*               .                                        |          0..infinite                       .    */
/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
/* author's note:   Overriding is a list (set) but ##any enums                                              */
/*               .                                        |   + - - - - - - - - - -+                   .    */
/*               .                                        + - ! OverridingElements !                   .    */
/*               .                                        |   + - + - - - - - - - -M                   .    */
/*               .                                        |       |                                    .    */
/*               .                                        |       |   /---------\    /-----------\     .    */
/*               .                                        |       +---| -o-o-o- |----| any ##any |     .    */
/*               .                                        |           \---------/    \-----------/     .    */
/*               .                                        |                            0..infinite     .    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*               .                                        |   + - - - - - - - - - -+                   .    */
/*               .                                        + - ! OverridingElements !                   .    */
/*               .                                        |   ##any - - - - - - - -M                   .    */
/*               .                                        |             0..infinite                    .    */
/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv */
/* author's note:   There is element NumberRange; Pages is a RangeOfInteger                                 */
/*               .                                        |   +-------+                                .    */
/*               .                                        +---| Pages |                                .    */
/*               .                                        !   R--+----M                                .    */
/*               .                                        !      |                                     .    */
/*               .                                        !      |   /---------\    +-----------+      .    */
/*               .                                        !      +---| -o-o-o- |----| PageRange |+     .    */
/*               .                                        !          \---------/    +-----------M      .    */
/*               .                                        !                           0..infinite      .    */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*               .                                        |   +-------+                                .    */
/*               .                                        +---| Pages |                                .    */
/*               .                                        !   R--+----M                                .    */
/*               .                                        !  0..infinite                               .    */
/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/*               .                                        !                                            .    */
/*               .                                        !   / - - - - - - \                          .    */
/*               .                                        + - ! any ##other !                          .    */
/*               .                                            \ - - - - - - /                          .    */
/*               .                                               0..infinite                           .    */
/*               .                                                                                     .    */
/*               + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +    */
/*                                                                                                          */
/* ======================================================================================================== */
/* A CLEANED UP VERSION OF THE ABOVE                                                                        */
/*                                                                                                          */
/*               + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +    */
/*               . OverridesType                                                                       .    */
/*               .                                                                                     .    */
/* +-----------+ .    +------------+                                                                   .    */
/* | Overrides |-.-+--| attributes |                                                                   .    */
/* +-----------+ . |  +------------+                                                                   .    */
/*               . |                                                                                   .    */
/*               . | /---------\     +----------+                                                      .    */
/*               . +-| -o-o-o- |-----| Override |                                                      .    */
/*               .   \---------/     C--+-------M                                                      .    */
/*               .                      | 0..infinite                                                  .    */
/*               .                      |                                                              .    */
/*               .                      |    /---------\      + - - - - - - - -+                       .    */
/*               .                      + ---| -o-o-o- |- + - | DocumentCopies |                       .    */
/*               .                           \---------/  |   R - - - - - - - -M                       .    */
/*               .                                        |          0..infinite                       .    */
/*               .                                        |                                            .    */
/*               .                                        |   + - - - - - - - - +                      .    */
/*               .                                        + - ! DocumentNumbers !                      .    */
/*               .                                        |   R - - - - - - - - M                      .    */
/*               .                                        |          0..infinite                       .    */
/*               .                                        |                                            .    */
/*               .                                        |   + - - - - - - - - - -+                   .    */
/*               .                                        + - ! OverridingElements !                   .    */
/*               .                                        |   ##any - - - - - - - -M                   .    */
/*               .                                        |             0..infinite                    .    */
/*               .                                        |                                            .    */
/*               .                                        |   +-------+                                .    */
/*               .                                        +---| Pages |                                .    */
/*               .                                        !   R--+----M                                .    */
/*               .                                        !  0..infinite                               .    */
/*               .                                        !                                            .    */
/*               .                                        !   / - - - - - - \                          .    */
/*               .                                        + - ! any ##other !                          .    */
/*               .                                            \ - - - - - - /                          .    */
/*               .                                               0..infinite                           .    */
/*               .                                                                                     .    */
/*               + . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . +    */
/*                                                                                                          */
/*                                           Figure 21 Overrides                                            */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 56] Overrides                      */
/* -----------------                                                                                        */
/* Provides for the overriding of processing instructions on a page basis.                                  */
/*    (Contains Pages, DocumentNumbers, DocumentCopies, OverridingElements)                                 */
/* [PWG5100.6] §4.1                                                                                         */
/*                                                                                                          */
/* ======================================================================================================== */
    /* [PWG 5100.6] October 31, 2003: Candidate Standard 5100.6-2003                                        */
    /*                              Standard for The Internet Printing Protocol (IPP): Page Overrides       */
    /*      §4.1 [page 8-13] overrides (1setOf collection)                                                  */
    /* -----------------                                                                                    */
    /* This Job Template attribute contains Job Template attributes that are associated with Pages and that */
    /* are treated as page Overrides. Such attributes are called "overrides" attributes. The remainder of   */
    /* this section describes features that an implementation MUST support or MAY support if an             */
    /* implementation supports this attribute.                                                              */
    /*                                                                                                      */
    /* If this attribute is present in a Job, there are Page Overrides. If it is present, the value         */
    /* consists of one or more 'collection' values, where each 'collection' value identifies one or more    */
    /* Pages and contains one or more Job Template attributes which act as Overrides to the corresponding   */
    /* Job Template attribute(s) for the specified Page(s) in the Job. Page Overrides are specified by      */
    /* including the "overrides" attribute inthe Job Template attributes group in a Print-Job, Print-Uri,   */
    /* Validate-Job, Create-Job or Set-Job-Attributes operation.                                            */
    /*                                                                                                      */
    /* The first member attribute of the "overrides" collection MUST be the "pages" attribute. This         */
    /* identifies the pages to which the Override applies. The identified pages need not be contiguous.     */
    /*                                                                                                      */
    /* If the Override applies only to specific Documents, the next member attribute MUST be the            */
    /* "document-numbers" attribute, which specifies the Documents to which the Override applies. If this   */
    /* attribute is not supplied, the Override applies to all Documents in the Job.                         */
    /*                                                                                                      */
    /* If the Override applies only to specific copies of the Document, the next member attribute MUST be   */
    /* the "document-copies" attribute, which specifies the copies of the Document to which the Override    */
    /* applies. If this attribute is not supplied, the Override applies to all copies of the Document.      */
    /*                                                                                                      */
    /* The remaining member attributes in the 'collection' value MUST be one or more Job Template           */
    /* attributes that are Overrides for the specified pages.                                               */
    /*                                                                                                      */
    /* If the "pages", "document-copies", and "document-numbers", identify pages that either don't exist or */
    /* are within nonexistent Document-Copies or Documents, the Printer MUST silently ignore them. The      */
    /* Printer MUST apply Overrides to the pages that do exist.                                             */
    /*                                                                                                      */
    /* If a client supplies a member attribute in some position other than its required position (e.g.      */
    /* "pages" MUST be first), a Printer MUST reject the request with status-code                           */
    /* 'client-error-bad-request'.                                                                          */
    /*                                                                                                      */
    /* For each member attribute in the collection (i.e. "pages", "document-copies" and "document-numbers") */
    /* the client MUST NOT specify values that contain overlapping ranges . Furthermore the ranges MUST be  */
    /* in ascending order.  If there are multiple "overrides" in the collection the client MUST NOT specify */
    /* "overrides" with overlapping documents (i.e. overlapping "document-numbers"). The "overrides" in the */
    /* set MUST be in ascending order based on the "document-numbers" member attribute value. If a request  */
    /* is received by the Printer that does not meet these requirements, the Printer MUST reject the        */
    /* request with status-code 'client-error-bad-request'.                                                 */
    /*                                                                                                      */
    /* When a client receives this attribute in a Get-Jobs or Get-Job-Attributes response, the value MUST   */
    /* contain the same 'collection' values received in Job-Submission operations, except for those         */
    /* 'collection' values the Printer returned in the Unsupported Attributes group.                        */
    /*                                                                                                      */
    /* To allow the specification of the last page, copy or document, the MAX integer value (2147483647)    */
    /* is used. To allow the specification of the page, copy or document before the last, a special value   */
    /* of MAX-1(2147483646) is used. No other special values are defined.                                   */
    /*                                                                                                      */
    /*                                  Table 1 "overrides' member attributes                               */
    /*      +----------------------------+----------------------------+------------+-------------------+    */
    /*      | Attribute Name             | Syntax                     | In request | Printer Support   |    */
    /*      +============================+============================+============+===================+    */
    /*      | pages                      | 1setOf rangeOfInteger(MAX) |  MUST      | MUST              |    */
    /*      +----------------------------+----------------------------+------------+-------------------+    */
    /*      | document-numbers           | 1setOf rangeOfInteger(MAX) |  MAY       | MUST              |    */
    /*      +----------------------------+----------------------------+------------+-------------------+    */
    /*      | document-copies            | 1setOf rangeOfInteger(MAX) |  MAY       | MAY               |    */
    /*      +----------------------------+----------------------------+------------+-------------------+    */
    /*      | Any Job Template attribute |                            |  MAY       | See section 4.1.4 |    */
    /*      +----------------------------+----------------------------+------------+-------------------+    */
    /*                                                                                                      */
    /* The following sections describe each member attribute in the above table.                            */
    /*                                                                                                      */
    /*    4.1.1  pages (1setOf rangeOfInteger(1:MAX))                                                       */
    /*        This attribute identifies one or more pages by specifying one or more ranges of numbers (see  */
    /*        section 3.1 for the rules on associating a number with each page). The "1setOf" allows        */
    /*        noncontiguous pages. The Overrides apply to the identified pages within the Documents         */
    /*        specified.                                                                                    */
    /*                                                                                                      */
    /*        If the "page-ranges" attribute is associated with a Document, the pages identified by this    */
    /*        attribute are the same as when "page-ranges" is not present. However, this attribute may      */
    /*        identify pages that are deselected for printing by the "page-ranges" attribute. For example,  */
    /*        if the value of "page-ranges" is "5:10" and this attribute identifies pages "3:6", this       */
    /*        attribute identifies two pages (3 and 4) that are not printed and two that are (5 and 6).     */
    /*                                                                                                      */
    /*        If a Printer supports the "overrides" attribute, it MUST support this attribute. A client     */
    /*        MUST supply this attribute in each 'collection' value of the "overrides" attribute and it     */
    /*        MUST be the first attribute of each 'collection' value.                                       */
    /*                                                                                                      */
    /*    4.1.2  document-numbers (1setOf rangeOfInteger (1:MAX))                                           */
    /*        This attribute identifies one or more Documents by specifying one or more ranges of numbers.  */
    /*        The Overrides apply to the pages within the Documents specified.                              */
    /*                                                                                                      */
    /*        A Printer MUST support this attribute. A client MAY supply this attribute in each             */
    /*        'collection' value. If supplied, it MUST be the second attribute of each 'collection' value.  */
    /*                                                                                                      */
    /*    4.1.3  document-copies (1setOf rangeOfInteger (1:MAX))                                            */
    /*        This attribute identifies one or more Document-Copies by specifying one or more ranges of     */
    /*        numbers. The Overrides apply to the pages within the identified Documents-Copies within the   */
    /*        Documents specified. For example, 10 copies are duplex printed on letter paper with a staple, */
    /*        while one copy is simplex printed on transparencies without a staple.                         */
    /*                                                                                                      */
    /*        If an attribute can affect a Document, it can affect particular Document-Copies. If an        */
    /*        attribute can affect Sheets, it can affect Sheets of particular Document-Copies.              */
    /*                                                                                                      */
    /*        A Printer MAY support this attribute. A client MAY supply this attribute in each 'collection' */
    /*        value. It MUST be the third attribute of each 'collection' value if the client supplies       */
    /*        "document-numbers'; otherwise it MUST be second.                                              */
    /*                                                                                                      */
    /*    4.1.4  Overriding Job Template attributes                                                         */
    /*        These attributes have the same meaning as in IPP/1.1. The Printer MUST support only Job       */
    /*        Template attributes with a scope of Page, Cell, Impressions, or Sheet (see section 4.1.5).    */
    /*        The Printer MUST list Job Template attributes that the Printer supports for Override in the   */
    /*        Printer's "overrides-supported" attribute.                                                    */
    /*                                                                                                      */
    /*        All overriding Job Template attributes follow the same rules as ordinary Job Template         */
    /*        attributes not specified in an Override and interact with "ipp-attribute-fidelity" as         */
    /*        specified in [rfc2911]. Therefore if "ipp-attribute-fidelity" is 'false', the Printer MUST    */
    /*        accept the request (assuming no other problems are found with the request) and any overriding */
    /*        Job Template attributes not supported by the Printer MUST be returned in                      */
    /*        "unsupported-attributes". If "ipp-attribute-fidelity" is 'true', then the Printer MUST reject */
    /*        the request and the unsupported Job Template attributes MUST be returned in                   */
    /*        "unsupported-attributes".                                                                     */
    /*                                                                                                      */
    /*        The client MUST include at least one attribute to be overridden. A request with "overrides"   */
    /*        that does not have any overriding Job Template attributes MUST be rejected with a             */
    /*        'client-error-bad-request' status code.                                                       */
    /*                                                                                                      */
    /*    4.1.5  Scope of Job Template Attribute in an Override                                             */
    /*        Table 2 defines scopes for Job Template attributes as they apply to Overrides. The Scope is   */
    /*        applicable only when the Job Template attribute is applied as part of an Override. A Scope is */
    /*        the smallest entity to which a Job Template attribute applies. The order of Scopes from       */
    /*        largest to smallest is: a Job contains one or more Documents that are printed on one or more  */
    /*        Sheets that have up to two Impressions containing one or more Cells [^4] containing one or    */
    /*                                                                                                      */
    /* [^4: If impositions are not applied to the page, then a Cell is equivalent to an Impression. (i.e.   */
    /*      an Impression contains one Cell)]                                                               */
    /*                                                                                                      */
    /*        more Pages. For a Printer to support a Job Template attribute in an Override, it MUST support */
    /*        the Job Template at the specified Scope. Implementations MAY apply the Job Template attribute */
    /*        at a smaller scope (e.g. Page instead of Impression).                                         */
    /*                                                                                                      */
    /*        Job Template attributes with a scope of Job or Document SHOULD NOT be part of an Override.    */
    /*        They are meaningless in a Override that is specified with a range of Pages in a Document.     */
    /*                                                                                                      */
    /*        Included in the definitions are the rules for handling a change in the Job Template attribute */
    /*        value on Override boundaries. An Override boundary occurs when two contiguous Pages are in    */
    /*        separate Overrides or two contiguous Pages have one Page in an Override and the other is not. */
    /*        When an Override boundary is reached and the value of the Job Template attribute does not     */
    /*        change, the Printer MUST place the next Page on the Impression or Sheet without the           */
    /*        transition move dictated in Table 2. For example: A Document is being printed with            */
    /*        "number-up" set to '4' and "sides" set to 'two-sided-long-edge' and an Override is set for    */
    /*        page 4 with "number-up" of '1'. Pages 1 to 3 will be printed on the first impression (i.e.    */
    /*        first side of sheet 1).  The Job Template attribute value change at the transition only       */
    /*        affects Impressions (i.e. "number-up" from '4' to '1') so the next Page is printed on a new   */
    /*        Impression (i.e. second side of the first sheet). Since the Job Template attribute affecting  */
    /*        Sheets did not change, the fourth Page is not printed on a new Sheet (i.e. first side of the  */
    /*        second Sheet).                                                                                */
    /*                                                                                                      */
    /*                                          Table 2 Scope definitions                                   */
    /*            +----------------+------------------------------------------------------------------+     */
    /*            | Override Scope | Definition                                                       |     */
    /*            +================+==================================================================+     */
    /*            | Job            | Job Template Attributes that operate on whole Jobs, such as      |     */
    /*            |                | "job-priority", "job-hold-until", and                            |     */
    /*            |                | "multiple-document-handling", are meaningless as page overrides. |     */
    /*            |                | The Client SHOULD NOT supply these attributes in "overrides".    |     */
    /*            +----------------+------------------------------------------------------------------+     */
    /*            | Document       | Job Template Attributes that operate on whole Documents, such as |     */
    /*            |                | "copies", are meaningless as page overrides. These attributes    |     */
    /*            |                | SHOULD NOT be included in "overrides".                           |     */
    /*            +----------------+------------------------------------------------------------------+     */
    /*            | Sheet          | Job Template Attributes that operate on whole Sheets, such as    |     */
    /*            |                | "media" and "finishings", are appropriate as Overrides. These    |     */
    /*            |                | attributes MAY be included in "overrides". When a Sheet          |     */
    /*            |                | attribute changes value at an Override boundary, this forces the |     */
    /*            |                | Printer to move on to the first side of a new sheet.             |     */
    /*            +----------------+------------------------------------------------------------------+     */
    /*            | Impression     | Job Template Attributes that operate on whole Impressions, such  |     */
    /*            |                | as "imposition-template" or "print-quality", are appropriate as  |     */
    /*            |                | Overrides. These attributes MAY be included in "overrides". When |     */
    /*            |                | an Impression attribute changes value at an Override boundary,   |     */
    /*            |                | this forces the Printer to move on to the next Impression -- that|     */
    /*            |                | is, the next side.                                               |     */
    /*            +----------------+------------------------------------------------------------------+     */
    /*            | Cell           | Job Template Attributes that operate on whole Cell, such as      |     */
    /*            |                | "number-up" or "x-side1-image-shift", are appropriate as         |     */
    /*            |                | Overrides. These attributes MAY be included in "overrides". When |     */
    /*            |                | an Cell attribute changes value at an Override boundary, this    |     */
    /*            |                | forces the Printer to move on to the next Cell on the            |     */
    /*            |                | impression. If impositions are not in effect there is only one   |     */
    /*            |                | Cell per impression. Therefore a change at an Override boundary  |     */
    /*            |                | would require moving to the next side.                           |     */
    /*            +----------------+------------------------------------------------------------------+     */
    /*            | Page           | Job Template Attributes that operate on whole Pages, such as     |     */
    /*            |                | "orientation-requested", are appropriate as Overrides. These     |     */
    /*            |                | attributes MAY be included in "overrides". Job Template          |     */
    /*            |                | Attributes that operate on Pages do not affect the location of   |     */
    /*            |                | the page image in the Cell (or Impression if impositions are not |     */
    /*            |                | being applied).                                                  |     */
    /*            +----------------+------------------------------------------------------------------+     */
    /*                                                                                                      */
    /*        Table 3 below shows the Scope for the Job Template attributes. As indicated above, Job        */
    /*        Template attributes with a Scope of Job or Document are not applicable to Overrides. The      */
    /*        "Override Scope" column contains 'N/A' for these Job Template attributes. Table 2 above       */
    /*        indicates the appropriate behavior for when the attribute values change on Override           */
    /*        boundaries.                                                                                   */
    /*                                                                                                      */
    /*        The Job Template attributes "print-quality" and "printer-resolution" have an Override Scope   */
    /*        of Impression. To support these attributes in an "override"the Printers MUST implement them   */
    /*        at least to the Override Scope of Impression. As with any "override" attribute the Printer    */
    /*        MAY implement them with the reduced Override Scope of Page.                                   */
    /*                                                                                                      */
    /*                              Table 3 Job Template Attribute Override Scope                           */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | Job Template Attribute |  Override  |      Attribute Syntax        |       Reference       | */
    /*       |                        |    Scope   |                              |                       | */
    /*       +========================+============+==============================+=======================+ */
    /*       | copies                 | N/A        | integer(1:MAX)               | [rfc2911]   | §4.2.5  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | cover-back             | N/A        | collection                   | [pwg5100.3] | §3.1    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | cover-front            | N/A        | collection                   | [pwg5100.3] | §3.1    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | finishings             | Sheet      | 1setOf type2 enum            | [rfc2911]   | §4.2.6  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | finishings-col         | Sheet      | collection                   | [pwg5100.3] | §3.2    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | force-front-side       | Sheet      | 1setOf integer(1:MAX)        | [pwg5100.3] | §3.3    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | imposition-template    | Impression | type2 keyword or name(MAX)   | [pwg5100.3] | §3.4    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | insert-sheet           | N/A        | 1setOf collection            | [pwg5100.3] | §3.5    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-account-id         | N/A        | name(MAX)                    | [pwg5100.3] | §3.6    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-accounting-sheets  | N/A        | collection                   | [pwg5100.3] | §3.8    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-accounting-        |            |                              |             |         | */
    /*       |           user-id**    | N/A        | name(MAX)                    | [pwg5100.3] | §3.7    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-copies             | N/A        | integer(1:MAX)               | [jobx]      | §5.1.   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-cover-back         | N/A        | collection                   | [jobx]      | §5.1.   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-cover-front        | N/A        | collection                   | [jobx]      | §5.1.   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-error-sheet        | N/A        | collection                   | [pwg5100.3] | §3.9    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-finishings         | N/A        | 1setOf type2 enum            | [jobx]      | §5.1.   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-finishings-col     | N/A        | collection                   | [jobx]      | §5.1.   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-hold-until         | N/A        | type3 keyword or name(MAX)   | [rfc2911]   | §4.2.2  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-message-to-        | N/A        | text(MAX)                    | [pwg5100.3] | §3.10   | */
    /*       |          operator      |            |                              |             |         | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-priority           | N/A        | integer(1:100)               | [rfc2911]   | §4.2.1  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-sheet-message      | N/A        | text(MAX)                    | [pwg5100.3] | §3.12   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-sheets             | N/A        | type3 keyword or name(MAX)   | [rfc2911]   | §4.2.3  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | job-sheets-col         | N/A        | collection                   | [pwg5100.3] | §3.11   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | media                  | Sheet      | type3 keyword or name(MAX)   | [rfc2911]   | §4.2.11 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | media-col              | Sheet      | collection                   | [pwg5100.3] | §3.13   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | media-input-tray-check | N/A        | type3 keyword or name(MAX)   | [pwg5100.3] | §3.14   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | media-type             | Sheet      | type3 keyword or name(MAX)   | [upnp],     |         | */
    /*       |                        |            |                              | [pwg5100.3] | §3.13.2 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | multiple-document-     | N/A        | type2 keyword                | [rfc2911]   | §4.2.4  | */
    /*       |              handling  |            |                              |             |         | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | number-up              | Cell       | integer(1:MAX)               | [rfc2911]   | §4.2.9  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | orientation-requested  | Page       | type2 enum                   | [rfc2911]   | §4.2.10 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | output-bin             | N/A        | type2 keyword or name(MAX)   | [pwg5100.2] | §2.1    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | output-device          | Sheet      | name(MAX)                    | [jobx]      | §5.1.   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | page-delivery          | N/A        | type2 keyword                | [pwg5100.3] | §3.15   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | page-order-received    | N/A        | type2 keyword                | [pwg5100.3] | §3.16   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | page-ranges            | N/A        | 1setOf rangeOfInteger(1:MAX) | [rfc2911]   | §4.2.7  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | presentation-          | Cell       | type2 keyword                | [pwg5100.3] | §3.17   | */
    /*       |   direction-number-up  |            |                              |             |         | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | print-quality          | Impression | type2 enum                   | [rfc2911]   | §4.2.13 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | printer-resolution     | Impression | resolution                   | [rfc2911]   | §4.2.12 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | separator-sheets       | N/A        | collection                   | [pwg5100.3] | §3.18   | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | sheet-collate          | N/A        | type2 keyword                | [rfc3381]   | §3.1    | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | sides                  | Sheet      | type2 keyword                | [rfc2911]   | §4.2.8  | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | x-image-position       | Cell       | type2 keyword                | [pwg5100.3] | §3.19.2 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | x-image-shift          | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.3 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | x-side1-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.4 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | x-side2-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.5 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | y-image-position       | Cell       | type2 keyword                | [pwg5100.3] | §3.19.6 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | y-image-shift          | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.7 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | y-side1-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.8 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*       | y-side2-image-shift    | Cell       | integer(MIN:MAX)             | [pwg5100.3] | §3.19.9 | */
    /*       +------------------------+------------+------------------------------+-----------------------+ */
    /*                                                                                                      */
    /*    4.1.6  Rationale for not having a "overrides-default" attribute                                   */
    /*        There is no "overrides-default" attribute because it adds complicated rules for a Printer to  */
    /*        implement. The problems are best illustrated with examples.                                   */
    /*                                                                                                      */
    /*        If there were an "overrides-default" and it contained a "sides" and "media" Override for the  */
    /*        first page, and if a client submitted a Job with no "sides" attribute and with "media" as a   */
    /*        Job Template attribute with no Overrides, a possible meaning is that the Printer uses the     */
    /*        client's requested media for the entire Job and the sides specified by the "sides-default"and */
    /*        the "sides" value in "overrides-default". So in this example, the Printer ignores the         */
    /*        "overrides-default" attribute for "media", but uses it for "sides" because the Printer uses   */
    /*        it for an attribute "xxx" only when it uses "xxx-default".                                    */
    /*                                                                                                      */
    /*    4.1.7  overrides-supported (1setOf type2 keyword)                                                 */
    /*        This attribute specifies the supported values of the "overrides" attribute. A client can use  */
    /*        this attribute to determine what Override attributes the Printer supports.                    */
    /*                                                                                                      */
    /*        This attribute contains the name of each attribute that the Printer supports in a             */
    /*        'collection' value of the "overrides" attribute. The Printer MUST support this attribute.     */
    /*        This attribute MUST contain the keywords "pages" and "document-numbers" because a Printer     */
    /*        MUST support these attributes. This attribute MUST contain the keyword "document-copies" if   */
    /*        the Printer supports overriding of individual copies of a Document.                           */
    /*                                                                                                      */
    /*        This attribute MUST also contain the name of each attribute that can be an Override. For      */
    /*        example, this attribute contains the keyword "sides" if and only if the Printer supports      */
    /*        "sides" in a 'collection' value of the "overrides" attribute.                                 */
    /*                                                                                                      */
    /*        There are no corresponding "document-numbers-supported", "document-copies-supported", and     */
    /*        "pages-supported" Printer attributes. However, the supported values for all of the other      */
    /*        member attributes are indicated by the corresponding "xxx-supported" Printer attributes which */
    /*        are the same values as for the corresponding "xxx" operation or Job Template attribute. For   */
    /*        example, if"sides" is supported as a member attribute of the "override" collection,then the   */
    /*        "sides-supported" Printer attribute indicates the values that are supported both at the job   */
    /*        level and as an Override.                                                                     */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [PWG 5100.6] October 31, 2003: Candidate Standard 5100.6-2003                                    */
        /*                              Standard for The Internet Printing Protocol (IPP): Page Overrides   */
        /*      §3.1 [page 7-8] Numbering of Components                                                     */
        /* -----------------                                                                                */
        /* The Override Extension defines a system for numbering of components.                             */
        /*                                                                                                  */
        /*    - Each Page in a Document is numbered sequentially, starting at 1 for the first Page. If a    */
        /*      Job has several Documents, the first Page of each Document has the number 1. The Page       */
        /*      number is unaffected by the "multiple-document-handling" Job Template Attribute.[^3]        */
        /*                                                                                                  */
        /* [^3: Rationale: The primary reason for ignoring "multi-document-handling" in numbering Pages for */
        /*                 Overrides is simplicity. From a usability standpoint it is cleaner to present    */
        /*                 the Page number within a Document than to determine the current rule for         */
        /*                 numbering Pages across the Job and then keep the counts of the previous          */
        /*                 Document's Pages so the correct Page can be specified. ]                         */
        /*                                                                                                  */
        /*    - The Documents are numbered as if the value of "copies" were 1, i.e. if a Document produces  */
        /*      multiple copies, each copy of the Document has the same document number.                    */
        /*                                                                                                  */
        /*    - Each copy of a Document has a number. The first copy of each Document has the number 1, and */
        /*      each subsequent copy has a number that is one higher than the previous copy.                */
        /*                                                                                                  */
        /*    - Each Document has a number. The single Document that a client sends with Print-Job or       */
        /*      Print-URI and the first Document that a client sends with Send-Document or Send-URI has the */
        /*      number 1. Each subsequent Document that a client sends has a number that is one higher than */
        /*      the previous.                                                                               */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef struct {
            pwgRangeOfInteger  pages[pwgMAX_PAGE_RANGES];                  /* Pages in document data.       */
            pwgRangeOfInteger  documentCopies[pwgMAX_DOC_COPIES_RANGES];   /* Doc copies to apply override. */
            pwgRangeOfInteger  documentNumbers[pwgMAX_DOC_NUM_RANGES];     /* Doc for override processing.  */
    pwgOverridingElementsEnum  overridingElements[pwgMAX_OVERRIDES_ELEM];  /* Elements to Override          */
                      pwgVOID* overrideData[pwgMAX_OVERRIDES_ELEM];        /* Element Data for Override     */

                      VND_OVERRIDES_STRUCT

} pwgOverrides;

typedef struct {
            pwgARY_DEF*        overridePages;         /* Pages in document data.                              */
            pwgARY_DEF*        documentCopies;        /* Doc copies to apply override.                        */
            pwgARY_DEF*        documentNumbers;       /* Doc for override processing.                         */
        pwgNUM_RNG_DEF*        overridingElements;    /* Elements to Override                                 */
            pwgBUF_DEF*        overrideData;          /* Element Data for Override                            */

        VND_OVERRIDES_DEF_STRUCT

               pwgVOID*        last;
} pwgOverridesDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern         pwgARY_DEF  pwgDef_OverridePages;

extern         pwgBUF_DEF  pwgDef_OverrideData;

extern pwgOverridesDefLst  pwgOverridesDefElem;
extern      pwgSTRUCT_DEF  pwgDef_Overrides;

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_OVERRIDES_H__                                                                    */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.pjp.3.overrides.h ============================================= */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
