/* =================================== pwg.pjt.pjp.3.save.info.h ========================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_PJP_3_SAVE_INFO_H__
#define __PWG_PJT_PJP_3_SAVE_INFO_H__
#ifdef __cplusplus
extern "C" {
#endif

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.ticket.config.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ........................................................................................................ */
/*                                                                                                          */
/* Save Info                                                                                                */
/*                                                                                                          */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 58] SaveInfo                       */
/* -----------------                                                                                        */
/* Contains sets of elements that each tells the PrintService how to create each copy of the saved job.     */
/* (Contains SaveLocation, SaveName, SaveDocumentFormat)                                                    */
/* [PWG5100.11] §7.9.1.2                                                                                    */
/*                                                                                                          */
/* ======================================================================================================== */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note: The following section has been added for completeness                                     */
/* ======================================================================================================== */
/* [wd-sm20-printjobticket10-20120117] January 17, 2012: Working Draft - Status: Stable                     */
/*                                     PWG Print Job Ticket and Associated Capabilities                     */
/*      §6.3.3: [page 29] JobSaveDisposition Element                                                        */
/* -----------------                                                                                        */
/* Figure 19 shows the constituent elements of the JobSaveDisposition element.                              */
/*                                                                                                          */
/*    +~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+      */
/*                                                                                                          */
/* +--------------------+     +------------+                                                                */
/* | JobSaveDisposition |--+--| attributes |                                                                */
/* +--------------------+  |  +------------+                                                                */
/*                         |                                                                                */
/*                         |  /---------\      + - - - - - - - - +                                          */
/*                         +--| -o-o-o- |- + - | SaveDisposition |                                          */
/*                            \---------/  !   + - - - - - - - - +                                          */
/*                                      !                                                                   */
/*                                      !                + . . . . . . . . . . . . . . . . . . . . . .  +   */
/*                                      !                .  SaveInfoType                                .   */
/*                                      !                .                                              .   */
/*                                      !                .    +------------+                            .   */
/*                                      !                . +--| attributes |                            .   */
/*                                      !                . |  +------------+                            .   */
/*                                      !   + - - - - -+ . |                   + - - - - - - - - - -+   .   */
/*                                      + - | SaveInfo |-.-+               + - | SaveDocumentFormat |   .   */
/*                                      !   + - - - - -+ . |               !   + - - - - - - - - - -+   .   */
/*                                      !                . |               !                            .   */
/*                                      !                . |  /---------\  !   + - - - - - - -+         .   */
/*                                      !                . +--| -o-o-o- |- + - | SaveLocation |         .   */
/*                                      !                .    \---------/  !   + - - - - - - -+         .   */
/*                                      !                .                 !                            .   */
/*                                      !                .                 !   + - - - - - +            .   */
/*                                      !                .                 + - | SaveName  |            .   */
/*                                      !                .                 !   + - - - - - +            .   */
/*                                      !                .                 !                            .   */
/*                                      !                .                 !   / - - - - - - -\         .   */
/*                                      !                .                 + - | any ##other  |         .   */
/*                                      !                .                     \ - - - - - - -/         .   */
/*                                      !                .                         0..infinite          .   */
/*                                      !                .                                              .   */
/*                                      !                + . . . . . . . . . . . . . . . . . . . . . .  +   */
/*                                      !                                                                   */
/*                                      !   / - - - - - - -\                                                */
/*                                      + - | any ##other  |                                                */
/*                                          \ - - - - - - -/                                                */
/*                                              0..infinite                                                 */
/*                                                                                                          */
/*                                     Figure 19 JobSaveDisposition                                         */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + . . . . . . . . . . . . . . +       ! = Optional   */
/*      ! Optional Element  !   | Required Element |   . ElementS of a Complex Type  .       | = Required   */
/*      X - - - - - - - - - Y   X------------------Y   + . . . . . . . . . . . . . . +                      */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ........................................................................................................ */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                      */
    /*                           Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
    /*      §7.9.1.2 [page 41-48] save-info (1setOf collection)                                             */
    /* -----------------                                                                                    */
    /* The "save-info" member attribute is a collection that contains the attributes that tell the printer  */
    /* how to save the job.  This includes the format in which the Document Data MUST be saved, and the     */
    /* location to which these are saved.  Multiple save locations or document formats MAY be saved by      */
    /* specifying multiple collections within this attribute.                                               */
    /*                                                                                                      */
    /* If the client supplies the "job-save-disposition" Job Template attribute, but omits the "save-info"  */
    /* member attribute, the Printer supplies a single collection value for the "save-info" member          */
    /* attribute from the values of its "save-location-default" attribute, the job's "job-name", and its    */
    /* "save-document-format-default" attribute (see descriptions immediately below).                       */
    /*                                                                                                      */
    /* A client MUST supply in a request a number of collections not to exceed the maximum number supported */
    /* specified in the "max-save-info-supported" Printer Description attribute (see                        */
    /* "max-save-info-supported" description in section 10.6). As with any Job Template attribute, if the   */
    /* client does supply more values than the Printer supports and the values of the                       */
    /* "ipp-attribute-fidelity" is 'false' (or omitted), the Printer MUST accept the job, return the        */
    /* 'successful-ok-ignored-or-substituted-attributes' status code, return the ignored values in the      */
    /* Ignored Attributes group, use the first n-values, and ignore the remaining values. If the client     */
    /* does supply more values than the Printer supports and the values of the "ipp-attribute-fidelity" is  */
    /* 'true', the Printer MUST reject the request and return the 'client-error-request-entity-too-large'   */
    /* status code.                                                                                         */
    /*                                                                                                      */
    /*        7.9.1.2.1  There is no save-info-default Printer attribute                                    */
    /*            There is no "save-info-default" Printer attribute. If the client supplies the             */
    /*            "job-save-disposition" Job Template attribute, but omits the "save-info" member attribute,*/
    /*            the Printer creates a single collection value for the "save-info" member attribute using  */
    /*            from the Printer's "save-location-default" and "save-document-format-default" Printer     */
    /*            attributes and the job's "job-name" attribute (see "save-info" description above).        */
    /*                                                                                                      */
    /*        7.9.1.2.2  save-info-supported (1setOf type2 keyword)                                         */
    /*            The "save-info-supported (1setOf type2 keyword)" attribute identifies the names of the    */
    /*            member attributes supported in the "save-info" collection attribute, i.e., the names of   */
    /*            the member attributes in Table 8 that the Printer supports.                               */
    /*                                                                                                      */
    /*        7.9.1.2.3  Member Attributes for the "save-info" member attribute                             */
    /*            The "save-info" collection member attributes are:                                         */
    /*                                                                                                      */
    /*                              Table 8 - "save-info" member attributes                                 */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              | Member Attribute Name | Attribute Syntax  | Request | Printer Support |               */
    /*              +=======================+===================+=========+=================+               */
    /*              |      save-location    |        uri        |    MAY  |       MUST      |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              |      save-name        |      name(MAX)    |    MAY  |       MAY       |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*              |  save-document-format |    mimeMediaType  |    MAY          MUST      |               */
    /*              +-----------------------+-------------------+---------+-----------------+               */
    /*                                                                                                      */
    /*          7.9.1.2.3.1  save-location (uri)                                                            */
    /*              The "save-location" member attribute specifies the path to the directory as a URI where */
    /*              the Printer MUST save the Document Data and other information.                          */
    /*                                                                                                      */
    /*              The "save-location" and ("save-location-default" and "save-location-supported")         */
    /*              attribute value MUST be an Absolute URI [RFC2396]. Absolute URIs are specified with a   */
    /*              URI scheme, an optional authority component, and an absolute path (e.g.,                */
    /*              'ftp://printhost.printco.com/var/spool/jobdir/' or 'file:///job-repository/jobdir/').   */
    /*                                                                                                      */
    /*                  Note: As any other member attribute of a Job Template attribute, the Printer        */
    /*                        validates the "save-location" member attribute as follows: If the client      */
    /*                        supplies the "save-location" member attribute, the value MUST match one       */
    /*                        of the values of the Printer's "save-location-supported" (1setOf uri)         */
    /*                        attribute. If the value does not match, the Printer's action depends on       */
    /*                        the value of the job's "ipp-attribute-fidelity" (boolean) attribute: If       */
    /*                        "ipp-attribute-fidelity" is 'false' or omitted, the Printer MUST accept       */
    /*                        the job, return the 'successful-ok-ignored-or-substituted-attributes'         */
    /*                        status code, return the ignored attributes in the Unsupported Attributes      */
    /*                        Group, and perform one of the following actions                               */
    /*                                                                                                      */
    /*                            DEPENDING ON IMPLEMENTATION:                                              */
    /*                                                                                                      */
    /*                                (1) ignore the attribute and not save the job,                        */
    /*                                                                                                      */
    /*                                (2) put the job in the 'held' state and let the operator fix          */
    /*                                    the problem, either by changing the job's "save-location"         */
    /*                                    attribute value or adding the value to the Printer's              */
    /*                                    "save-location-supported" attribute, or                           */
    /*                                                                                                      */
    /*                                (3) substitute the job's "save-location" value with one of the        */
    /*                                    values of the Printer's "save-location-supported" values.         */
    /*                                    If "ipp-attribute-fidelity" is 'true', the Printer MUST           */
    /*                                    reject the request, return the                                    */
    /*                                    'client-error-attributes-or-values-not-supported' status          */
    /*                                    code, along with the "job-save-disposition" attribute in          */
    /*                                    the Unsupported Attributes Group.                                 */
    /*                                                                                                      */
    /*              If the client wants to put the saved job in a sub-directory (whether it exists or not)  */
    /*              of one of the directories specified by the "save-location-supported" Printer attribute, */
    /*              the client supplies that sub-directory name as part of the "save-name" attribute (see   */
    /*              "save-name" description below), not as part of the "save-location" member attribute.    */
    /*                                                                                                      */
    /*                  Note: As with any other 'name', 'integer', 'uri', or 'collection' Job Template      */
    /*                        or Job Template member attribute, the administrator can suspend validation    */
    /*                        by configuring the Printer's "user-defined-values-supported" attribute        */
    /*                        with the 'save-location' keyword (see "user-defined-values-supported"         */
    /*                        description in [PWG5100.3]), so that the user can specify an arbitrary        */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:                             ^^^^^^^^^ Section 5.1 page 65.  No critical to this file.     */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /*                        path and the Printer will accept the job. If the Printer cannot process       */
    /*                        the job using the specified value for "save-location", then the Printer       */
    /*                        MUST hold the job so that an operator can attempt to create the necessary     */
    /*                        sub-directories to populate the path, if they don't already exist, or         */
    /*                        change the job's "save-location" attribute value. See Table 10 below          */
    /*                        entitled "Printer actions for various Job and Printer attribute values",      */
    /*                        at the end of the "job-save-disposition" description.                         */
    /*                                                                                                      */
    /*              If the client supplies the "save-info" member attribute, but omits the "save-location"  */
    /*              member attribute, the Printer supplies the "save-location" member attribute value from  */
    /*              its "save-location-default" attribute (see "save-location-default" description below).  */
    /*                                                                                                      */
    /*              Defined Job Save URI Schemes for use in the "save-location" member attribute include:   */
    /*                                                                                                      */
    /*                          Table 9 - URI Schemes for "save-location" member attribute                  */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*               | URI Scheme | Description                                       | Printer Support |   */
    /*               +============+===================================================+=================+   */
    /*               |    ftp     | Use IETF FTP protocol [RFC959], [RFC2228],        |      SHOULD     |   */
    /*               |            | [RFC2640]                                         |                 |   */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*               |    file    | Use the Printer's configured file system. Since   |       MAY       |   */
    /*               |            | the 'file:' URI scheme cannot be separated from   |                 |   */
    /*               |            | the Printer object's native file system, the      |                 |   */
    /*               |            | semantic of the 'file:' URI scheme is             |                 |   */
    /*               |            | IMPLEMENTATION DEPENDENT. Also the 'file:' URI    |                 |   */
    /*               |            | scheme on some Printer objects MAY be limited to  |                 |   */
    /*               |            | the local file system, while on other Printer     |                 |   */
    /*               |            | objects it MAY be configured to use a network     |                 |   */
    /*               |            | file system.                                      |                 |   */
    /*               |            |                                                   |                 |   */
    /*               |            | The Printer implementation MAY allow the system   |                 |   */
    /*               |            | administrator to configure where the 'file:'      |                 |   */
    /*               |            | scheme is based in the file system.  However, the |                 |   */
    /*               |            | base for the 'file:' scheme MUST be the same as   |                 |   */
    /*               |            | for all other uses of the 'file': scheme, such as |                 |   */
    /*               |            | the value of the "document-uri" operation         |                 |   */
    /*               |            | attribute in a Printer-URI operation (for print   |                 |   */
    /*               |            | by reference of a saved document - see [RFC2911]  |                 |   */
    /*               |            | section 3.2.2 Print-URI operation).               |                 |   */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*               | http       | Use HTTP protocol with the Put operation to save  |      SHOULD     |   */
    /*               |            | the job.                                          |                 |   */
    /*               +------------+---------------------------------------------------+-----------------+   */
    /*                                                                                                      */
    /*              It is RECOMMENDED that for each URI scheme supported for saving jobs, that all of these */
    /*              values have the first token in the file path be 'job-repository'. Then an administrator */
    /*              that has to manage the saved jobs for several Printers will have a consistent naming    */
    /*              schemes for locating all the saved jobs by whatever means used to access the saved jobs.*/
    /*              For example, for the 'file:' scheme, all of the values SHOULD start out with:           */
    /*              file:///job-repository/ and for the 'ftp:' scheme, all of the values SHOULD start out   */
    /*              with: ftp://xxx/job-repository/.                                                        */
    /*                                                                                                      */
    /*                  (Note: In URIs, the final "/" is redundant, and the Printer MUST behave the same    */
    /*                         whether or not the final "/" is present).                                    */
    /*                                                                                                      */
    /*            7.9.1.2.3.1.1  save-location-default (uri)                                                */
    /*                The "save-location-default (uri)" Printer attribute indicates the value that the      */
    /*                Printer supplies, if the client omits the "save-location" member attribute from the   */
    /*                "save-info" member attribute.                                                         */
    /*                                                                                                      */
    /*            7.9.1.2.3.1.2  save-location-supported (1setOf uri)                                       */
    /*                The "save-location-supported (1setOf uri)" Printer attribute defines a list of URI    */
    /*                values supported by the Printer object for the "save-location" member attribute (see  */
    /*                above description). The client MUST supply a value of the "save-location" member      */
    /*                attribute that completely matches one of these values. Note: The administrator can    */
    /*                configure the "save-location-supported" to have separate directories for individuals, */
    /*                groups, projects, or MAY just have one directory for all saved jobs. Whether or not   */
    /*                access control is applied to these directories is IMPLEMENTATION DEPENDENT.           */
    /*                                                                                                      */
    /*          7.9.1.2.3.2  save-name (name(MAX))                                                          */
    /*              The "save-name" member attribute specifies the name of the saved job in the directory   */
    /*              specified by the "save-location" member attribute. The client can supply a "save-name"  */
    /*              attribute value that is either a simple file name or a relative path where each         */
    /*              component of the path is separated by a FORWARD SLASH ("/") character.  The             */
    /*              "save-name-subdirectory-supported" Printer Description attribute indicates whether or   */
    /*              not the Printer supports a FORWARD-SLASH ("/") in the "save-name" value. Whether the    */
    /*              FORWARD SLASH when supported is actually implemented as a sub-directory is              */
    /*              IMPLEMENTATION DEPENDENT.                                                               */
    /*                                                                                                      */
    /*              There is no requirement that the "save-name" attribute value in combination with the    */
    /*              "save-location" attribute value specify an identification that is unique. Thus, if the  */
    /*              "save-name" attribute value in combination with the "save-location" attribute value     */
    /*              specifies a handle that already exists, the Printer MUST accept the job and save the    */
    /*              job with the duplicate "save-name" value. This requirement is because a Saved Job is    */
    /*              referenced for re-printing using the "job-id" attribute value assigned by the Printer   */
    /*              that is unique at least with respect to that Printer.                                   */
    /*                                                                                                      */
    /*              If the "save-name" member attribute is not specified by the client in the               */
    /*              "job-save-disposition" Job Template attribute, the Printer object MUST generate a       */
    /*              "save-name" attribute value for the job using the job's "job-name" attribute value.     */
    /*                                                                                                      */
    /*                  Note: Printers MUST generate a "job-name" value, when the client does not supply    */
    /*                        a "job-name" operation attribute (see [RFC2911] section 4.3.5 "job-name",     */
    /*                        so there is always a "job-name" value.                                        */
    /*                                                                                                      */
    /*            7.9.1.2.3.2.1  There is no "save-name-default" Printer attribute                          */
    /*                There is no "save-name-default". If the client omits the "save-name" member attribute */
    /*                when supplying the "save-info" member attribute, the Printer uses the job's           */
    /*                "job-name" attribute as the value of the "save-name" attribute (described above).     */
    /*                                                                                                      */
    /*            7.9.1.2.3.2.2  save-name-supported (boolean)                                              */
    /*                The "save-name-supported (boolean)" attribute indicates support for the OPTIONAL      */
    /*                "save-name" member attribute of the "save-info" member attribute.                     */
    /*                                                                                                      */
    /*                  Note: The means to query the Printer to see what saved jobs it has is a potential   */
    /*                        future extension.                                                             */
    /*                                                                                                      */
    /*            7.9.1.2.3.2.3  save-name-subdirectory-supported (boolean)                                 */
    /*                The "save-name-subdirectory-supported" (boolean) Printer Description attribute        */
    /*                indicates whether the Printer supports a FORWARD SLASH ("/") character in the         */
    /*                "save-name" (name(MAX)) member attribute. If the value is 'false' and the client      */
    /*                supplies a FORWARD-SLASH ("/") in the "save-name" value, the Printer MUST reject the  */
    /*                request and return the 'client-error-attributes-or-values-not-supported'.             */
    /*                                                                                                      */
    /*          7.9.1.2.3.3  save-document-format (mimeMediaType)                                           */
    /*              The "save-document-format" member attribute indicates the document format in which the  */
    /*              job content (Document Data) MUST be saved. If the "job-save-disposition" attribute is   */
    /*              supported, the printer object MUST support the "save-document-format" member attribute. */
    /*                                                                                                      */
    /*              If the client supplies the "save-info" member attribute, but omits the                  */
    /*              "save-document-format" member attribute, the Printer MUST use the value of its          */
    /*              "save-document-format-default" attribute (see above "save-info" description).           */
    /*                                                                                                      */
    /*              Although there can be a many-to-one relationship of documents to a job, all documents   */
    /*              in a job specified with a disposition of 'save' or 'print-save' MUST be saved in the    */
    /*              same format as specified by the "save-document-format" attribute value. A job MAY be    */
    /*              saved to multiple formats by specifying multiple collection values for the "save-info"  */
    /*              member attribute.                                                                       */
    /*                                                                                                      */
    /*              The "job-save-disposition" member attribute (and the "save-document-format" member      */
    /*              attribute) is NOT defined to be used with the "page-overrides" attribute (see           */
    /*              [PWG5100.6]). Thus all documents MUST be saved in the same document format in each      */
    /*              saved job.                                                                              */
    /*                                                                                                      */
    /*              The 'mimeMediaType' values defined for the "save-document-format" attribute are listed  */
    /*              in the Table below. All values MUST include saving PDL data. A Printer MUST support at  */
    /*              least one value. However, at this time, this specification does NOT REQUIRE a Printer   */
    /*              to support any particular formats for saving jobs.                                      */
    /*                                                                                                      */
    /*              If the saved job is submitted to a different make-and-model printer that supports the   */
    /*              same document-format (i.e., the same value of the "document-format" operation attribute */
    /*              in the Document Creation request), then the Printer MUST be able to print the job, but  */
    /*              the output cannot be guaranteed to appear exactly the same as the original output.      */
    /*                                                                                                      */
    /*                +-------------------+-------------------------------------------------------+         */
    /*                | MIME Media Type   | Description                                           |         */
    /*                +===================+=======================================================+         */
    /*                | any PDL document  | If any PDL document-format value is supplied from the |         */
    /*                | format            | Printer's "document-format-supported" attribute, such |         */
    /*                |                   | as 'application/postscript', then the Printer         |         */
    /*                |                   | MUST save the PDL data in that document format.       |         */
    /*                |                   |                                                       |         */
    /*                |                   | Printer implementations are free to store the saved   |         */
    /*                |                   | data in any form they want for convenient, fast,      |         */
    /*                |                   | and/or compact re-printing using Reprocess-Job or     |         */
    /*                |                   | Resubmit-Job, and NEED NOT be identified by a         |         */
    /*                |                   | distinct mimeMediaType value in the                   |         */
    /*                |                   | "save-document-format-supported" Printer attribute. I |         */
    /*                |                   |                                                       |         */
    /*                |                   | The 'application/octet-stream' value MUST NOT be      |         */
    /*                |                   | supplied for this attribute since it doesn't make any |         */
    /*                |                   | sense for saving jobs.                                |         */
    /*                +-------------------+-------------------------------------------------------+         */
    /*                                                                                                      */
    /*              The referenced specifications that define the saved format MUST meet the conformance    */
    /*              requirements listed in section 12.4.2.1.                                                */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
/* author's note:                                  ^^^^^^^^^ Section 12.4.2 page 72.                        */
/* '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
    /*                                                                                                      */
    /*            7.9.1.2.3.3.1  save-document-format-default (mimeMediaType)                               */
    /*                If the client supplies the "save-info" member attribute, but omits the                */
    /*                "save-document-format" member attribute (see above description), the Printer MUST use */
    /*                the value of its "save-document-format-default" (mimeMediaType) attribute.            */
    /*                                                                                                      */
    /*            7.9.1.2.3.3.2  save-document-format-supported (1setOf mimeMediaType)                      */
    /*                The "save-document-format-supported" (1setOf mimeMediaType) attribute specifies the   */
    /*                document formats which a Printer supports for saving jobs.                            */
    /*                                                                                                      */
    /*                If a Printer supports this Job Save & Reprint Feature, the Printer SHOULD be able to  */
    /*                Reprint using the Resubmit-Job operation (see Section 4.3.1.2) for all the formats in */
    /*                which it is capable of saving jobs, i.e., the mimeMediaType values of the Printer's   */
    /*                "document-format-supported" Printer Description attribute SHOULD be a superset of the */
    /*                values of the Printer's "save-document-format-supported" attribute. For example, if   */
    /*                a Printer supports the 'application/X-single-page-tiff' format for saving jobs, it    */
    /*                SHOULD also accept and support a Resubmit-Job operation to reprint that job.          */
    /*                                                                                                      */
    /*          7.9.1.2.3.4  Printer actions for various combinations of attributes                         */
    /*              This section lists the Printer actions for various combinations of "save-location"      */
    /*              (uri), "save-name" (name(MAX)), "save-location-supported" (1setOf uri), existing saved  */
    /*              jobs, ipp-attribute-fidelity (boolean), "user-defined-values-supported" (1setOf         */
    /*              keyword) and Printer actions.                                                           */
    /*                                                                                                      */
    /*              The possible Printer actions are (see above descriptions of "save-location" and         */
    /*              "save-name" for details):                                                               */
    /*                                                                                                      */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | Print Action      | Description                                               |   */
    /*                  +===================+===========================================================+   */
    /*                  |  reject           | The Printer rejects the Job Creation request, returns the |   */
    /*                  |                   | 'client-error-attributes-or-values-not-supported' status  |   */
    /*                  |                   | code and the "job-save-disposition" attribute and value   |   */
    /*                  |                   | in the Unsupported Attributes group.                      |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | accept-save       | The Printer accepts the Job Creation request, returns the |   */
    /*                  |                   | 'successful-ok' status code, and attempts to create all   |   */
    /*                  |                   | necessary files and sub-directories.                      |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | accept-substitute | The Printer accepts the Job Creation request, returns the |   */
    /*                  |                   | 'successful-ok-ignored-or-substituted-attributes' status  |   */
    /*                  |                   | code and the "job-save-disposition" attribute and value   |   */
    /*                  |                   | in the Unsupported Attributes group, and, DEPENDING ON    |   */
    /*                  |                   | IMPLEMENTATION:                                           |   */
    /*                  |                   |     (1) ignores the attribute and does not perform the    |   */
    /*                  |                   |         save,                                             |   */
    /*                  |                   |     (2) puts the job in the 'held' state and let the      |   */
    /*                  |                   |         operator fix the problem, either by changing the  |   */
    /*                  |                   |         job's "save-location" attribute value or adding   |   */
    /*                  |                   |         the value to the Printer's                        |   */
    /*                  |                   |         "save-location-supported" attribute, or           |   */
    /*                  |                   |     (3) substitutes the job's "save-location" value with  |   */
    /*                  |                   |         one of the values of the Printer's                |   */
    /*                  |                   |         "save-location-supported" values.                 |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                  | accept-hold       | The Printer accepts the Job Creation request, returns the |   */
    /*                  |                   | 'successful-ok' status code, and holds the job for the    |   */
    /*                  |                   | operator to resolve the conflict so that the job can be   |   */
    /*                  |                   | saved.                                                    |   */
    /*                  +-------------------+-----------------------------------------------------------+   */
    /*                                                                                                      */
    /*              Table 10 shows the Printer actions for the various possible value combinations of the   */
    /*              other Job and Printer attributes. In the example, there is already one saved job:       */
    /*              'a/bar'. The Printer supports three save-location directories: a, b, c.                 */
    /*                                                                                                      */
    /*                   Table 10 - Printer actions for various Job and Printer attribute values            */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | MIME  | save- | save-     | existing | ipp-       | user-defined-    | Printer           | */
    /*         | Media | name  | location- | saved    | attribute- | values-supported | action            | */
    /*         | Type  |       | supported | jobs     | fidelity   |                  |                   | */
    /*         +=======+=======+===========+==========+============+==================+===================+ */
    /*         | a     | foo   | a, b, c   | a/bar    | T or F     | none             | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | d/foo | a, b, c   | a/bar    | T or F     | none             | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | bar   | a, b, c   | a/bar    | T or F     | none             | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | F          | none             | accept-substitute | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | T          | none             | reject            | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | F          | none             | accept-substitute | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | T          | none             | reject            | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | foo   | a, b, c   | a/bar    | T or F     | save-location    | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | d/foo | a, b, c   | a/bar    | T or F     | save-location    | accept-save       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a     | bar   | a, b, c   | a/bar    | T or F     | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | F          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | d     | foo   | a, b, c   | a/bar    | T          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | F          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*         | a/d   | foo   | a, b, c   | a/bar    | T          | save-location    | accept-hold       | */
    /*         +-------+-------+-----------+----------+------------+------------------+-------------------+ */
    /*                                                                                                      */
    /*                                                                                                      */
    /* ==================================================================================================== */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §3.2.2 [page 48-49] Print-URI Operation                                                     */
        /* -----------------                                                                                */
        /* This OPTIONAL operation is identical to the Print-Job operation (section 3.2.1) except that a    */
        /* client supplies a URI reference to the document data using the "document-uri" (uri) operation    */
        /* attribute (in Group 1) rather than including the document data itself.  Before returning the     */
        /* response, the Printer MUST validate that the Printer supports the retrieval method (e.g., http,  */
        /* ftp, etc.) implied by the URI, and MUST check for valid URI syntax.  If the client-supplied URI  */
        /* scheme is not supported, i.e. the value is not in the Printer object's                           */
        /* "referenced-uri-scheme-supported" attribute, the Printer object MUST reject the request and      */
        /* return the 'client-error-uri-scheme-not-supported' status code.                                  */
        /*                                                                                                  */
        /* The IPP Printer MAY validate the accessibility of the document as part of the operation or       */
        /* subsequently.  If the Printer determines an accessibility problem before returning an operation  */
        /* response, it rejects the request and returns the 'client-error-document-access-error' status     */
        /* code.  The Printer MAY also return a specific document access error code using the               */
        /* "document-access-error" operation attribute (see section 3.1.6.4).                               */
        /*                                                                                                  */
        /* If the Printer determines this document accessibility problem after accepting the request and    */
        /* returning an operation response with one of the successful status codes, the Printer adds the    */
        /* 'document-access-error' value to the job's "job-state-reasons" attribute and MAY populate the    */
        /* job's "job-document-access-errors" Job Description attribute (see section 4.3.11).  See The      */
        /* Implementer's Guide [IPP-IIG] for suggested additional checks.                                   */
        /*                                                                                                  */
        /* If the Printer object supports this operation, it MUST support the                               */
        /* "reference-uri-schemes-supported" Printer attribute (see section 4.4.27).                        */
        /*                                                                                                  */
        /* It is up to the IPP object to interpret the URI and subsequently "pull" the document from the    */
        /* source referenced by the URI string.                                                             */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [rfc2911] September 2000: Standards Track                                                        */
        /*                              Internet Printing Protocol/1.1: Model and Semantics                 */
        /*      §4.3.5 [page 108-109] job-name (name(MAX))                                                  */
        /* -----------------                                                                                */
        /* This REQUIRED attribute is the name of the job.  It is a name that is more user friendly than    */
        /* the "job-uri" attribute value.  It does not need to be unique between Jobs.  The Job's           */
        /* "job-name" attribute is set to the value supplied by the client in the "job-name" operation      */
        /* attribute in the create request (see Section 3.2.1.1).   If, however, the "job-name" operation   */
        /* attribute is not supplied by the client in the create request, the Printer object, on creation   */
        /* of the Job, MUST generate a name.  The printer SHOULD generate the value of the Job's "job-name" */
        /* attribute from the first of the following sources that produces a value:                         */
        /*                                                                                                  */
        /*    1) the "document-name" operation attribute of the first (or only) document,                   */
        /*                                                                                                  */
        /*    2) the "document-URI" attribute of the first (or only) document, or                           */
        /*                                                                                                  */
        /*    3) any other piece of Job specific and/or Document Content information.                       */
        /*                                                                                                  */
        /* ================================================================================================ */
        /* [PWG 5100.11] October 30, 2010: Candidate Standard 5100.11-2010                                  */
        /*                       Internet Printing Protocol(IPP): Job and Printer Extensions - Set 2 (JPS2) */
        /*   §12.4.2 [page 72-73] Printer Conformance Requirements for the 'job-save-disposition" attribute */
        /* -----------------                                                                                */
        /* In order to claim conformance for the OPTIONAL "job-save-dispositions" Job Template attribute,   */
        /* Printers:                                                                                        */
        /*                                                                                                  */
        /*    1. MUST support the "job-save-disposition" (collection) Job Template attribute according to   */
        /*       the description in section 7.9, including the member attributes as REQUIRED by Table 7 and */
        /*       the "job-save-disposition-default" attribute and the "job-save-disposition-supported"      */
        /*       attribute.                                                                                 */
        /*                                                                                                  */
        /*    2. MUST support all of the "save-disposition" member attribute values defined in the          */
        /*       "job-save-disposition" description section 7.9.                                            */
        /*                                                                                                  */
        /*    3. MUST support the "save-info" (collection) member attribute according to the                */
        /*       "job-save-disposition" attribute description in section 7.9, including the member          */
        /*       attributes as REQUIRED by Table 8 and the "save-location-supported",                       */
        /*       "save-name-supported", "save-document-format-supported", and "save-info-supported" Printer */
        /*       attributes.                                                                                */
        /*                                                                                                  */
        /*    4. SHOULD support the 'ftp:', and 'http:' schemes and MAY support 'file:' scheme for use in   */
        /*       the "save-location" member attribute as defined in the "job-save-disposition" attribute    */
        /*       description in section 7.9.                                                                */
        /*                                                                                                  */
        /*    5. MUST support at least one "save-document-format" (mimeMediaType) attribute value, as       */
        /*       defined in the "job-save-disposition" attribute description in section 7.9, for use in the */
        /*       "save-document-format" member attribute.                                                   */
        /*                                                                                                  */
        /*    6. SHOULD support a superset of the values of the Printer's "save-document-format-supported"  */
        /*       attribute (section 7.9.1.2.3.3.2) as the values of the Printer's                           */
        /*       "document-format-supported" attribute ([RFC2911] section 4.4.22).                          */
        /*                                                                                                  */
        /*    7. MUST support the "job-save-printer-make-and-model" Job Description attribute (see          */
        /*       section 9.1).                                                                              */
        /*                                                                                                  */
        /*    8. MUST support the "which-jobs-supported" Printer Description attribute (see section 10.9)   */
        /*       and the 'saved' keyword values (see section 11.2).                                         */
        /*                                                                                                  */
        /*    9. MUST support the 'job-saving', 'job-saved-successfully', 'job-saved-with-warnings', and    */
        /*       'job-saved-with-errors' values of the "job-state-reasons" Job Description attribute as     */
        /*       defined in the "job-state-reasons" attribute description in section 11.3.                  */
        /*                                                                                                  */
        /* ================================================================================================ */
typedef struct {
    pwgCHAR   saveDocumentFormat[pwgMAX_SAVE_DOC_FMT_SIZE]; /* Doc fmt of the PrintService saved Doc Data   */
    pwgCHAR   saveLocation[pwgMAX_URI_SIZE];                /* URI the saved Docu Data & other Job info     */
    pwgCHAR   saveName[pwgMAX_SAVE_JOB_NAME_SIZE];          /* Saved Job Name for job info                  */

    VND_SAV_INFO_STRUCT

} pwgSaveInfo;


typedef struct {
    pwgINFO_DEF*  saveDocumentFormat;                 /* Doc fmt of the PrintService saved Doc Data         */
    pwgINFO_DEF*  saveLocation;                       /* URI the saved Docu Data & other Job info           */
    pwgINFO_DEF*  saveName;                           /* Saved Job Name for job info                        */

    VND_SAV_INFO_DEF_STRUCT

    pwgVOID*        last;
} pwgSaveInfoDefLst;

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */
extern pwgINFO_DEF pwgDef_SaveDocumentFormat;

extern pwgINFO_DEF pwgDef_SaveLocation;

extern pwgINFO_DEF pwgDef_SaveName;

extern pwgSaveInfoDefLst pwgSaveInfoDefElem;
extern pwgSTRUCT_DEF     pwgDef_SaveInfo;


/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_PJP_3_SAVE_INFO_H__                                                                    */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* =================================== pwg.pjt.pjp.3.save.info.h ========================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
