/* =================================== pwg.pjt.xxx.N.ticket.config.h ====================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
#ifndef __PWG_PJT_XXX_N_TICKET_CONFIG_H__
#define __PWG_PJT_XXX_N_TICKET_CONFIG_H__
#ifdef __cplusplus
extern "C" {
#endif

/*** From 5100.6: MAX integer value (2147483647)                                                            */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.types.h"
#include "pwg.pjt.xxx.N.level.config.h"

#include "pwg.pjt.xxx.N.adornment.types.h"

#define _MY_DEBUG_        1
#define _MY_TEST_TOOL_    1

#define PWG_SUPPORT_LEVEL PJT_SUPPORT_LEVEL_1

#define USE_VENDOR_EXTENSIONS 1

#include "pwg.pjt.xxx.N.vendor.extensions.h"

/* ----------------------------------------- General Comments --------------------------------------------- */

/* ..................................................|..................................................... */
/* Based on comment from PWG member - Need to research definitive documentation                             */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .  */
/*                                                                                                          */
/*                    + - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - +   */
/*                    ! PrintJobCol                                                                     !   */
/*                    !                                                                                 !   */
/*                    !                                                                                 !   */
/*    +----------+    !     +----------------+                                                          !   */
/*    | PrintJob |----!--+--| PrintJobStatus |                                                          !   */
/*    +----------+    !  |  +----------------+                                                          !   */
/*                    !  |                                                                              !   */
/*                    !  |  +----------------+                                                          !   */
/*                    !  +--| PrintJobTicket |                                                          !   */
/*                    !  |  +----------------+                                                          !   */
/*                    !  |                                                                              !   */
/*                    !  |  +-----------------+                                                         !   */
/*                    !  +--| PrintJobReceipt | ??????????                                              !   */
/*                    !  |  +-----------------+                                                         !   */
/*                    !  |                                                                              !   */
/*                    !  |                + - - - - - - - - - - - - - - - - - - - - - - - - +           !   */
/*                    !  |                ! DocumentCol                                     !           !   */
/*                    !  |                !                                                 !           !   */
/*                    !  |                !                                                 !           !   */
/*                    !  |  +----------+  !     +---------------------+                     !           !   */
/*                    !  +--| Document |--!--+--| PrintDocumentStatus |                     !           !   */
/*                    !     +----------+  !  |  +---------------------+                     !           !   */
/*                    !       0..infinite !  |                                              !           !   */
/*                    !                   !  |  +---------------------+                     !           !   */
/*                    !                   !  +--| PrintDocumentTicket |                     !           !   */
/*                    !                   !  |  +---------------------+                     !           !   */
/*                    !                   !  |                                              !           !   */
/*                    !                   !  |  +----------------------+                    !           !   */
/*                    !                   !  +--| PrintDocumentReceipt |??????              !           !   */
/*                    !                   !  |  +----------------------+                    !           !   */
/*                    !                   !  |                                              !           !   */
/*                    !                   !  |  +---------------------+                     !           !   */
/*                    !                   !  +--| DocumentContent[^1] |                     !           !   */
/*                    !                   !     +---------------------+                     !           !   */
/*                    !                   !                 0..infinite                     !           !   */
/*                    !                   !                                                 !           !   */
/*                    !                   + - - - - - - - - - - - - - - - - - - - - - - - - +           !   */
/*                    !                                                                                 !   */
/*                    + - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - +   */
/*                    [^1] => Document content is associated with the Document object.  It is not an        */
/*                            attribute of the object.  A document reference (DocumentUri) is a             */
/*                            Print[Job|Document]Description element that is copied to the                  */
/*                            Print[Job|Document]Status element.                                            */
/*                                                                                                          */
/* ======================================================================================================== */
/*  Legend ---                                                                                              */
/*      + - - - - - - - - - +   +------------------+   + - - - - + 123                      ! = Optional    */
/*      ! Optional Element  !   | Required Element |   | Element | ^^^ Support Level        | = Required    */
/*      X - - - - - - - - - Y   X------------------Y   + - - - - +                                          */
/*      ^                   ^                                                               !+ = Expansion  */
/*      ^                   Y = M for MustHonor element adornment                           |+ = Expansion  */
/*      ^                       Note for S and K the Expansion is typically for MustHonor                   */
/*      ^                                                                                                   */
/*      X = B for Boolean type            X = C for (Ref to) Complex type        X = I for Integer type     */
/*      X = K for Keyword type            X = R for Range of Integers            X = S for String type      */
/*      X = L for List of Integers        X = U for URI                          X = 6 for Base 64 Binary   */
/*      X = E for List of Keywords        X = T for List of Resolution                                      */
/*                                                                                                          */
/*                                 / - - \                                                                  */
/*      /---------\  A Sequence    !   o ! Select     / - - - - - - -\ Vendor                               */
/*      | -o-o-o- | of Elements    !__/o ! One of     ! any ##other  ! Extension                            */
/*      \---------/                !   o !            \ - - - - - - -/ Point                                */
/*                                 \ - - /                0..infinite                                       */
/*                                                                                                          */
/*                               + . . . . . . . . . +                                                      */
/*                               .  Attributes       .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*     | attributes | Expands to .  ! MustHonor !    .                                                      */
/*     +------------+            .  + - - - - - +    .                                                      */
/*                               .  / - - - - - - -\ .                                                      */
/*                               .  ! any ##other  ! .                                                      */
/*                               .  \ - - - - - - -/ .                                                      */
/*                               .      0..infinite  .                                                      */
/*                               + . . . . . . . . . +                                                      */
/*                                                                                                          */
/* ..................................................|..................................................... */
/* Keyword and Types                                                                                        */
/*                                                                                                          */
/*    "type1":  This IPP specification document must be revised (or another IETF standards track document   */
/*              which augments this document) to add a new keyword or a new enum.  No vendor defined        */
/*              keywords or enums are allowed.                                                              */
/*                                                                                                          */
/*    "type2":  Implementers can, at any time, add new keyword or enum values by proposing the complete     */
/*              specification to IANA:                                                                      */
/*                                                                                                          */
/*              iana@iana.org                                                                               */
/*                                                                                                          */
/*              IANA will forward the registration proposal to the IPP Designated Expert who will review    */
/*              the proposal with a mailing list that the Designated Expert keeps for this purpose.         */
/*              Initially, that list will be the mailing list used by the IPP WG:                           */
/*                                                                                                          */
/*              ipp@pwg.org                                                                                 */
/*                                                                                                          */
/*              even after the IPP WG is disbanded as permitted by [IANA-CON].                              */
/*                                                                                                          */
/*              The IPP Designated Expert is appointed by the IESG Area Director responsible for IPP,       */
/*              according to [IANA-CON].                                                                    */
/*                                                                                                          */
/*              When a type2 keyword or enum is approved, the IPP Designated Expert becomes the point of    */
/*              contact for any future maintenance that might be required for that registration.            */
/*                                                                                                          */
/*    "type3":  Implementers can, at any time, add new keyword and enum values by submitting the complete   */
/*              specification to IANA as for type2 who will forward the proposal to the IPP Designated      */
/*              Expert.  While no additional technical review is required, the IPP Designated Expert may,   */
/*              at his/her discretion, forward the proposal to the same mailing list as for type2           */
/*              registrations for advice and comment.                                                       */
/*                                                                                                          */
/*              When a type3 keyword or enum is approved by the IPP Designated Expert, the original         */
/*              proposer becomes the point of contact for any future maintenance that might be required     */
/*              for that registration.                                                                      */
/*                                                                                                          */
/* ======================================================================================================== */

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */

 /* SMIv1 forbids named-number enumerations of value '0'. */
 /* SMIv2 removed this restriction and allows 0 and negative enum values. */


#define pwgPJT_VERSION                  010000

#define pwgJOB_PRIORITY_MIN                 1
#define pwgJOB_PRIOTITY_MAX               100

#define pwgMULTI_DOC_SUPPORTED               1        /* Does this PJT instantiation support Multi-doc      */
#define pwgJOB_FINISHING_SUPPORTED           1        /* Does this PJT instantiation support job finishing  */
#define pwgFINISHING_SUPPORTED               1        /* Does this PJT instantiation support     finishing  */
#define pwgSIDES_SUPPORTED                   1        /* Does this PJT instantiation support sides          */
#define pwgCOLOR_SUPPORTED                   1        /* Does this PJT instantiation support color          */

#define pwgMAX_DOC_TKTS                    255        /* Maximum number of Document Tickets (documents)     */
#define pwgMAX_URI_SIZE                    255        /* Maximum string length for URI info                 */
#define pwgMAX_NUMBER_UP                     6        /* Maximum number of "numberUp"                       */
#define pwgMAX_DATE_TIME_SIZE               32        /* Maximum Size of date/time string                   */
#define pwgMAX_PHONE_NUMBER_SIZE           127        /* Maximum Size of Phone Number string                */
#define pwgMAX_PASSWORD_SIZE              1024        /* Maximum octet size of passwords                    */
#define pwgMAX_FORCE_FRONT_PAGES          1024        /* Maximum force front pages per job                  */
#define pwgMAX_INSERT_SHEEETS             1024        /* Maximum insert sheets per job                      */
#define pwgMAX_STITCHING_LOCATIONS         255        /* Maximum number of stitching locations              */
#define pwgMAX_OUTPUT_DEVICE_NAME          128        /* Maximum length of output device name (string)      */

#define pwgMAX_OVERRIDES                    30        /* Maximum number of "overrides"                      */
#define pwgMAX_OVERRIDES_ELEM             1024        /* Maximum number of  Override elements               */

#define pwgMAX_PAGE_RANGES                1024        /* Maximum number of page range pairs                 */
#define pwgMAX_NUM_OF_PAGES_PER_SUBSET     255        /* Maximum number of pages-per-subet values           */

#define pwgMAX_PDL_INIT_FILE_NAME          255        /* Maximum string length of file name                 */
#define pwgMAX_PDL_INIT_FILE_ENTRY         255        /* Maximum string length of file entry name           */
#define pwgMAX_PDL_INIT_FILES             1024        /* Maximum number of PDL init files                   */

#define pwgMAX_TEMPLATE_CREATOR_USER_NAME 1024        /* Maximum Size of the template creator user name.    */
#define pwgMAX_TEMPLATE_INFO_SIZE         2048        /* Maximum Size of information of a template          */
#define pwgMAX_TEMPLATE_NAME_SIZE         1024        /* Maximum Size of name for a template                */

#define pwgMAX_SAVE_DOC_FMT_SIZE           255        /* Maximum size of Document format of saved Doc Data  */
#define pwgMAX_SAVE_JOB_NAME_SIZE          255        /* Maximum size of Saved Job Name job                 */

#define pwgMAX_DOC_COPIES_RANGES          1024        /* Maximum number of Doc Copies range pairs           */
#define pwgMAX_DOC_NUM_RANGES             1024        /* Maximum number of Doc Numbers range pairs          */
#define pwgMAX_DOC_COPIES                   30        /* Maximum number of document "copies"                */
#define pwgMAX_DOC_FMT_VER_SIZE            128        /* Maximum Size of document format version string     */
#define pwgMAX_DOC_FMT_DEV_ID_SIZE         128        /* Maximum Size of document format device Id string   */
#define pwgMAX_DOC_SRC_APP_NAMED_SIZE     1024        /* Maximum Size of document Application name          */
#define pwgMAX_DOC_SRC_APP_VER_SIZE        128        /* Maximum Size of document Application version       */
#define pwgMAX_DOC_SRC_OS_NAME_SIZE         40        /* Maximum Size of document OS name                   */
#define pwgMAX_DOC_SRC_OS_VER_SIZE          40        /* Maximum Size of document OS version                */
#define pwgMAX_DOC_MESSAGE_SIZE           1024        /* Maximum Size of document message                   */
#define pwgMAX_DOC_META_DATA_SIZE         1024        /* Maximum Size of document meta data                 */
#define pwgMAX_DOC_NAME_SIZE               256        /* Maximum Size of document name                      */

#define pwgMAX_JOB_COPIES                   30        /* Maximum number of Job "copies"                     */
#define pwgMAX_JOB_ACC_ID                 1024        /* Maximum string length for job  account id          */
#define pwgMAX_JOB_ACC_USER_ID            1024        /* Maximum string length for user account id          */
#define pwgMAX_JOB_ERR_ACT_SIZE            255        /* Maximum string length for a JobErrorAction string  */
#define pwgMAX_JOB_MESS_FROM_OPR           127        /* Message from operator to the end user on the job.  */
#define pwgMAX_JOB_MESS_TO_OPR            1024        /* Message to operator from the end user on the job.  */
#define pwgMAX_JOB_NAME_SIZE              1024        /* Maximum Size of the user friendly name of the Job. */
#define pwgMAX_JOB_ORIG_USER_NAME_SIZE     255        /* Maximum Size of the job user name of the Job.      */
#define pwgMAX_JOB_RECIPIENT_NAME_SIZE     255        /* Name of the intended recipient of the Job.         */
#define pwgMAX_JOB_SHEET_MSG_SIZE          255        /* Maximum size of Job Sheet Message                  */


/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

#ifdef __cplusplus
}
#endif
#endif  /* __PWG_PJT_XXX_N_TICKET_CONFIG_H__                                                                */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* =================================== pwg.pjt.xxx.N.ticket.config.h ====================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
