/* ================================ pwg.pjt.xxx.N.vendor.extensions.h ===================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing                                                                      */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

#ifdef USE_VENDOR_EXTENSIONS

/* ######################################################################################################## */
/* PRINT_JOB_TICKET     PRINT_JOB_TICKET      PRINT_JOB_TICKET      PRINT_JOB_TICKET      PRINT_JOB_TICKET  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRINT_JOB_TICKET_STRUCT

#define VND_PRINT_JOB_TICKET_DEF_STRUCT

#define VND_PRINT_JOB_TICKET_ELEM_DATA

/* ######################################################################################################## */
/* PRINT_DOCUMENT_PROCESSING_1          PRINT_DOCUMENT_PROCESSING_1           PRINT_DOCUMENT_PROCESSING_1   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_DOC_PROC_STRUCT_1         pwgINT32  AnotherSide;

#define VND_PRT_DOC_PROC_DEF_STRUCT_1     pwgNUM_RNG_DEF* Anothersides;

#define VND_PRT_DOC_PROC_ELEM_DATA_1      &pwgDef_Sides,

/* ######################################################################################################## */
/* PRINT_DOCUMENT_PROCESSING_2          PRINT_DOCUMENT_PROCESSING_2           PRINT_DOCUMENT_PROCESSING_2   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
#define VND_PRT_DOC_PROC_STRUCT_2

#define VND_PRT_DOC_PROC_DEF_STRUCT_2

#define VND_PRT_DOC_PROC_ELEM_DATA_2
#else
#define VND_PRT_DOC_PROC_STRUCT_2
#define VND_PRT_DOC_PROC_DEF_STRUCT_2
#define VND_PRT_DOC_PROC_ELEM_DATA_2
#endif

/* ######################################################################################################## */
/* PRINT_DOCUMENT_PROCESSING_3          PRINT_DOCUMENT_PROCESSING_3           PRINT_DOCUMENT_PROCESSING_3   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
#define VND_PRT_DOC_PROC_STRUCT_3

#define VND_PRT_DOC_PROC_DEF_STRUCT_3

#define VND_PRT_DOC_PROC_ELEM_DATA_3
#else
#define VND_PRT_DOC_PROC_STRUCT_3
#define VND_PRT_DOC_PROC_DEF_STRUCT_3
#define VND_PRT_DOC_PROC_ELEM_DATA_3
#endif
/* ######################################################################################################## */
/* PRINT_DOCUMENT_PROCESSING            PRINT_DOCUMENT_PROCESSING              PRINT_DOCUMENT_PROCESSING    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_DOC_PROC_STRUCT         VND_PRT_DOC_PROC_STRUCT_1 \
                                        VND_PRT_DOC_PROC_STRUCT_2 \
                                        VND_PRT_DOC_PROC_STRUCT_3

#define VND_PRT_DOC_PROC_DEF_STRUCT     VND_PRT_DOC_PROC_DEF_STRUCT_1 \
                                        VND_PRT_DOC_PROC_DEF_STRUCT_2 \
                                        VND_PRT_DOC_PROC_DEF_STRUCT_3

#define VND_PRT_DOC_PROC_ELEM_DATA      VND_PRT_DOC_PROC_ELEM_DATA_1  \
                                        VND_PRT_DOC_PROC_ELEM_DATA_2  \
                                        VND_PRT_DOC_PROC_ELEM_DATA_3

/* ######################################################################################################## */
/* PRINT_DOCUMENT_TICKET      PRINT_DOCUMENT_TICKET     PRINT_DOCUMENT_TICKET     PRINT_DOCUMENT_TICKET     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_DOC_TKT_STRUCT

#define VND_PRT_DOC_TKT_DEF_STRUCT

#define VND_PRT_DOC_TKT_ELEM_DATA


/* ######################################################################################################## */
/* PRESENTATION_DIRECTION_NUMBER_UP    PRESENTATION_DIRECTION_NUMBER_UP    PRESENTATION_DIRECTION_NUMBER_UP */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRES_DIR_NUM_UP_ENUM

#define VND_PRES_DIR_NUM_UP_KW

#define VND_PRES_DIR_NUM_UP_KWV

#define VND_PRES_DIR_NUM_UP_KWVL

#define VND_PRES_DIR_NUM_UP_KWVS

/* ######################################################################################################## */
/* COVER_BACK    COVER_BACK     COVER_BACK      COVER_BACK      COVER_BACK     COVER_BACK     COVER_BACK    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_COVER_STRUCT

#define VND_COVER_DEF_STRUCT

#define VND_COVER_ELEM_DATA

/* ######################################################################################################## */
/* COVER_FRONT    COVER_FRONT    COVER_FRONT    COVER_FRONT    COVER_FRONT    COVER_FRONT    COVER_FRONT    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_COVER_STRUCT

#define VND_COVER_DEF_STRUCT

#define VND_COVER_ELEM_DATA

/* ######################################################################################################## */
/* FEED_ORIENTATION      FEED_ORIENTATION       FEED_ORIENTATION      FEED_ORIENTATION     FEED_ORIENTATION */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_FEED_ORIEN_ENUM

#define VND_FEED_ORIEN_KW

#define VND_FEED_ORIEN_KWV

#define VND_FEED_ORIEN_KWVL

#define VND_FEED_ORIEN_KWVS

/* ######################################################################################################## */
/* FINISHINGS     FINISHINGS      FINISHINGS      FINISHINGS      FINISHINGS      FINISHINGS     FINISHINGS */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_FIN_ENUM

#define VND_FIN_KW

#define VND_FIN_KWV

#define VND_FIN_KWVL

#define VND_FIN_KWVS

#define VND_FIN_COL_STRUCT

#define VND_FIN_COL_DEF_STRUCT

#define VND_FIN_COL_ELEM_DATA

/* ######################################################################################################## */
/* FONT_NAME_REQUESTED         FONT_NAME_REQUESTED          FONT_NAME_REQUESTED         FONT_NAME_REQUESTED */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_FONT_NAME_REQ_ENUM

#define VND_FONT_NAME_REQ_KW

#define VND_FONT_NAME_REQ_KWV

#define VND_FONT_NAME_REQ_KWVL

#define VND_FONT_NAME_REQ_KWVS

/* ######################################################################################################## */
/* IMPOSITION_TEMPLATE          IMPOSITION_TEMPLATE         IMPOSITION_TEMPLATE         IMPOSITION_TEMPLATE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_IMPS_TMPL_ENUM

#define VND_IMPS_TMPL_KW

#define VND_IMPS_TMPL_KWV

#define VND_IMPS_TMPL_KWVL

#define VND_IMPS_TMPL_KWVS

/* ######################################################################################################## */
/* COVER_BACK    COVER_BACK     COVER_BACK      COVER_BACK      COVER_BACK     COVER_BACK     COVER_BACK    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_INSERT_SHEET_STRUCT

#define VND_INSERT_SHEET_DEF_STRUCT

#define VND_INSERT_SHEET_ELEM_DATA

/* ######################################################################################################## */
/* JOB_ERROR_ACTION     JOB_ERROR_ACTION      JOB_ERROR_ACTION      JOB_ERROR_ACTION      JOB_ERROR_ACTION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_ERR_ACT_ENUM

#define VND_JOB_ERR_ACT_KW

#define VND_JOB_ERR_ACT_KWV

#define VND_JOB_ERR_ACT_KWVL

#define VND_JOB_ERR_ACT_KWVS

/* ######################################################################################################## */
/* MEDIA_DESCRIPTION_TYPE     MEDIA_DESCRIPTION_TYPE      MEDIA_DESCRIPTION_TYPE     MEDIA_DESCRIPTION_TYPE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_DES_TYP_ENUM

#define VND_MEDIA_DES_TYP_KW

#define VND_MEDIA_DES_TYP_KWV

#define VND_MEDIA_DES_TYP_KWVL

#define VND_MEDIA_DES_TYP_KWVS

/* ######################################################################################################## */
/* MEDIA_MARGINS  MEDIA_MARGINS  MEDIA_MARGINS  MEDIA_MARGINS  MEDIA_MARGINS  MEDIA_MARGINS  MEDIA_MARGINS  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_MRGN_STRUCT

#define VND_MEDIA_MRGN_DEF_STRUCT

#define VND_MEDIA_MRGN_ELEM_DATA

/* ######################################################################################################## */
/* MEDIA_SIZE   MEDIA_SIZE    MEDIA_SIZE    MEDIA_SIZE    MEDIA_SIZE   MEDIA_SIZE   MEDIA_SIZE   MEDIA_SIZE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_SIZ_STRUCT

#define VND_MEDIA_SIZ_DEF_STRUCT

#define VND_MEDIA_SIZ_ELEM_DATA

/* ######################################################################################################## */
/* MEDIA_SIZE_NAME    MEDIA_SIZE_NAME   MEDIA_SIZE_NAME   MEDIA_SIZE_NAME  MEDIA_SIZE_NAME  MEDIA_SIZE_NAME */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_SIZ_NAM_ENUM

#define VND_MEDIA_SIZ_NAM_KW                    \
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,

#define VND_MEDIA_SIZ_NAM_KWV                   \
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,\
              pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL, pwgNULL,


#define VND_MEDIA_SIZ_NAM_KWVL

#define VND_MEDIA_SIZ_NAM_KWVS

/* ######################################################################################################## */
/* MEDIA_TYPE     MEDIA_TYPE      MEDIA_TYPE     MEDIA_TYPE     MEDIA_TYPE     MEDIA_TYPE     MEDIA_TYPE    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_TYP_ENUM

#define VND_MEDIA_TYP_KW

#define VND_MEDIA_TYP_KWV

#define VND_MEDIA_TYP_KWVL

#define VND_MEDIA_TYP_KWVS

/* ######################################################################################################## */
/* MEDIA_COATING  MEDIA_COATING  MEDIA_COATING  MEDIA_COATING  MEDIA_COATING  MEDIA_COATING  MEDIA_COATING  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_COT_ENUM

#define VND_MEDIA_COT_KW

#define VND_MEDIA_COT_KWV

#define VND_MEDIA_COT_KWVL

#define VND_MEDIA_COT_KWVS

/* ######################################################################################################## */
/* MEDIA_COLOR   MEDIA_COLOR  MEDIA_COLOR  MEDIA_COLOR  MEDIA_COLOR  MEDIA_COLOR  MEDIA_COLOR  MEDIA_COLOR  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_CLR_ENUM

#define VND_MEDIA_CLR_KW

#define VND_MEDIA_CLR_KWV

#define VND_MEDIA_CLR_KWVL

#define VND_MEDIA_CLR_KWVS

/* ######################################################################################################## */
/* MEDIA_GRAIN    MEDIA_GRAIN    MEDIA_GRAIN    MEDIA_GRAIN    MEDIA_GRAIN    MEDIA_GRAIN    MEDIA_GRAIN    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_GRN_ENUM

#define VND_MEDIA_GRN_KW

#define VND_MEDIA_GRN_KWV

#define VND_MEDIA_GRN_KWVL

#define VND_MEDIA_GRN_KWVS

/* ######################################################################################################## */
/* MEDIA_KEY   MEDIA_KEY   MEDIA_KEY   MEDIA_KEY   MEDIA_KEY   MEDIA_KEY   MEDIA_KEY   MEDIA_KEY  MEDIA_KEY */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_KEY_ENUM

#define VND_MEDIA_KEY_KW

#define VND_MEDIA_KEY_KWV

#define VND_MEDIA_KEY_KWVL

#define VND_MEDIA_KEY_KWVS

/* ######################################################################################################## */
/* MEDIA_PRE_PRINTED    MEDIA_PRE_PRINTED     MEDIA_PRE_PRINTED     MEDIA_PRE_PRINTED     MEDIA_PRE_PRINTED */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_PREPRT_ENUM

#define VND_MEDIA_PREPRT_KW

#define VND_MEDIA_PREPRT_KWV

#define VND_MEDIA_PREPRT_KWVL

#define VND_MEDIA_PREPRT_KWVS

/* ######################################################################################################## */
/* MEDIA_RECYCLED   MEDIA_RECYCLED    MEDIA_RECYCLED    MEDIA_RECYCLED    MEDIA_RECYCLED    MEDIA_RECYCLED  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_RCY_ENUM

#define VND_MEDIA_RCY_KW

#define VND_MEDIA_RCY_KWV

#define VND_MEDIA_RCY_KWVL

#define VND_MEDIA_RCY_KWVS

/* ######################################################################################################## */
/* MEDIA_SOURCE   MEDIA_SOURCE    MEDIA_SOURCE    MEDIA_SOURCE   MEDIA_SOURCE   MEDIA_SOURCE   MEDIA_SOURCE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_SRC_ENUM

#define VND_MEDIA_SRC_KW

#define VND_MEDIA_SRC_KWV

#define VND_MEDIA_SRC_KWVL

#define VND_MEDIA_SRC_KWVS

/* ######################################################################################################## */
/* MEDIA_TOOTH   MEDIA_TOOTH  MEDIA_TOOTH  MEDIA_TOOTH  MEDIA_TOOTH  MEDIA_TOOTH  MEDIA_TOOTH  MEDIA_TOOTH  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_TTH_ENUM

#define VND_MEDIA_TTH_KW

#define VND_MEDIA_TTH_KWV

#define VND_MEDIA_TTH_KWVL

#define VND_MEDIA_TTH_KWVS

/* ######################################################################################################## */
/* MEDIA_COLLECTION     MEDIA_COLLECTION      MEDIA_COLLECTION      MEDIA_COLLECTION      MEDIA_COLLECTION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_COL_STRUCT

#define VND_MEDIA_COL_DEF_STRUCT

#define VND_MEDIA_COL_ELEM_DATA

/* ######################################################################################################## */
/* MEDIA_INPUT_TRAY_CHECK     MEDIA_INPUT_TRAY_CHECK      MEDIA_INPUT_TRAY_CHECK     MEDIA_INPUT_TRAY_CHECK */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MEDIA_INP_TRAY_ENUM

#define VND_MEDIA_INP_TRAY_KW

#define VND_MEDIA_INP_TRAY_KWV

#define VND_MEDIA_INP_TRAY_KWVL

#define VND_MEDIA_INP_TRAY_KWVS

/* ######################################################################################################## */
/* ORIENTATION_REQUESTED      ORIENTATION_REQUESTED     ORIENTATION_REQUESTED     ORIENTATION_REQUESTED     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_ORIEN_REQ_ENUM

#define VND_ORIEN_REQ_KW

#define VND_ORIEN_REQ_KWV

#define VND_ORIEN_REQ_KWVL

#define VND_ORIEN_REQ_KWVS

/* ######################################################################################################## */
/* OUTPUT_BIN     OUTPUT_BIN      OUTPUT_BIN      OUTPUT_BIN      OUTPUT_BIN      OUTPUT_BIN     OUTPUT_BIN */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_OUT_BIN_ENUM    PWG_OUTPUT_BIN_DEFAULT,

#define VND_OUT_BIN_KW      "PWG_OUTPUT_BIN_DEFAULT",

#define VND_OUT_BIN_KWV     "DefaultOutputBin",

#define VND_OUT_BIN_KWVL    PJT_SUPPORT_LEVEL_1,

#define VND_OUT_BIN_KWVS    pwgSUPPORTED,

/* ######################################################################################################## */
/* PAGE_DELIVERY      PAGE_DELIVERY     PAGE_DELIVERY     PAGE_DELIVERY     PAGE_DELIVERY     PAGE_DELIVERY */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PAG_DLV_ENUM

#define VND_PAG_DLV_KW

#define VND_PAG_DLV_KWV

#define VND_PAG_DLV_KWVL

#define VND_PAG_DLV_KWVS

/* ######################################################################################################## */
/* PAGE_RANGES     PAGE_RANGES    PAGE_RANGES    PAGE_RANGES    PAGE_RANGES    PAGE_RANGES    PAGE_RANGES   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PAG_RNG_STRUCT

#define VND_PAG_RNG_DEF_STRUCT

#define VND_PAG_RNG_ELEM_DATA

/* ######################################################################################################## */
/* PDL_INIT_FILES   PDL_INIT_FILES    PDL_INIT_FILES    PDL_INIT_FILES    PDL_INIT_FILES    PDL_INIT_FILES  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PDL_INIT_FIL_STRUCT

#define VND_PDL_INIT_FIL_DEF_STRUCT

#define VND_PDL_INIT_FIL_ELEM_DATA

/* ######################################################################################################## */
/* PRINT_CONTENT_OPTIMIZE     PRINT_CONTENT_OPTIMIZE      PRINT_CONTENT_OPTIMIZE     PRINT_CONTENT_OPTIMIZE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_CNT_OPT_ENUM

#define VND_PRT_CNT_OPT_KW

#define VND_PRT_CNT_OPT_KWV

#define VND_PRT_CNT_OPT_KWVL

#define VND_PRT_CNT_OPT_KWVS

/* ######################################################################################################## */
/* PRINT_COLOR_MODE     PRINT_COLOR_MODE      PRINT_COLOR_MODE      PRINT_COLOR_MODE      PRINT_COLOR_MODE  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_CLR_MOD_ENUM

#define VND_PRT_CLR_MOD_KW

#define VND_PRT_CLR_MOD_KWV

#define VND_PRT_CLR_MOD_KWVL

#define VND_PRT_CLR_MOD_KWVS

/* ######################################################################################################## */
/* PRINT_RENDERING_INTENT    PRINT_RENDERING_INTENT     PRINT_RENDERING_INTENT     PRINT_RENDERING_INTENT   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_RNDR_INT_ENUM

#define VND_PRT_RNDR_INT_KW

#define VND_PRT_RNDR_INT_KWV

#define VND_PRT_RNDR_INT_KWVL

#define VND_PRT_RNDR_INT_KWVS

/* ######################################################################################################## */
/* SEPARATOR_SHEETS     SEPARATOR_SHEETS      SEPARATOR_SHEETS      SEPARATOR_SHEETS      SEPARATOR_SHEETS  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_SEP_SHT_STRUCT

#define VND_SEP_SHT_DEF_STRUCT

#define VND_SEP_SHT_ELEM_DATA

/* ######################################################################################################## */
/* QUALITY      QUALITY     QUALITY     QUALITY     QUALITY     QUALITY     QUALITY     QUALITY     QUALITY */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_QUALITY_ENUM

#define VND_QUALITY_KW

#define VND_QUALITY_KWV

#define VND_QUALITY_KWVL

#define VND_QUALITY_KWVS

/* ######################################################################################################## */
/* RESOLUTION    RESOLUTION     RESOLUTION     RESOLUTION     RESOLUTION     RESOLUTION     RESOLUTION      */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_RES_STRUCT

#define VND_RES_DEF_STRUCT

#define VND_RES_ELEM_DATA

/* ######################################################################################################## */
/* RESOLUTION_UNITS     RESOLUTION_UNITS      RESOLUTION_UNITS      RESOLUTION_UNITS      RESOLUTION_UNITS  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_RES_UNITS_ENUM

#define VND_RES_UNITS_KW

#define VND_RES_UNITS_KWV

#define VND_RES_UNITS_KWVL

#define VND_RES_UNITS_KWVS

/* ######################################################################################################## */
/* SEPARATOR_SHEETS_TYPE      SEPARATOR_SHEETS_TYPE     SEPARATOR_SHEETS_TYPE     SEPARATOR_SHEETS_TYPE     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_SEP_SHT_TYP_ENUM

#define VND_SEP_SHT_TYP_KW

#define VND_SEP_SHT_TYP_KWV

#define VND_SEP_SHT_TYP_KWVL

#define VND_SEP_SHT_TYP_KWVS

/* ######################################################################################################## */
/* SHEET_COLLATE      SHEET_COLLATE     SHEET_COLLATE     SHEET_COLLATE     SHEET_COLLATE     SHEET_COLLATE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_SHT_COLT_ENUM

#define VND_SHT_COLT_KW

#define VND_SHT_COLT_KWV

#define VND_SHT_COLT_KWVL

#define VND_SHT_COLT_KWVS

/* ######################################################################################################## */
/* SIDES    SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   SIDES   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_SIDES_ENUM

#define VND_SIDES_KW

#define VND_SIDES_KWV

#define VND_SIDES_KWVL

#define VND_SIDES_KWVS

/* ######################################################################################################## */
/* X_IMAGE_POSITION     X_IMAGE_POSITION      X_IMAGE_POSITION      X_IMAGE_POSITION      X_IMAGE_POSITION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_X_IMG_POS_ENUM

#define VND_X_IMG_POS_KW

#define VND_X_IMG_POS_KWV

#define VND_X_IMG_POS_KWVL

#define VND_X_IMG_POS_KWVS

/* ######################################################################################################## */
/* Y_IMAGE_POSITION     Y_IMAGE_POSITION      Y_IMAGE_POSITION      Y_IMAGE_POSITION      Y_IMAGE_POSITION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_Y_IMG_POS_ENUM

#define VND_Y_IMG_POS_KW

#define VND_Y_IMG_POS_KWV

#define VND_Y_IMG_POS_KWVL

#define VND_Y_IMG_POS_KWVS

/* ######################################################################################################## */
/* PRINT_JOB_DESCRIPTION_1   PRINT_JOB_DESCRIPTION_1   PRINT_JOB_DESCRIPTION_1    PRINT_JOB_DESCRIPTION_1   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_JOB_DESC_STRUCT_1

#define VND_PRT_JOB_DESC_DEF_STRUCT_1

#define VND_PRT_JOB_DESC_ELEM_DATA_1

/* ######################################################################################################## */
/* PRINT_JOB_DESCRIPTION_2   PRINT_JOB_DESCRIPTION_2   PRINT_JOB_DESCRIPTION_2    PRINT_JOB_DESCRIPTION_2   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_1
#define VND_PRT_JOB_DESC_STRUCT_2

#define VND_PRT_JOB_DESC_DEF_STRUCT_2

#define VND_PRT_JOB_DESC_ELEM_DATA_2
#else
#define VND_PRT_JOB_DESC_STRUCT_2
#define VND_PRT_JOB_DESC_DEF_STRUCT_2
#define VND_PRT_JOB_DESC_ELEM_DATA_2
#endif

/* ######################################################################################################## */
/* PRINT_JOB_DESCRIPTION_3   PRINT_JOB_DESCRIPTION_3   PRINT_JOB_DESCRIPTION_3    PRINT_JOB_DESCRIPTION_3   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
#define VND_PRT_JOB_DESC_STRUCT_3

#define VND_PRT_JOB_DESC_DEF_STRUCT_3

#define VND_PRT_JOB_DESC_ELEM_DATA_3
#else
#define VND_PRT_JOB_DESC_STRUCT_3
#define VND_PRT_JOB_DESC_DEF_STRUCT_3
#define VND_PRT_JOB_DESC_ELEM_DATA_3
#endif
/* ######################################################################################################## */
/* PRINT_DOCUMENT_PROCESSING            PRINT_DOCUMENT_PROCESSING              PRINT_DOCUMENT_PROCESSING    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_JOB_DESC_STRUCT         VND_PRT_JOB_DESC_STRUCT_1 \
                                        VND_PRT_JOB_DESC_STRUCT_2 \
                                        VND_PRT_JOB_DESC_STRUCT_3

#define VND_PRT_JOB_DESC_DEF_STRUCT     VND_PRT_JOB_DESC_DEF_STRUCT_1 \
                                        VND_PRT_JOB_DESC_DEF_STRUCT_2 \
                                        VND_PRT_JOB_DESC_DEF_STRUCT_3

#define VND_PRT_JOB_DESC_ELEM_DATA      VND_PRT_JOB_DESC_ELEM_DATA_1  \
                                        VND_PRT_JOB_DESC_ELEM_DATA_2  \
                                        VND_PRT_JOB_DESC_ELEM_DATA_3

/* ######################################################################################################## */
/* NATURAL_LANGAUAGE     NATURAL_LANGAUAGE    NATURAL_LANGAUAGE    NATURAL_LANGAUAGE    NATURAL_LANGAUAGE   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_NAT_LANG_ENUM

#define VND_NAT_LANG_KW

#define VND_NAT_LANG_KWV

#define VND_NAT_LANG_KWVL

#define VND_NAT_LANG_KWVS

/* ######################################################################################################## */
/* JOB_PASSWORD_ENCRYPTION    JOB_PASSWORD_ENCRYPTION   JOB_PASSWORD_ENCRYPTION   JOB_PASSWORD_ENCRYPTION   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_PW_ENCRYP_ENUM

#define VND_JOB_PW_ENCRYP_KW

#define VND_JOB_PW_ENCRYP_KWV

#define VND_JOB_PW_ENCRYP_KWVL

#define VND_JOB_PW_ENCRYP_KWVS

/* ######################################################################################################## */
/* TEMPLATE_TYPE     TEMPLATE_TYPE     TEMPLATE_TYPE     TEMPLATE_TYPE     TEMPLATE_TYPE     TEMPLATE_TYPE  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_TMPL_TYP_ENUM

#define VND_TMPL_TYP_KW

#define VND_TMPL_TYP_KWV

#define VND_TMPL_TYP_KWVL

#define VND_TMPL_TYP_KWVS

/* ######################################################################################################## */
/* COMPRESSION   COMPRESSION    COMPRESSION    COMPRESSION     COMPRESSION    COMPRESSION   COMPRESSION     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_COMPRESSION_ENUM

#define VND_COMPRESSION_KW

#define VND_COMPRESSION_KWV

#define VND_COMPRESSION_KWVL

#define VND_COMPRESSION_KWVS

/* ######################################################################################################## */
/* DOCUMENT_CHARSET     DOCUMENT_CHARSET      DOCUMENT_CHARSET      DOCUMENT_CHARSET      DOCUMENT_CHARSET  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_DOC_CHR_SET_ENUM

#define VND_DOC_CHR_SET_KW

#define VND_DOC_CHR_SET_KWV

#define VND_DOC_CHR_SET_KWVL

#define VND_DOC_CHR_SET_KWVS

/* ######################################################################################################## */
/* DOCUMENT_DIGITAL_SIGNATURE           DOCUMENT_DIGITAL_SIGNATURE            DOCUMENT_DIGITAL_SIGNATURE    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_DOC_DIG_SIGN_ENUM

#define VND_DOC_DIG_SIGN_KW

#define VND_DOC_DIG_SIGN_KWV

#define VND_DOC_DIG_SIGN_KWVL

#define VND_DOC_DIG_SIGN_KWVS

/* ######################################################################################################## */
/* DOCUMENT_FORMAT_DETAILS    DOCUMENT_FORMAT_DETAILS     DOCUMENT_FORMAT_DETAILS   DOCUMENT_FORMAT_DETAILS */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_DOC_FMT_DTLS_STRUCT

#define VND_DOC_FMT_DTLS_DEF_STRUCT

#define VND_DOC_FMT_DTLS_ELEM_DATA

/* ######################################################################################################## */
/* DOCUMENT_FORMAT   DOCUMENT_FORMAT   DOCUMENT_FORMAT   DOCUMENT_FORMAT   DOCUMENT_FORMAT  DOCUMENT_FORMAT */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_DOC_FMT_ENUM

#define VND_DOC_FMT_KW

#define VND_DOC_FMT_KWV

#define VND_DOC_FMT_KWVL

#define VND_DOC_FMT_KWVS

/* ######################################################################################################## */
/* DOCUMENT_SOURCE_OS_NAME    DOCUMENT_SOURCE_OS_NAME   DOCUMENT_SOURCE_OS_NAME   DOCUMENT_SOURCE_OS_NAME   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_DOC_SRC_OS_NAM_ENUM

#define VND_DOC_SRC_OS_NAM_KW

#define VND_DOC_SRC_OS_NAM_KWV

#define VND_DOC_SRC_OS_NAM_KWVL

#define VND_DOC_SRC_OS_NAM_KWVS

/* ######################################################################################################## */
/* PAGE_ORDER_RECEIVED  PAGE_ORDER_RECEIVED  PAGE_ORDER_RECEIVED  PAGE_ORDER_RECEIVED  PAGE_ORDER_RECEIVED  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PG_ORD_RECV_ENUM

#define VND_PG_ORD_RECV_KW

#define VND_PG_ORD_RECV_KWV

#define VND_PG_ORD_RECV_KWVL

#define VND_PG_ORD_RECV_KWVS

/* ######################################################################################################## */
/* PRINT_JOB_PROCESSING_1    PRINT_JOB_PROCESSING_1     PRINT_JOB_PROCESSING_1     PRINT_JOB_PROCESSING_1   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_JOB_PRC_STRUCT_1

#define VND_PRT_JOB_PRC_DEF_STRUCT_1

#define VND_PRT_JOB_PRC_ELEM_DATA_1

/* ######################################################################################################## */
/* PRINT_JOB_PROCESSING_2    PRINT_JOB_PROCESSING_2     PRINT_JOB_PROCESSING_2     PRINT_JOB_PROCESSING_2   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
#define VND_PRT_JOB_PRC_STRUCT_2

#define VND_PRT_JOB_PRC_DEF_STRUCT_2

#define VND_PRT_JOB_PRC_ELEM_DATA_2
#else
#define VND_PRT_JOB_PRC_STRUCT_2
#define VND_PRT_JOB_PRC_DEF_STRUCT_2
#define VND_PRT_JOB_PRC_ELEM_DATA_2
#endif

/* ######################################################################################################## */
/* PRINT_JOB_PROCESSING_3    PRINT_JOB_PROCESSING_3     PRINT_JOB_PROCESSING_3     PRINT_JOB_PROCESSING_3   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#if PWG_SUPPORT_LEVEL > PJT_SUPPORT_LEVEL_2
#define VND_PRT_JOB_PRC_STRUCT_3

#define VND_PRT_JOB_PRC_DEF_STRUCT_3

#define VND_PRT_JOB_PRC_ELEM_DATA_3
#else
#define VND_PRT_JOB_PRC_STRUCT_3
#define VND_PRT_JOB_PRC_DEF_STRUCT_3
#define VND_PRT_JOB_PRC_ELEM_DATA_3
#endif
/* ######################################################################################################## */
/* PRINT_JOB_PROCESSING       PRINT_JOB_PROCESSING        PRINT_JOB_PROCESSING        PRINT_JOB_PROCESSING  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRT_JOB_PRC_STRUCT          VND_PRT_JOB_PRC_STRUCT_1 \
                                        VND_PRT_JOB_PRC_STRUCT_2 \
                                        VND_PRT_JOB_PRC_STRUCT_3

#define VND_PRT_JOB_PRC_DEF_STRUCT      VND_PRT_JOB_PRC_DEF_STRUCT_1 \
                                        VND_PRT_JOB_PRC_DEF_STRUCT_2 \
                                        VND_PRT_JOB_PRC_DEF_STRUCT_3

#define VND_PRT_JOB_PRC_ELEM_DATA       VND_PRT_JOB_PRC_ELEM_DATA_1  \
                                        VND_PRT_JOB_PRC_ELEM_DATA_2  \
                                        VND_PRT_JOB_PRC_ELEM_DATA_3










/* ######################################################################################################## */
/* JOB_DELAY_OUTPUT_UNTIL    JOB_DELAY_OUTPUT_UNTIL      JOB_DELAY_OUTPUT_UNTIL      JOB_DELAY_OUTPUT_UNTIL */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_DLY_OUT_UTL_ENUM

#define VND_JOB_DLY_OUT_UTL_KW

#define VND_JOB_DLY_OUT_UTL_KWV

#define VND_JOB_DLY_OUT_UTL_KWVL

#define VND_JOB_DLY_OUT_UTL_KWVS

/* ######################################################################################################## */
/* JOB_HOLD_UNTIL   JOB_HOLD_UNTIL    JOB_HOLD_UNTIL    JOB_HOLD_UNTIL    JOB_HOLD_UNTIL    JOB_HOLD_UNTIL  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_HLD_UTL_ENUM

#define VND_JOB_HLD_UTL_KW

#define VND_JOB_HLD_UTL_KWV

#define VND_JOB_HLD_UTL_KWVL

#define VND_JOB_HLD_UTL_KWVS

/* ######################################################################################################## */
/* JOB_MANDATORY_ELEMENTS    JOB_MANDATORY_ELEMENTS     JOB_MANDATORY_ELEMENTS     JOB_MANDATORY_ELEMENTS   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_MAN_ELEM_ENUM

#define VND_JOB_MAN_ELEM_KW

#define VND_JOB_MAN_ELEM_KWV

#define VND_JOB_MAN_ELEM_KWVL

#define VND_JOB_MAN_ELEM_KWVS

/* ######################################################################################################## */
/* JOB_ACCOUNTING_SHEETS      JOB_ACCOUNTING_SHEETS     JOB_ACCOUNTING_SHEETS     JOB_ACCOUNTING_SHEETS     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_ACC_SHT_STRUCT

#define VND_JOB_ACC_SHT_DEF_STRUCT

#define VND_JOB_ACC_SHT_ELEM_DATA

/* ######################################################################################################## */
/* JOB_ACCOUNTING_SHEETS_TYPE           JOB_ACCOUNTING_SHEETS_TYPE            JOB_ACCOUNTING_SHEETS_TYPE    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_ACC_SHT_TYP_ENUM

#define VND_JOB_ACC_SHT_TYP_KW

#define VND_JOB_ACC_SHT_TYP_KWV

#define VND_JOB_ACC_SHT_TYP_KWVL

#define VND_JOB_ACC_SHT_TYP_KWVS

/* ######################################################################################################## */
/* JOB_ACCOUNTING_OUTPUT_BIN              JOB_ACCOUNTING_OUTPUT_BIN           JOB_ACCOUNTING_OUTPUT_BIN     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_ACC_OUT_BIN_ENUM

#define VND_JOB_ACC_OUT_BIN_KW

#define VND_JOB_ACC_OUT_BIN_KWV

#define VND_JOB_ACC_OUT_BIN_KWVL

#define VND_JOB_ACC_OUT_BIN_KWVS

/* ######################################################################################################## */
/* JOB_COLLATION_TYPE   JOB_COLLATION_TYPE    JOB_COLLATION_TYPE    JOB_COLLATION_TYPE   JOB_COLLATION_TYPE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_COLT_TYP_ENUM

#define VND_JOB_COLT_TYP_KW

#define VND_JOB_COLT_TYP_KWV

#define VND_JOB_COLT_TYP_KWVL

#define VND_JOB_COLT_TYP_KWVS

/* ######################################################################################################## */
/* JOB_COVER_BACK   JOB_COVER_BACK    JOB_COVER_BACK    JOB_COVER_BACK    JOB_COVER_BACK    JOB_COVER_BACK  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_CVR_BACK_STRUCT         VND_COVER_DEF_STRUCT

#define VND_JOB_CVR_BACK_DEF_STRUCT

#define VND_JOB_CVR_BACK_ELEM_DATA

/* ######################################################################################################## */
/* JOB_COVER_FRONT   JOB_COVER_FRONT  JOB_COVER_FRONT  JOB_COVER_FRONT   JOB_COVER_FRONT   JOB_COVER_FRONT  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_CVR_FRNT_STRUCT         VND_COVER_DEF_STRUCT

#define VND_JOB_CVR_FRNT_DEF_STRUCT

#define VND_JOB_CVR_FRNT_ELEM_DATA

/* ######################################################################################################## */
/* COVER_TYPE   COVER_TYPE    COVER_TYPE    COVER_TYPE    COVER_TYPE   COVER_TYPE   COVER_TYPE   COVER_TYPE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_CVR_TYP_ENUM

#define VND_CVR_TYP_KW

#define VND_CVR_TYP_KWV

#define VND_CVR_TYP_KWVL

#define VND_CVR_TYP_KWVS

/* ######################################################################################################## */
/* JOB_ERROR_SHEET   JOB_ERROR_SHEET  JOB_ERROR_SHEET  JOB_ERROR_SHEET  JOB_ERROR_SHEET  JOB_ERROR_SHEET    */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_ERR_SHT_STRUCT

#define VND_JOB_ERR_SHT_DEF_STRUCT

#define VND_JOB_ERR_SHT_ELEM_DATA

/* ######################################################################################################## */
/* JOB_ERROR_SHEET_TYPE       JOB_ERROR_SHEET_TYPE        JOB_ERROR_SHEET_TYPE        JOB_ERROR_SHEET_TYPE  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_SHT_TYP_ENUM

#define VND_JOB_SHT_TYP_KW

#define VND_JOB_SHT_TYP_KWV

#define VND_JOB_SHT_TYP_KWVL

#define VND_JOB_SHT_TYP_KWVS

/* ######################################################################################################## */
/* JOB_ERROR_SHEET_WHEN       JOB_ERROR_SHEET_WHEN        JOB_ERROR_SHEET_WHEN        JOB_ERROR_SHEET_WHEN  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_SHT_WHN_ENUM

#define VND_JOB_SHT_WHN_KW

#define VND_JOB_SHT_WHN_KWV

#define VND_JOB_SHT_WHN_KWVL

#define VND_JOB_SHT_WHN_KWVS

/* ######################################################################################################## */
/* JOB_FINISHINGS   JOB_FINISHINGS    JOB_FINISHINGS    JOB_FINISHINGS    JOB_FINISHINGS    JOB_FINISHINGS  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_FIN_ENUM

#define VND_JOB_FIN_KW

#define VND_JOB_FIN_KWV

#define VND_JOB_FIN_KWVL

#define VND_JOB_FIN_KWVS

/* ######################################################################################################## */
/* JOB_FINISHINGS_COLLECTION          JOB_FINISHINGS_COLLECTION         JOB_FINISHINGS_COLLECTION           */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_FIN_COL_STRUCT

#define VND_JOB_FIN_COL_DEF_STRUCT

#define VND_JOB_FIN_COL_ELEM_DATA

/* ######################################################################################################## */
/* STITCHING_COLLECTION       STITCHING_COLLECTION        STITCHING_COLLECTION        STITCHING_COLLECTION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_STH_COL_STRUCT

#define VND_STH_COL_DEF_STRUCT

#define VND_STH_COL_ELEM_DATA

/* ######################################################################################################## */
/* STITCHING_REF_EDGE   STITCHING_REF_EDGE    STITCHING_REF_EDGE    STITCHING_REF_EDGE   STITCHING_REF_EDGE */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_STH_REF_EDG_ENUM

#define VND_STH_REF_EDG_KW

#define VND_STH_REF_EDG_KWV

#define VND_STH_REF_EDG_KWVL

#define VND_STH_REF_EDG_KWVS

/* ######################################################################################################## */
/* JOB_SAVE_DISPOSITION       JOB_SAVE_DISPOSITION        JOB_SAVE_DISPOSITION        JOB_SAVE_DISPOSITION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_SAV_DISP_STRUCT

#define VND_JOB_SAV_DISP_DEF_STRUCT

#define VND_JOB_SAV_DISP_ELEM_DATA

/* ######################################################################################################## */
/* SAVE_DISPOSITION     SAVE_DISPOSITION      SAVE_DISPOSITION      SAVE_DISPOSITION      SAVE_DISPOSITION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_SAV_DISP_ENUM

#define VND_SAV_DISP_KW

#define VND_SAV_DISP_KWV

#define VND_SAV_DISP_KWVL

#define VND_SAV_DISP_KWVS

/* ######################################################################################################## */
/* SAVE_INFO   SAVE_INFO   SAVE_INFO   SAVE_INFO   SAVE_INFO   SAVE_INFO   SAVE_INFO   SAVE_INFO  SAVE_INFO */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_SAV_INFO_STRUCT

#define VND_SAV_INFO_DEF_STRUCT

#define VND_SAV_INFO_ELEM_DATA

/* ######################################################################################################## */
/* JOB_SHEETS   JOB_SHEETS    JOB_SHEETS    JOB_SHEETS    JOB_SHEETS   JOB_SHEETS   JOB_SHEETS   JOB_SHEETS */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_SHT_ENUM

#define VND_JOB_SHT_KW

#define VND_JOB_SHT_KWV

#define VND_JOB_SHT_KWVL

#define VND_JOB_SHT_KWVS

/* ######################################################################################################## */
/* JOB_SHEETS_COLLECTION       JOB_SHEETS_COLLECTION      JOB_SHEETS_COLLECTION      JOB_SHEETS_COLLECTION  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_JOB_SHT_COL_STRUCT

#define VND_JOB_SHT_COL_DEF_STRUCT

#define VND_JOB_SHT_COL_ELEM_DATA

/* ######################################################################################################## */
/* MULTIPLE_DOCUMENTS_HANDLING          MULTIPLE_DOCUMENTS_HANDLING         MULTIPLE_DOCUMENTS_HANDLING     */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_MULT_DOC_HND_ENUM

#define VND_MULT_DOC_HND_KW

#define VND_MULT_DOC_HND_KWV

#define VND_MULT_DOC_HND_KWVL

#define VND_MULT_DOC_HND_KWVS

/* ######################################################################################################## */
/* OVERRIDES   OVERRIDES   OVERRIDES   OVERRIDES   OVERRIDES   OVERRIDES   OVERRIDES   OVERRIDES  OVERRIDES */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_OVERRIDES_STRUCT

#define VND_OVERRIDES_DEF_STRUCT

#define VND_OVERRIDES_ELEM_DATA

/* ######################################################################################################## */
/* OVERRIDING_ELEMENTS  OVERRIDING_ELEMENTS  OVERRIDING_ELEMENTS  OVERRIDING_ELEMENTS  OVERRIDING_ELEMENTS  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_OVR_ELEM_ENUM

#define VND_OVR_ELEM_KW

#define VND_OVR_ELEM_KWV

#define VND_OVR_ELEM_KWVL

#define VND_OVR_ELEM_KWVS

/* ######################################################################################################## */
/* PROOF_PRINT     PROOF_PRINT    PROOF_PRINT    PROOF_PRINT    PROOF_PRINT    PROOF_PRINT    PROOF_PRINT   */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#define VND_PRF_PRT_STRUCT

#define VND_PRF_PRT_DEF_STRUCT

#define VND_PRF_PRT_ELEM_DATA


/* ######################################################################################################## */
/* ######################################################################################################## */
/* ######################################################################################################## */
/* DO NOT CHANGE THE CODE BELOW         DO NOT CHANGE THE CODE BELOW          DO NOT CHANGE THE CODE BELOW  */
/* DO NOT CHANGE THE CODE BELOW         DO NOT CHANGE THE CODE BELOW          DO NOT CHANGE THE CODE BELOW  */
/* DO NOT CHANGE THE CODE BELOW         DO NOT CHANGE THE CODE BELOW          DO NOT CHANGE THE CODE BELOW  */
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
#else /* Don't USE_VENDOR_EXTENSIONS                                                                        */
#define VND_PRINT_JOB_TICKET_STRUCT
#define VND_PRINT_JOB_TICKET_DEF_STRUCT
#define VND_PRINT_JOB_TICKET_ELEM_DATA

#define VND_PRT_DOC_PROC_STRUCT
#define VND_PRT_DOC_PROC_DEF_STRUCT
#define VND_PRT_DOC_PROC_ELEM_DATA

  #define VND_PRES_DIR_NUM_UP_ENUM
  #define VND_PRES_DIR_NUM_UP_KW
  #define VND_PRES_DIR_NUM_UP_KWV
  #define VND_PRES_DIR_NUM_UP_KWVL

  #define VND_COVER_STRUCT
  #define VND_COVER_DEF_STRUCT
  #define VND_COVER_ELEM_DATA

  #define VND_COVER_STRUCT
  #define VND_COVER_DEF_STRUCT
  #define VND_COVER_ELEM_DATA

  #define VND_FEED_ORIEN_ENUM
  #define VND_FEED_ORIEN_KW
  #define VND_FEED_ORIEN_KWV
  #define VND_FEED_ORIEN_KWVL

  #define VND_FIN_ENUM
  #define VND_FIN_KW
  #define VND_FIN_KWV
  #define VND_FIN_KWVL

  #define VND_FIN_COL_STRUCT
  #define VND_FIN_COL_DEF_STRUCT
  #define VND_FIN_COL_ELEM_DATA

  #define VND_FONT_NAME_REQ_ENUM
  #define VND_FONT_NAME_REQ_KW
  #define VND_FONT_NAME_REQ_KWV
  #define VND_FONT_NAME_REQ_KWVL

  #define VND_IMPS_TMPL_ENUM
  #define VND_IMPS_TMPL_KW
  #define VND_IMPS_TMPL_KWV
  #define VND_IMPS_TMPL_KWVL

  #define VND_INSERT_SHEET_STRUCT
  #define VND_INSERT_SHEET_DEF_STRUCT
  #define VND_INSERT_SHEET_ELEM_DATA

  #define VND_MEDIA_DES_TYP_ENUM
  #define VND_MEDIA_DES_TYP_KW
  #define VND_MEDIA_DES_TYP_KWV
  #define VND_MEDIA_DES_TYP_KWVL

  #define VND_MEDIA_SIZ_NAM_ENUM
  #define VND_MEDIA_SIZ_NAM_KW
  #define VND_MEDIA_SIZ_NAM_KWV
  #define VND_MEDIA_SIZ_NAM_KWVL

  #define VND_MEDIA_TYP_ENUM
  #define VND_MEDIA_TYP_KW
  #define VND_MEDIA_TYP_KWV
  #define VND_MEDIA_TYP_KWVL

  #define VND_MEDIA_COL_STRUCT
  #define VND_MEDIA_COL_DEF_STRUCT
  #define VND_MEDIA_COL_ELEM_DATA

  #define VND_MEDIA_INP_TRAY_ENUM
  #define VND_MEDIA_INP_TRAY_KW
  #define VND_MEDIA_INP_TRAY_KWV
  #define VND_MEDIA_INP_TRAY_KWVL

  #define VND_ORIEN_REQ_ENUM
  #define VND_ORIEN_REQ_KW
  #define VND_ORIEN_REQ_KWV
  #define VND_ORIEN_REQ_KWVL

  #define VND_OUT_BIN_ENUM
  #define VND_OUT_BIN_KW
  #define VND_OUT_BIN_KWV
  #define VND_OUT_BIN_KWVL

  #define VND_PAG_DLV_ENUM
  #define VND_PAG_DLV_KW
  #define VND_PAG_DLV_KWV
  #define VND_PAG_DLV_KWVL

  #define VND_PAG_RNG_STRUCT
  #define VND_PAG_RNG_DEF_STRUCT
  #define VND_PAG_RNG_ELEM_DATA

  #define VND_PDL_INIT_FIL_STRUCT
  #define VND_PDL_INIT_FIL_DEF_STRUCT
  #define VND_PDL_INIT_FIL_ELEM_DATA

  #define VND_PRT_CNT_OPT_ENUM
  #define VND_PRT_CNT_OPT_KW
  #define VND_PRT_CNT_OPT_KWV
  #define VND_PRT_CNT_OPT_KWVL

  #define VND_PRT_CLR_MOD_ENUM
  #define VND_PRT_CLR_MOD_KW
  #define VND_PRT_CLR_MOD_KWV
  #define VND_PRT_CLR_MOD_KWVL

  #define VND_PRT_RNDR_INT_ENUM
  #define VND_PRT_RNDR_INT_KW
  #define VND_PRT_RNDR_INT_KWV
  #define VND_PRT_RNDR_INT_KWVL

  #define VND_QUALITY_ENUM
  #define VND_QUALITY_KW
  #define VND_QUALITY_KWV
  #define VND_QUALITY_KWVL

  #define VND_RES_STRUCT
  #define VND_RES_DEF_STRUCT
  #define VND_RES_ELEM_DATA

  #define VND_RES_UNITS_ENUM
  #define VND_RES_UNITS_KW
  #define VND_RES_UNITS_KWV
  #define VND_RES_UNITS_KWVL

  #define VND_SEP_SHT_TYP_ENUM
  #define VND_SEP_SHT_TYP_KW
  #define VND_SEP_SHT_TYP_KWV
  #define VND_SEP_SHT_TYP_KWVL

  #define VND_SHT_COLT_ENUM
  #define VND_SHT_COLT_KW
  #define VND_SHT_COLT_KWV
  #define VND_SHT_COLT_KWVL

  #define VND_SIDES_ENUM
  #define VND_SIDES_KW
  #define VND_SIDES_KWV
  #define VND_SIDES_KWVL

  #define VND_X_IMG_POS_ENUM
  #define VND_X_IMG_POS_KW
  #define VND_X_IMG_POS_KWV
  #define VND_X_IMG_POS_KWVL

  #define VND_Y_IMG_POS_ENUM
  #define VND_Y_IMG_POS_KW
  #define VND_Y_IMG_POS_KWV
  #define VND_Y_IMG_POS_KWVL

  #define VND_PRT_JOB_DESC_STRUCT
  #define VND_PRT_JOB_DESC_DEF_STRUCT
  #define VND_PRT_JOB_DESC_ELEM_DATA

  #define VND_NAT_LANG_ENUM
  #define VND_NAT_LANG_KW
  #define VND_NAT_LANG_KWV
  #define VND_NAT_LANG_KWVL

  #define VND_JOB_PW_ENCRYP_ENUM
  #define VND_JOB_PW_ENCRYP_KW
  #define VND_JOB_PW_ENCRYP_KWV
  #define VND_JOB_PW_ENCRYP_KWVL

  #define VND_TMPL_TYP_ENUM
  #define VND_TMPL_TYP_KW
  #define VND_TMPL_TYP_KWV
  #define VND_TMPL_TYP_KWVL

  #define VND_COMPRESSION_ENUM
  #define VND_COMPRESSION_KW
  #define VND_COMPRESSION_KWV
  #define VND_COMPRESSION_KWVL

  #define VND_DOC_CHR_SET_ENUM
  #define VND_DOC_CHR_SET_KW
  #define VND_DOC_CHR_SET_KWV
  #define VND_DOC_CHR_SET_KWVL

  #define VND_DOC_DIG_SIGN_ENUM
  #define VND_DOC_DIG_SIGN_KW
  #define VND_DOC_DIG_SIGN_KWV
  #define VND_DOC_DIG_SIGN_KWVL

  #define VND_DOC_FMT_DTLS_STRUCT
  #define VND_DOC_FMT_DTLS_DEF_STRUCT
  #define VND_DOC_FMT_DTLS_ELEM_DATA

  #define VND_DOC_FMT_ENUM
  #define VND_DOC_FMT_KW
  #define VND_DOC_FMT_KWV
  #define VND_DOC_FMT_KWVL

  #define VND_PG_ORD_RECV_ENUM
  #define VND_PG_ORD_RECV_KW
  #define VND_PG_ORD_RECV_KWV
  #define VND_PG_ORD_RECV_KWVL

  #define VND_PRT_JOB_PRC_STRUCT
  #define VND_PRT_JOB_PRC_DEF_STRUCT
  #define VND_PRT_JOB_PRC_ELEM_DATA

  #define VND_JOB_DLY_OUT_UTL_ENUM
  #define VND_JOB_DLY_OUT_UTL_KW
  #define VND_JOB_DLY_OUT_UTL_KWV
  #define VND_JOB_DLY_OUT_UTL_KWVL

  #define VND_JOB_HLD_UTL_ENUM
  #define VND_JOB_HLD_UTL_KW
  #define VND_JOB_HLD_UTL_KWV
  #define VND_JOB_HLD_UTL_KWVL

  #define VND_JOB_MAN_ELEM_ENUM
  #define VND_JOB_MAN_ELEM_KW
  #define VND_JOB_MAN_ELEM_KWV
  #define VND_JOB_MAN_ELEM_KWVL

  #define VND_JOB_ACC_SHT_STRUCT
  #define VND_JOB_ACC_SHT_DEF_STRUCT
  #define VND_JOB_ACC_SHT_ELEM_DATA

  #define VND_JOB_COLT_TYP_ENUM
  #define VND_JOB_COLT_TYP_KW
  #define VND_JOB_COLT_TYP_KWV
  #define VND_JOB_COLT_TYP_KWVL

  #define VND_JOB_CVR_BACK_STRUCT
  #define VND_JOB_CVR_BACK_DEF_STRUCT
  #define VND_JOB_CVR_BACK_ELEM_DATA

  #define VND_JOB_CVR_FRNT_STRUCT
  #define VND_JOB_CVR_FRNT_DEF_STRUCT
  #define VND_JOB_CVR_FRNT_ELEM_DATA

  #define VND_JOB_ERR_SHT_STRUCT
  #define VND_JOB_ERR_SHT_DEF_STRUCT
  #define VND_JOB_ERR_SHT_ELEM_DATA

  #define VND_JOB_FIN_ENUM
  #define VND_JOB_FIN_KW
  #define VND_JOB_FIN_KWV
  #define VND_JOB_FIN_KWVL

  #define VND_JOB_FIN_COL_STRUCT
  #define VND_JOB_FIN_COL_DEF_STRUCT
  #define VND_JOB_FIN_COL_ELEM_DATA

  #define VND_JOB_SAV_DISP_STRUCT
  #define VND_JOB_SAV_DISP_DEF_STRUCT
  #define VND_JOB_SAV_DISP_ELEM_DATA

  #define VND_JOB_SHT_ENUM
  #define VND_JOB_SHT_KW
  #define VND_JOB_SHT_KWV
  #define VND_JOB_SHT_KWVL

  #define VND_JOB_SHT_COL_STRUCT
  #define VND_JOB_SHT_COL_DEF_STRUCT
  #define VND_JOB_SHT_COL_ELEM_DATA

  #define VND_MULT_DOC_HND_ENUM
  #define VND_MULT_DOC_HND_KW
  #define VND_MULT_DOC_HND_KWV
  #define VND_MULT_DOC_HND_KWVL

  #define VND_OVERRIDES_STRUCT
  #define VND_OVERRIDES_DEF_STRUCT
  #define VND_OVERRIDES_ELEM_DATA

  #define VND_PRF_PRT_STRUCT
  #define VND_PRF_PRT_DEF_STRUCT
  #define VND_PRF_PRT_ELEM_DATA

#endif /* USE_VENDOR_EXTENSIONS                                                                             */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ================================ pwg.pjt.xxx.N.vendor.extensions.h ===================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
