/* ============================= pwg.pjt.pjp.2.job.accounting.output.bin.c ================================ */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*                          Initial                                                                         */
/*                          Developing - 2nd pass based on PWG:PJT Candidate Standard                       */
/*                          Working                                                                         */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */
#include "pwg.pjt.pjp.2.job.accounting.output.bin.h"

/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/* Job Accounting Output Bin                                                                                */
/* ======================================================================================================== */
/* [PWG 5108.07] August 1, 2012: Candidate Standard 5108.07-2012 - Status: Stable                           */
/*                                 PWG Print Job Ticket and Associated Capabilities Version 1.0 (PJT)       */
/*      §Appendix A: PrintJobTicket Elements' Semantic Information [page 47] JobAccountingOutputBin         */
/* -----------------                                                                                        */
/* Specifies the output bin where the accounting sheet is to be placed.                                     */
/*    Values: OutputBinWKV, KeywordNsPattern  (e.g.,  Bottom, FaceUp, LargeCapacity, Left, MailboxN*,       */
/*                                                    Rear, Right, Side, StackerN*, Top, TrayN*.            */
/*                                                    *Note: N is replaced by a cardinal number)            */
/* ..................................................|..................................................... */
#if (_MY_DEBUG_ || _MY_TEST_TOOL_)
pwgCHAR* pwgJobAccountingOutputBin_Keywords[] = {
    "-",
    "-",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_UNKNOWN",

    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TOP",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MIDDLE",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_BOTTOM",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_SIDE",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_LEFT",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_RIGHT",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_CENTER",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_REAR",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_FACE_UP",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_FACE_DOWN",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_LARGE_CAPACITY",

    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_1",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_2",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_3",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_4",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_5",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_6",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_7",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_8",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_9",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_STACKER_10",

    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_1",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_2",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_3",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_4",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_5",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_6",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_7",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_8",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_9",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_10",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_11",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_12",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_13",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_14",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_15",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_16",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_17",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_18",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_19",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_20",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_21",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_22",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_23",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_24",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MAILBOX_25",

    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_MY_MAILBOX",

    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_1",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_2",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_3",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_4",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_5",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_6",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_7",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_8",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_9",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_10",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_11",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_12",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_13",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_14",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_15",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_16",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_17",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_18",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_19",
    "PWG_JOB_ACCOUNTING_OUTPUT_BIN_TRAY_20",

    VND_JOB_ACC_OUT_BIN_KW

    pwgNULL
};
#else
pwgCHAR* pwgJobAccountingOutputBin_Keywords[] = {pwgNULL};
#endif

pwgCHAR* pwgJobAccountingOutputBin_KWValues[] = {
    "-",
    "_",
    "Unknown",

    "top",
    "middle",
    "bottom",
    "side",
    "left",
    "right",
    "center",
    "rear",
    "face-up",
    "face-down",
    "large-capacity",

    "stacker-1",
    "stacker-2",
    "stacker-3",
    "stacker-4",
    "stacker-5",
    "stacker-6",
    "stacker-7",
    "stacker-8",
    "stacker-9",
    "stacker-10",

    "mailbox-1",
    "mailbox-2",
    "mailbox-3",
    "mailbox-4",
    "mailbox-5",
    "mailbox-6",
    "mailbox-7",
    "mailbox-8",
    "mailbox-9",
    "mailbox-10",
    "mailbox-11",
    "mailbox-12",
    "mailbox-13",
    "mailbox-14",
    "mailbox-15",
    "mailbox-16",
    "mailbox-17",
    "mailbox-18",
    "mailbox-19",
    "mailbox-20",
    "mailbox-21",
    "mailbox-22",
    "mailbox-23",
    "mailbox-24",
    "mailbox-25",

    "my-mailbox",

    "tray-1",
    "tray-2",
    "tray-3",
    "tray-4",
    "tray-5",
    "tray-6",
    "tray-7",
    "tray-8",
    "tray-9",
    "tray-10",
    "tray-11",
    "tray-12",
    "tray-13",
    "tray-14",
    "tray-15",
    "tray-16",
    "tray-17",
    "tray-18",
    "tray-19",
    "tray-20",

    VND_JOB_ACC_OUT_BIN_KWV

    pwgNULL
};

pwgBIT8 pwgJobAccountingOutputBin_KWVLevel[] = {
    PJT_SUPPORT_LEVEL_NONE,   /* "-"                */
    PJT_SUPPORT_LEVEL_NONE,   /* "_"                */
    PJT_SUPPORT_LEVEL_1,      /* "Unknown"          */

    PJT_SUPPORT_LEVEL_1,      /* "top"              */
    PJT_SUPPORT_LEVEL_2,      /* "middle"           */
    PJT_SUPPORT_LEVEL_1,      /* "bottom"           */
    PJT_SUPPORT_LEVEL_2,      /* "side"             */
    PJT_SUPPORT_LEVEL_3,      /* "left"             */
    PJT_SUPPORT_LEVEL_3,      /* "right"            */
    PJT_SUPPORT_LEVEL_3,      /* "center"           */
    PJT_SUPPORT_LEVEL_2,      /* "rear"             */
    PJT_SUPPORT_LEVEL_3,      /* "face-up"          */
    PJT_SUPPORT_LEVEL_3,      /* "face-down"        */
    PJT_SUPPORT_LEVEL_1,      /* "large-capacity"   */

    PJT_SUPPORT_LEVEL_3,      /* "stacker-1"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-2"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-3"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-4"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-5"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-6"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-7"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-8"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-9"        */
    PJT_SUPPORT_LEVEL_3,      /* "stacker-10"       */

    PJT_SUPPORT_LEVEL_2,      /* "mailbox-1"        */
    PJT_SUPPORT_LEVEL_2,      /* "mailbox-2"        */
    PJT_SUPPORT_LEVEL_2,      /* "mailbox-3"        */
    PJT_SUPPORT_LEVEL_2,      /* "mailbox-4"        */
    PJT_SUPPORT_LEVEL_2,      /* "mailbox-5"        */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-6"        */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-7"        */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-8"        */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-9"        */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-10"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-11"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-12"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-13"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-14"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-15"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-16"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-17"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-18"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-19"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-20"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-21"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-22"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-23"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-24"       */
    PJT_SUPPORT_LEVEL_3,      /* "mailbox-25"       */

    PJT_SUPPORT_LEVEL_2,      /* "my-mailbox"       */

    PJT_SUPPORT_LEVEL_3,      /* "tray-1"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-2"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-3"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-4"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-5"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-6"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-7"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-8"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-9"           */
    PJT_SUPPORT_LEVEL_3,      /* "tray-10"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-11"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-12"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-13"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-14"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-15"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-16"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-17"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-18"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-19"          */
    PJT_SUPPORT_LEVEL_3,      /* "tray-20"          */

    VND_JOB_ACC_OUT_BIN_KWVL

    0
};

pwgBOOL pwgJobAccountingOutputBin_KWVSupported[] = {
    pwgNOT_SUPPORTED,   /* "-"                */
    pwgNOT_SUPPORTED,   /* "_"                */
    pwgSUPPORTED,       /* "Unknown"          */

    pwgSUPPORTED,      /* "top"              */
    pwgSUPPORTED,      /* "middle"           */
    pwgSUPPORTED,      /* "bottom"           */
    pwgSUPPORTED,      /* "side"             */
    pwgSUPPORTED,      /* "left"             */
    pwgSUPPORTED,      /* "right"            */
    pwgSUPPORTED,      /* "center"           */
    pwgSUPPORTED,      /* "rear"             */
    pwgSUPPORTED,      /* "face-up"          */
    pwgSUPPORTED,      /* "face-down"        */
    pwgSUPPORTED,      /* "large-capacity"   */

    pwgSUPPORTED,      /* "stacker-1"        */
    pwgSUPPORTED,      /* "stacker-2"        */
    pwgSUPPORTED,      /* "stacker-3"        */
    pwgSUPPORTED,      /* "stacker-4"        */
    pwgSUPPORTED,      /* "stacker-5"        */
    pwgSUPPORTED,      /* "stacker-6"        */
    pwgSUPPORTED,      /* "stacker-7"        */
    pwgSUPPORTED,      /* "stacker-8"        */
    pwgSUPPORTED,      /* "stacker-9"        */
    pwgSUPPORTED,      /* "stacker-10"       */

    pwgSUPPORTED,      /* "mailbox-1"        */
    pwgSUPPORTED,      /* "mailbox-2"        */
    pwgSUPPORTED,      /* "mailbox-3"        */
    pwgSUPPORTED,      /* "mailbox-4"        */
    pwgSUPPORTED,      /* "mailbox-5"        */
    pwgSUPPORTED,      /* "mailbox-6"        */
    pwgSUPPORTED,      /* "mailbox-7"        */
    pwgSUPPORTED,      /* "mailbox-8"        */
    pwgSUPPORTED,      /* "mailbox-9"        */
    pwgSUPPORTED,      /* "mailbox-10"       */
    pwgSUPPORTED,      /* "mailbox-11"       */
    pwgSUPPORTED,      /* "mailbox-12"       */
    pwgSUPPORTED,      /* "mailbox-13"       */
    pwgSUPPORTED,      /* "mailbox-14"       */
    pwgSUPPORTED,      /* "mailbox-15"       */
    pwgSUPPORTED,      /* "mailbox-16"       */
    pwgSUPPORTED,      /* "mailbox-17"       */
    pwgSUPPORTED,      /* "mailbox-18"       */
    pwgSUPPORTED,      /* "mailbox-19"       */
    pwgSUPPORTED,      /* "mailbox-21"       */
    pwgSUPPORTED,      /* "mailbox-22"       */
    pwgSUPPORTED,      /* "mailbox-23"       */
    pwgSUPPORTED,      /* "mailbox-24"       */
    pwgSUPPORTED,      /* "mailbox-25"       */

    pwgSUPPORTED,      /* "my-mailbox"       */

    pwgSUPPORTED,      /* "tray-1"           */
    pwgSUPPORTED,      /* "tray-2"           */
    pwgSUPPORTED,      /* "tray-3"           */
    pwgSUPPORTED,      /* "tray-4"           */
    pwgSUPPORTED,      /* "tray-5"           */
    pwgSUPPORTED,      /* "tray-6"           */
    pwgSUPPORTED,      /* "tray-7"           */
    pwgSUPPORTED,      /* "tray-8"           */
    pwgSUPPORTED,      /* "tray-9"           */
    pwgSUPPORTED,      /* "tray-10"          */
    pwgSUPPORTED,      /* "tray-11"          */
    pwgSUPPORTED,      /* "tray-12"          */
    pwgSUPPORTED,      /* "tray-13"          */
    pwgSUPPORTED,      /* "tray-14"          */
    pwgSUPPORTED,      /* "tray-15"          */
    pwgSUPPORTED,      /* "tray-16"          */
    pwgSUPPORTED,      /* "tray-17"          */
    pwgSUPPORTED,      /* "tray-18"          */
    pwgSUPPORTED,      /* "tray-19"          */
    pwgSUPPORTED,      /* "tray-20"          */

    VND_JOB_ACC_OUT_BIN_KWVS

    0
};

pwgNUM_RNG_DEF pwgDef_JobAccountingOutputBin = {
                                PWG_ELEMENT_TYPE_NUM_RNG,           /* Type of parameter definition         */
                                PWG_TYPE_ENUM,                      /* The data type                        */
                                "Job Accounting Output Bin",        /* Textual name of parametric           */
                                PJT_SUPPORT_LEVEL_2,                /* Minimum pjt level it is supported    */
                                PWG_MUST_HONOR,                     /* Must Honor Enforcement               */
                                pwgSUPPORTED,

                                PWG_JOB_ACCOUNTING_OUTPUT_BIN_UNKNOWN,/* Default or nominal setting         */
                                PWG_JOB_ACCOUNTING_OUTPUT_BIN_UNKNOWN,/* Setting data value                 */

                                pwgJobAccountingOutputBin_Keywords, /* ENUM Keyword names (strings)         */
                                pwgJobAccountingOutputBin_KWValues, /* ENUM Keyword (string) values         */
                                pwgJobAccountingOutputBin_KWVLevel, /* ENUM Keyword pjt support level       */
                                pwgJobAccountingOutputBin_KWVSupported,/*UM Keywords supported              */

                                PWG_JOB_ACCOUNTING_OUTPUT_BIN_UNKNOWN,/* The minimum   data value           */
                                PWG_JOB_ACCOUNTING_OUTPUT_BIN_END - 1,/* The maximum   data value           */
                                1                                   /* The increment data value             */
};

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ============================= pwg.pjt.pjp.2.job.accounting.output.bin.c ================================ */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
