/* ======================================= pwg.main.sample.app.C ========================================== */
/* ..................................................|..................................................... */

/* -------------------------------------------------------------------------------------------------------- */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/*        1         2         3         4         5         6         7         8         9         10      */
/* ..................................................|..................................................... */
/*                                                                                                          */
/****************************************************|*******************************************************/
/*                                                                                                          */
/*    Copyright (c) 2013-2013                SEIKO EPSON CORPORATION            All Rights Reserved         */
/*                                                                                                          */
/*                                      Common Public License - v 1.0                                       */
/*   THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS COMMON PUBLIC LICENSE ("AGREEMENT").      */
/*   ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS        */
/*   AGREEMENT.                                                                                             */
/*                                                                                                          */
/* 1. DEFINITIONS                                                                                           */
/*    "Contribution" means:                                                                                 */
/*    a) in the case of the initial Contributor, the initial code and documentation distributed under this  */
/*       Agreement, and                                                                                     */
/*    b) in the case of each subsequent Contributor:                                                        */
/*        i) changes to the Program, and                                                                    */
/*       ii) additions to the Program;                                                                      */
/*                                                                                                          */
/*       where such changes and/or additions to the Program originate from and are distributed by that      */
/*       particular Contributor. A Contribution 'originates' from a Contributor if it was added to the      */
/*       Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions    */
/*       do not include additions to the Program which:                                                     */
/*      (i) are separate modules of software distributed in conjunction with the Program under their own    */
/*          license agreement, and                                                                          */
/*     (ii) are not derivative works of the Program.                                                        */
/*                                                                                                          */
/*    "Contributor" means any person or entity that distributes the Program.                                */
/*                                                                                                          */
/*    "Licensed Patents" mean patent claims licensable by a Contributor which are necessarily infringed     */
/*    by the use or sale of its Contribution alone or when combined with the Program.                       */
/*                                                                                                          */
/*    "Program" means the Contributions distributed in accordance with this Agreement.                      */
/*                                                                                                          */
/*    "Recipient" means anyone who receives the Program under this Agreement, including all Contributors.   */
/*                                                                                                          */
/* 2. GRANT OF RIGHTS                                                                                       */
/*    a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free copyright license to reproduce, prepare derivative works of, publicly      */
/*       display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, */
/*       and such derivative works, in source code and object code form.                                    */
/*    b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive,  */
/*       worldwide, royalty-free patent license under Licensed Patents to make, use, sell, offer to sell,   */
/*       import and otherwise transfer the Contribution of such Contributor, if any, in source code and     */
/*       object code form. This patent license shall apply to the combination of the Contribution and the   */
/*       Program if, at the time the Contribution is added by the Contributor, such addition of the         */
/*       Contribution causes such combination to be covered by the Licensed Patents.  The patent license    */
/*       shall not apply to any other combinations which include the Contribution. No hardware per se is    */
/*       licensed hereunder.                                                                                */
/*    c) Recipient understands that although each Contributor grants the licenses to its Contributions set  */
/*       forth herein, no assurances are provided by any Contributor that the Program does not infringe the */
/*       patent or other intellectual property rights of any other entity. Each Contributor disclaims any   */
/*       liability to Recipient for claims brought by any other entity based on infringement of             */
/*       intellectual property rights or otherwise. As a condition to exercising the rights and licenses    */
/*       granted hereunder, each Recipient hereby assumes sole responsibility to secure any other           */
/*       intellectual property rights needed, if any.  For example, if a third party patent license is      */
/*       required to allow Recipient to distribute the Program, it is Recipient's responsibility to         */
/*       acquire that license before distributing the Program.                                              */
/*    d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its        */
/*       Contribution, if any, to grant the copyright license set forth in this Agreement.                  */
/*                                                                                                          */
/* 3. REQUIREMENTS                                                                                          */
/*    A Contributor may choose to distribute the Program in object code form under its own license          */
/*    agreement, provided that:                                                                             */
/*    a) it complies with the terms and conditions of this Agreement; and                                   */
/*    b) its license agreement:                                                                             */
/*        i) effectively disclaims on behalf of all Contributors all warranties and conditions, express     */
/*           and implied, including warranties or conditions of title and non-infringement, and implied     */
/*           warranties or conditions of merchantability and fitness for a particular purpose;              */
/*       ii) effectively excludes on behalf of all Contributors all liability for damages, including        */
/*           direct, indirect, special, (incidental and consequential damages, such as lost profits;        */
/*      iii) states that any provisions which differ from this Agreement are offered by that Contributor    */
/*           alone and not by any other party; and                                                          */
/*       iv) states that source code for the Program is available from such Contributor, and informs        */
/*           licensees how to obtain it in a reasonable manner on or through a medium customarily used      */
/*           for software exchange.                                                                         */
/*    When the Program is made available in source code form:                                               */
/*        a) it must be made available under this Agreement; and                                            */
/*        b) a copy of this Agreement must be included with each copy of the Program.                       */
/*    Contributors may not remove or alter any copyright notices contained within the Program.              */
/*                                                                                                          */
/*    Each Contributor must identify itself as the originator of its Contribution, if any, in a manner      */
/*    that reasonably allows subsequent Recipients to identify the originator of the Contribution.          */
/*                                                                                                          */
/* 4. COMMERCIAL DISTRIBUTION                                                                               */
/*    Commercial distributors of software may accept certain responsibilities with respect to end users,    */
/*    business partners and the like. While this license is intended to facilitate the commercial use of    */
/*    the Program, the Contributor who includes the Program in a commercial product offering should do so   */
/*    in a manner which does not create potential liability for other Contributors. Therefore, if a         */
/*    Contributor includes the Program in a commercial product offering, such Contributor                   */
/*    ("Commercial Contributor") hereby agrees to defend and indemnify every other Contributor              */
/*    ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising     */
/*    from claims, lawsuits and other legal actions brought by a third party against the Indemnified        */
/*    Contributor to the extent caused by the acts or omissions of such Commercial Contributor in           */
/*    connection with its distribution of the Program in a commercial product offering. The obligations in  */
/*    this section do not apply to any claims or Losses relating to any actual or alleged intellectual      */
/*    property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the   */
/*    Commercial Contributor in writing of such claim, and b) allow the Commercial Contributor to control,  */
/*    and cooperate with the Commercial Contributor in, the defense and any related settlement              */
/*    negotiations. The Indemnified Contributor may participate in any such claim at its own expense.       */
/*                                                                                                          */
/*    For example, a Contributor might include the Program in a commercial product offering, Product X.     */
/*    That Contributor is then a Commercial Contributor. If that Commercial Contributor then makes          */
/*    performance claims, or offers warranties related to Product X, those performance claims and           */
/*    warranties are such Commercial Contributor's responsibility alone. Under this section, the Commercial */
/*    Contributor would have to defend claims against the other Contributors related to those performance   */
/*    claims and warranties, and if a court requires any other Contributor to pay any damages as a result,  */
/*    the Commercial Contributor must pay those damages.                                                    */
/*                                                                                                          */
/* 5. NO WARRANTY                                                                                           */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS,         */
/*    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT            */
/*    LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS       */
/*    FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness    */
/*    of using and distributing the Program and assumes all risks associated with its exercise of rights    */
/*    under this Agreement, including but not limited to the risks and costs of program errors, compliance  */
/*    with applicable laws, damage to or loss of data, programs or equipment, and unavailability or         */
/*    interruption of operations.                                                                           */
/*                                                                                                          */
/* 6. DISCLAIMER OF LIABILITY                                                                               */
/*    EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE    */
/*    ANY LIABILITY FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES      */
/*    (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER   */
/*    IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     */
/*    OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF    */
/*    ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                                                           */
/*                                                                                                          */
/* 7. GENERAL                                                                                               */
/*    If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not     */
/*    affect the validity or enforceability of the remainder of the terms of this Agreement, and without    */
/*    further action by the parties hereto, such provision shall be reformed to the minimum extent          */
/*    necessary to make such provision valid and enforceable.                                               */
/*                                                                                                          */
/*    If Recipient institutes patent litigation against a Contributor with respect to a patent applicable   */
/*    to software (including a cross-claim or counterclaim in a lawsuit), then any patent licenses granted  */
/*    by that Contributor to such Recipient under this Agreement shall terminate as of the date such        */
/*    litigation is filed. In addition, if Recipient institutes patent litigation against any  entity       */
/*    (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding    */
/*    combinations of the Program with other software or hardware) infringes such Recipient's patent(s),    */
/*    then such Recipient's rights granted under Section 2(b) shall terminate as of the date such           */
/*    litigation is filed.                                                                                  */
/*                                                                                                          */
/*    All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the     */
/*    material terms or conditions of this Agreement and does not cure such failure in a reasonable         */
/*    period of time after becoming aware of such noncompliance. If all Recipient's rights under this       */
/*    Agreement terminate, Recipient agrees to cease use and distribution of the Program as soon as         */
/*    reasonably practicable. However, Recipient's obligations under this Agreement and any licenses        */
/*    granted by Recipient relating to the Program shall continue and survive.                              */
/*                                                                                                          */
/*    Everyone is permitted to copy and distribute copies of this Agreement, but in order to avoid          */
/*    inconsistency the Agreement is copyrighted and may only be modified in the following manner. The      */
/*    Agreement Steward reserves the right to publish new versions (including revisions) of this Agreement  */
/*    from time to time. No one other than the Agreement Steward has the right to modify this Agreement.    */
/*    IBM is the initial Agreement Steward. IBM may assign the responsibility to serve as the Agreement     */
/*    Steward to a suitable separate entity. Each new version of the Agreement will be given a              */
/*    distinguishing version number. The Program (including Contributions) may always be distributed        */
/*    subject to the version of the Agreement under which it was received. In addition, after a new         */
/*    version of the Agreement is published, Contributor may elect to distribute the Program (including     */
/*    its Contributions) under the new version. Except as expressly stated in Sections 2(a) and 2(b) above, */
/*    Recipient receives no rights or licenses to the intellectual property of any Contributor under this   */
/*    Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not    */
/*    expressly granted under this Agreement are reserved.                                                  */
/*                                                                                                          */
/*    This Agreement is governed by the laws of the State of New York and the intellectual property laws    */
/*    of the United States of America. No party to this Agreement will bring a legal action under this      */
/*    Agreement more than one year after the cause of action arose. Each party waives its rights to a       */
/*    jury trial in any resulting litigation.                                                               */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */
/*                                                                                                          */
/* Code States:                                                                                             */
/*      Initial                                                                                             */
/*                          Developing                                                                      */
/*      Working                                                                                             */
/*      Tested                                                                                              */
/*      Refactored                                                                                          */
/*      Final Candidate                                                                                     */
/*      Final Code                                                                                          */
/*                                                                                                          */
/* *****%*******************%*****|************************************************************************ */

/* ---------------------------------------------- Includes ------------------------------------------------ */
/* ..................................................|..................................................... */

#include "gw.win.h"
#include "gw.main.sample.app.h"
#include "pwg.pjt.xxx.N.new.pjt.h"
/* ---------------------------------------------- Macros -------------------------------------------------- */
/* ..................................................|..................................................... */

/* --------------------------------------------- Definition ----------------------------------------------- */
/* ..................................................|..................................................... */
#define Show(o) \
    fprintf(stderr,"Object: %s: %d\n", o, senderId); fflush(stderr);

/* ------------------------------------- Data Structure Declarations -------------------------------------- */
/* ..................................................|..................................................... */

/* ------------------------------------ Application Global Variables -------------------------------------- */
/* ..................................................|..................................................... */

/* ---------------------------------------- Local Global Variables ---------------------------------------- */
/* ..................................................|..................................................... */
pwgPrintJobTicket*  pjt               = pwgNULL;
pwgSTRUCT_DEF*      pjtDef            = pwgNULL;
pwgSTRUCT_DEF*      currentPjtItemDef = pwgNULL;
pwgSTRUCT_DEF*      parentPjtItemDef  = pwgNULL;
pwgBIT8             supportLevel      = PJT_SUPPORT_LEVEL_3;

pwgBIT32 lastXRefdx    = 0;
pwgBIT32 currentXRefdx = 0;
pwgBIT32 parentXRefdx  = 0;
pwgBIT32 currentDx     = 0;
pwgBIT32 xref[35000][2];
gpBIT32 levelButtonWidth;

/* ---------------------------------  Graphic Elements for Main Window  ----------------------------------- */
/* ..................................................|..................................................... */
gpWIN         mainWin;        /* Main Window                                                                */
    gwPUSHBUTTON*   level1Button;
    gwPUSHBUTTON*   level2Button;
    gwPUSHBUTTON*   level3Button;

    gwPUSHBUTTON*   pjtButton;
    gwPUSHBUTTON*   capButton;

    gwTREELIST*     pjtTree;
    gwTREELIST*     capTree;

    QTreeWidgetItem* tempTWI;
QTreeWidgetItem* currentItemId;
QTreeWidgetItem* parentItemId;

    gwLABEL*        menuLabel;
    gwICON*         sep1;
    gwICON*         sep2;

    gwEDITAREA*     displayArea;
    gwLABEL*           selectLabel;
    gwLABEL*             typeLabel;
    gwLABEL*            levelLabel;
    gwLABEL*        mustHonorLabel;
    gwLABEL*         supportedLabel;
    gwLABEL*        rangeStartLabel;
    gwLABEL*          rangeEndLabel;
    gwLABEL*         rangeStepLabel;
    gwLABEL*           defaultLabel;
    gwLABEL*           settingLabel;



    gwMENU*         mouseRightButtonMenu;
    gwMENUITEM*     itemMustHonor;
    gwMENUITEM*     itemSupported;
    gwMENUITEM*     itemSetValue;

/* ---------------------------------------- Function Declarations ----------------------------------------- */
/* ..................................................|..................................................... */
static gpVOID  _CreateMainWindow(gpWIN*);
       gpVOID  _MainWindowCallBack(QObject*);
static gpVOID  _TreeCascade(pwgSTRUCT_DEF* ptr);
static gpVOID  _UpdateElementDisplay(pwgSTRUCT_DEF* ptr);

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/* ======================================================================================================== */
/* Function name: main()                                                                                    */
/* ..................................................|..................................................... */
gpINT32 main (

    gpINT32 argc,
    gpCHAR* argv[]

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    pwgNewPrintJobTicket(&pjt, &pjtDef);            /* Create a default populated job ticket                */

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */
    strcpy(mainWin.title, "The PWG Print Job Ticket Tool\0");
    gwWindowInitialize (argc, argv);
    gwSetCallBackFncNew(_MainWindowCallBack);

/*** Create Main Window and Widgets                                                                         */
/*** ------------------------------------------------------------------------------------------------------ */
    _CreateMainWindow(&mainWin);

/*** Show (Display) Windows and Dialogs                                                                     */
/*** ------------------------------------------------------------------------------------------------------ */
    Prt("### Starting PWG Print Job Ticket Tool ###\n");
    fprintf(stderr,"lastXRefdx: %d\n\n\n\n", lastXRefdx); fflush(stderr);
    gwWindowShow(mainWin.win);

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return gwWindowExec();

} /* main                                                                                                   */

/* ======================================================================================================== */
/* Function name: Call Back for Print Dialog                                                                */
/* ..................................................|..................................................... */
gpVOID _MainWindowCallBack(

    QObject* sender

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpBIT32 senderId;
gpBIT32 senderItemId;
gpBIT32 idx, ddd, sss;
gpBIT32 keyMod;
gpBOOL  checkedState;

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    senderId    = (gpBIT32)sender;
    keyMod      = QApplication::keyboardModifiers();

    Show("Received");

/*** Process Individual Dialog Widgets                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    while (gpTRUE) {

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Print Job Ticket Tree                                                                                  */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)pjtTree) {
      Show("PJT Tree");
      senderItemId = (gpBIT32)((QTreeWidgetItem*)((pjtTree)->currentItem()));
      fprintf(stderr,"Object: PJT Tree: Item: %d\n", senderItemId); fflush(stderr);

      currentItemId = (QTreeWidgetItem*)senderItemId;
      for (idx = 0; idx < lastXRefdx; idx++) { if (senderItemId == xref[idx][0]) break; }
      currentXRefdx = idx;
      currentPjtItemDef = (pwgSTRUCT_DEF*)(xref[currentXRefdx][1]);

      parentItemId = currentItemId->parent();
      for (idx = 0; idx < lastXRefdx; idx++) { if ((gpBIT32)parentItemId == xref[idx][0]) break; }
      parentXRefdx = idx;
      parentPjtItemDef = (pwgSTRUCT_DEF*)(xref[parentXRefdx][1]);

      /*** "Must Honor" Check mark of Right-Click PopUp Menu                                                */
      /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
      if (currentPjtItemDef->mustHonor == pwgFALSE)         { itemMustHonor->setChecked(pwgFALSE); }
      else                                                  { itemMustHonor->setChecked(pwgTRUE ); }
      if (currentPjtItemDef->supported == pwgNOT_SUPPORTED) { itemSupported->setChecked(pwgFALSE); }
      else                                                  { itemSupported->setChecked(pwgTRUE ); }
      //if (currentPjtItemDef->mustHonor == pwgTRUE) { itemMustHonor->setChecked(pwgTRUE ); }

      /*** "Supported" Check mark of Right-Click PopUp Menu                                                 */
      /*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
      if (keyMod == gwKEY_MOD_CONTROL) {
        if (currentPjtItemDef->supported == pwgSUPPORTED) {
          itemSupported->setChecked((bool)gpFALSE);
          gwTreeListSetCurrentItemColor(pjtTree, gwLightGray);
          currentPjtItemDef->supported = pwgNOT_SUPPORTED;
        } else {
          itemSupported->setChecked((bool)gpTRUE);
          gwTreeListSetCurrentItemColor(pjtTree, gwBlack);
          currentPjtItemDef->supported = pwgSUPPORTED;
        }
      }

      _UpdateElementDisplay(currentPjtItemDef);

      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** "Must Honor" Popup Menu item                                                                           */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)itemMustHonor) {
      Show("Item Must Honor");
      checkedState = itemMustHonor->isChecked(); /***&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&& */
      if (checkedState == gpTRUE) currentPjtItemDef->mustHonor = pwgTRUE;
      else                        currentPjtItemDef->mustHonor = pwgFALSE;
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** "Supported" Popup Menu item                                                                            */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)itemSupported) {
      Show("Item Supported");
      checkedState = itemSupported->isChecked();
      if (checkedState == gpTRUE) {
        currentPjtItemDef->supported = pwgSUPPORTED;
        gwTreeListSetCurrentItemColor(pjtTree, gwBlack);
      } else {
        currentPjtItemDef->supported = pwgNOT_SUPPORTED;
        gwTreeListSetCurrentItemColor(pjtTree, gwLightGray);
      }
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** "Set Value" Popup Menu item                                                                            */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)itemSetValue) {
      Show("Item Set Value");
      ddd = ((pwgNUM_RNG_DEF*) parentPjtItemDef)->dflt - 2;
      sss = ((pwgNUM_RNG_DEF*) parentPjtItemDef)->setting - 2;

      tempTWI = (QTreeWidgetItem*) ((QTreeWidgetItem*)parentItemId)->child(sss);
      gwTreeListSetThisItemColor(tempTWI, gwBlack);
     ((pwgNUM_RNG_DEF*) parentPjtItemDef)->setting = (gpBIT32)(parentItemId->indexOfChild(currentItemId)+2);

      fprintf(stderr,"Setting: %d\n", ((pwgNUM_RNG_DEF*) parentPjtItemDef)->setting); fflush(stderr);

      tempTWI = (QTreeWidgetItem*) ((QTreeWidgetItem*)parentItemId)->child(ddd);
      gwTreeListSetThisItemColor(tempTWI, gwRed);

      gwTreeListSetCurrentItemColor(pjtTree, gwBlue);
      itemSetValue->setChecked(gpFALSE);

      _UpdateElementDisplay(parentPjtItemDef);
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Level 1 Button                                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)level1Button) {
      Show("Level 1 Button");
      gwPushButtonDown(level1Button);
      gwPushButtonUp  (level2Button);
      gwPushButtonUp  (level3Button);
      supportLevel = PJT_SUPPORT_LEVEL_1;
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Level 2 Button                                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)level2Button) {
      Show("Level 2 Button");
//      gwWindowClose(mainWin.win);
      gwPushButtonUp  (level1Button);
      gwPushButtonDown(level2Button);
      gwPushButtonUp  (level3Button);
      supportLevel = PJT_SUPPORT_LEVEL_2;
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Level 3 Button                                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)level3Button) {
      Show("Level 3 Button");
      gwPushButtonUp  (level1Button);
      gwPushButtonUp  (level2Button);
      gwPushButtonDown(level3Button);
      supportLevel = PJT_SUPPORT_LEVEL_3;
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Print Job Ticket Button                                                                                */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)pjtButton) {
      Show("PJT Button");
      gwPushButtonDown(pjtButton);
      gwPushButtonUp  (capButton);
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Print Capabilities Button                                                                              */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)capButton) {
      Show("Capability Button");
      gwPushButtonUp  (pjtButton);
      gwPushButtonDown(capButton);
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** Display Area                                                                                           */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
    if (senderId == (gpBIT32)displayArea) {
      Prt("Display Area\n");
      break;
    }

/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
/*** What happened - Error occurred                                                                         */
/*** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
        break;
    }

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;

} /* MainWindowCallBack                                                                                     */

/* ======================================================================================================== */
/* Function name: _CreateMainWindow                                                                         */
/* ..................................................|..................................................... */
static gpVOID _CreateMainWindow(

    gpWIN*        mainWin                           /* Main Window                                          */

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gwFONT* font;
gpRECT  dispRect;
gpBIT32 tmp;

/*** Initialize Generic Window Variables                                                                    */
/*** ------------------------------------------------------------------------------------------------------ */
    levelButtonWidth = 100;
    tmp = windowMetric.border.width;

/*** Create a Main Window                                                                                   */
/*** ------------------------------------------------------------------------------------------------------ */
    mainWin->win = gwWindowNew();
    gwWindowTitle(mainWin->win, mainWin->title);
    gwWindowFrame(mainWin->win, 20, 100, 880, 700);

    /*** Temporary Label for Menus                                                                          */
    /*** .................................................................................................. */
    menuLabel = gwLabelNew(mainWin->win);
    font = gwFontNew(mainWin->win);
    gwFontSize(font, 8);
    //gwFontBold(font);
    gwLabelTitle(menuLabel,
     "icon File    Edit    View    Insert    Format    Tools    Window    Help");
    gwLabelFrame(menuLabel, 5, 5, 400, 16);
    gwLabelFont (menuLabel, font);
    gwLabelAlign(menuLabel, gwALIGN_LEFT);

    /*** Separator Line                                                                                     */
    /*** .................................................................................................. */
    sep1 = gwIconNew(mainWin->win);
    gwIconImageFile(sep1, "../common.sw/res/HorzSepLine.png");
    gwIconFrame    (sep1, 0, 24, windowMetric.frame.width, 2);
    gwIconShow     (sep1, gpTRUE);

    /*** "Level" Push Buttons                                                                               */
    /*** .................................................................................................. */
    level1Button = gwPushButtonNew(mainWin->win);
    gwPushButtonTitle  (level1Button,"Level 1" );
    gwPushButtonFrame  (level1Button,
                        tmp, 26, levelButtonWidth, 20);
    gwPushButtonConnect(_MainWindowCallBack, level1Button, clicked());

    tmp += levelButtonWidth;
    level2Button = gwPushButtonNew(mainWin->win);
    gwPushButtonTitle  (level2Button,"Level 2");
    gwPushButtonFrame  (level2Button,
                        tmp, 26, levelButtonWidth, 20);
    gwPushButtonConnect(_MainWindowCallBack, level2Button, clicked());

    tmp += levelButtonWidth;
    level3Button = gwPushButtonNew(mainWin->win);
    gwPushButtonTitle  (level3Button,"Level 3");
    gwPushButtonFrame  (level3Button,
                        tmp, 26, levelButtonWidth, 20);
    gwPushButtonConnect(_MainWindowCallBack, level3Button, clicked());
    gwPushButtonDown   (level3Button);

    /*** Separator Line                                                                                     */
    /*** .................................................................................................. */
    sep2 = gwIconNew(mainWin->win);
    gwIconImageFile(sep2, "../common.sw/res/HorzSepLine.png");
    gwIconFrame    (sep2, 0, 46, windowMetric.frame.width, 2);
    gwIconShow     (sep2, gpTRUE);

    tmp = windowMetric.border.width;
    pjtButton = gwPushButtonNew(mainWin->win);
    gwPushButtonTitle  (pjtButton,"Print Job Ticket");
    gwPushButtonFrame  (pjtButton,
                        tmp, 48, (levelButtonWidth*3)/2, 20);
    gwPushButtonConnect(_MainWindowCallBack, pjtButton, clicked());
    gwPushButtonDown   (pjtButton);
    gwPushButtonBkColor(pjtButton, QPalette::BrightText);
pjtButton->setAutoFillBackground(true);
pjtButton->setStyleSheet("background-color: rgb(255, 0, 0); color: rgb(255, 255, 255)");


    tmp += (levelButtonWidth*3)/2;
    capButton = gwPushButtonNew(mainWin->win);
    gwPushButtonTitle  (capButton,"Print Capabilities");
    gwPushButtonFrame  (capButton,
                        tmp, 48, (levelButtonWidth*3)/2, 20);
    gwPushButtonConnect(_MainWindowCallBack, capButton, clicked());

    /*** Set up Print Job Ticket Tree widget                                                                */
    /*** .................................................................................................. */
    pjtTree = gwTreeListNew(mainWin->win);
    gwTreeListFrame(pjtTree, 10, 70, 300, windowMetric.frame.height - windowMetric.border.height - 70);
    gwTreeListTitle(pjtTree, "Print Job Ticket");
    _TreeCascade(pjtDef);
    gwTreeListConnect(_MainWindowCallBack, pjtTree, itemPressed(QTreeWidgetItem*, int));

    /*** Mouse Right Button Click Menu                                                                      */
    /*** .................................................................................................. */
    mouseRightButtonMenu = gwMenu();

    itemMustHonor = gwNewMenuItem("Must Honor" , mouseRightButtonMenu);
    itemSupported = gwNewMenuItem("Supported"  , mouseRightButtonMenu);
    itemSetValue  = gwNewMenuItem("Set Value"  , mouseRightButtonMenu);

    gwAddMenuItem(mouseRightButtonMenu, itemMustHonor);
    gwAddMenuItem(mouseRightButtonMenu, itemSupported);
    gwAddMenuItem(mouseRightButtonMenu, itemSetValue );

    gwTreeListAddMenuItem(pjtTree,itemMustHonor);
    gwTreeListAddMenuItem(pjtTree,itemSupported);
    gwTreeListAddMenuItem(pjtTree,itemSetValue );

    gwMenuConnect(_MainWindowCallBack, itemMustHonor, toggled(bool));
    gwMenuConnect(_MainWindowCallBack, itemSupported, changed());
    gwMenuConnect(_MainWindowCallBack, itemSetValue , changed());

    /*** Set up Main Text Display Area                                                                      */
    /*** -------------------------------------------------------------------------------------------------- */

    /*** Label for Selected Item                                                                            */
    /*** .................................................................................................. */
    dispRect.top  = 48; //2*windowMetric.border.height + 127;
    dispRect.left = windowMetric.border.width + 3*levelButtonWidth;

    dispRect.width  = windowMetric.frame.width  -
                      windowMetric.border.width -
                      dispRect.left;
    dispRect.height = windowMetric.frame.height -
                      windowMetric.border.height -
                      dispRect.top;
                    //3*windowMetric.border.height -
                    //127;


    selectLabel     = gwLabelNew(mainWin->win);
    typeLabel       = gwLabelNew(mainWin->win);
    levelLabel      = gwLabelNew(mainWin->win);
    mustHonorLabel  = gwLabelNew(mainWin->win);
    supportedLabel  = gwLabelNew(mainWin->win);
    rangeStartLabel = gwLabelNew(mainWin->win);
    rangeEndLabel   = gwLabelNew(mainWin->win);
    rangeStepLabel  = gwLabelNew(mainWin->win);
    defaultLabel    = gwLabelNew(mainWin->win);
    settingLabel    = gwLabelNew(mainWin->win);

    font = gwFontNew(mainWin->win);
    gwFontSize(font, 10);
    gwLabelFont (      typeLabel, font);
    gwLabelFont (     levelLabel, font);
    gwLabelFont ( mustHonorLabel, font);
    gwLabelFont ( supportedLabel, font);
    gwLabelFont (rangeStartLabel, font);
    gwLabelFont (  rangeEndLabel, font);
    gwLabelFont ( rangeStepLabel, font);
    gwLabelFont (   defaultLabel, font);
    gwLabelFont (   settingLabel, font);

    gwFontSize(font, 12);
    gwFontBold(font);
    gwLabelFont (selectLabel, font);
    gwLabelAlign(selectLabel, gwALIGN_H_CENTER);
    gwLabelFrame(selectLabel, dispRect.left, 60, dispRect.width, 30);
    gwLabelTitle(selectLabel, "Nothing Selected");



#if 0


    displayArea = gwEditAreaNew(mainWin->win);
    gwEditAreaFrame(displayArea, dispRect.left , dispRect.top,
                                 dispRect.width, dispRect.height);
    gwConnect(_MainWindowCallBack, displayArea,textChanged());
//    gwEditAreaSetText(displayArea,textData[USE_THIS_PAGE]);
#endif

/*** Return to Caller                                                                                       */
/*** ------------------------------------------------------------------------------------------------------ */
    return;



#if 0 /* example only */
    font = gwFontNew(mainWin->win);
    gwFontSize(font, 8);
    gwFontBold(font);
    gwTreeListSetItemFont(pjtTree, font);
#endif

    //gwTreeListSetCurrentItemColor(pjtTree, gwLightGray);



#if 0

//    gwTreeListSetSelectColor(pjtTree, gwRed);

//    gwDropListSelectItem(phoneSizes,cpsdx);
  //  gwDropListSetItemColor(phoneSizes, cpsdx, QColor( 0xAEDCE6));
    //gwConnect(MainWindowCallBack, phoneSizes,currentIndexChanged(int));

#endif

#if 0

#endif

} /* CreateMainWindow                                                                                       */

/* ======================================================================================================== */
/* Function name: _TreeCascade                                                                              */
/* ..................................................|..................................................... */
static pwgBIT32               treeLevel  = 0;
#define DEF_DEF_ATT(t,d,a)   ((t*)d)->a
#define GET_NAME(p)          (const char*)(((pwgSTRUCT_DEF*)(p))->name)
#define GET_LEVEL(p)         (pwgBIT8)(((pwgSTRUCT_DEF*)(p))->level)
#define GET_KVLEVEL(p,k)     (pwgBIT8)(((pwgNUM_RNG_DEF*)(p))->kwLevels[k])
#define SET_DEF(t,in,out)     memcpy((t*)(out), (t*)(in), sizeof(t))
#define ALLOC_DEF(t,a)        a = (t*)malloc(sizeof(t)); \
                              if (a == pwgNULL) {status = pwgERROR_MEMORY_ALLOCATION; break;}


/* ..................................................|..................................................... */
static pwgVOID _TreeCascade(

    pwgSTRUCT_DEF* ptr

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
PWG_ELEMENT_TYPE  pjtDefType;                         /* Type of pjt Definition                             */
pwgBIT32          kdx,jdx,idx,ddd,sss;
pwgBIT32          elementDefPtr;
pwgCHAR           fmt[128];

/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */

/*** Recursively loop through the PJT Structs                                                               */
/*** ------------------------------------------------------------------------------------------------------ */
  kdx = 0;
  while (pwgTRUE) {
    elementDefPtr = (pwgBIT32)(ptr->element[kdx++]);
    if (elementDefPtr == 0) { treeLevel -= 1; return; }
    if ( GET_LEVEL(elementDefPtr) > supportLevel ) continue;
    pjtDefType = DEF_DEF_ATT(pwgNUM_DEF, elementDefPtr, type);
    if (pjtDefType == PWG_ELEMENT_TYPE_STRUCT) {
      gwTreeListAddNext(pjtTree, treeLevel, GET_NAME(elementDefPtr));
      xref[lastXRefdx][0] = (pwgBIT32)gwTreeListGetAddress(treeLevel);
      xref[lastXRefdx][1] = (pwgBIT32)elementDefPtr;
      lastXRefdx++;
      treeLevel+=1;
      _TreeCascade((pwgSTRUCT_DEF*) elementDefPtr);
      continue;
    }
    gwTreeListAddNext(pjtTree, treeLevel, GET_NAME(elementDefPtr));
      xref[lastXRefdx][0] = (pwgBIT32)gwTreeListGetAddress(treeLevel);
      xref[lastXRefdx][1] = (pwgBIT32)elementDefPtr;
      lastXRefdx++;
    if (pjtDefType == PWG_ELEMENT_TYPE_NUM_RNG) {
      jdx = 0;
      treeLevel++;
      ddd = DEF_DEF_ATT(pwgNUM_RNG_DEF,elementDefPtr,dflt);
      sss = DEF_DEF_ATT(pwgNUM_RNG_DEF,elementDefPtr,setting);
      while (pwgTRUE) {
        idx = GET_KVLEVEL(elementDefPtr,jdx);
        if (idx == 0) break;
        if ( idx > supportLevel ) {jdx++; continue;}
        sprintf(fmt, "\"%s\"",DEF_DEF_ATT(pwgNUM_RNG_DEF,elementDefPtr,kwValues[jdx]));
        /*** Add a child to current Tree Level                                                              */
        gwTreeListAddNext(pjtTree, treeLevel, fmt);
          xref[lastXRefdx][0] = (pwgBIT32)gwTreeListGetAddress(treeLevel);
          xref[lastXRefdx][1] = (pwgBIT32)elementDefPtr;
          if (jdx == ddd) { gwTreeListSetThisItemColor(xref[lastXRefdx][0], gwRed );}
          if (jdx == sss) { gwTreeListSetThisItemColor(xref[lastXRefdx][0], gwBlue);}
          lastXRefdx++;
        jdx++;
      }
      treeLevel--;
    }
  }
} /* _TreeCascade                                                                                           */

/*** Update the Attributes/Values Region for this Element                                                   */
/*** ------------------------------------------------------------------------------------------------------ */
const gpCHAR* elementTypeStr[]= {" ",  "Type: \t\tNumber",
                                       "Type: \t\tNumber Range",
                                       "Type: \t\tArray",
                                       "Type: \t\tString",
                                       "Type: \t\tImage",
                                       "Type: \t\tIP4 address",
                                       "Type: \t\tIP6 address",
                                       "Type: \t\tDate",
                                       "Type: \t\tTime",
                                       "Type: \t\tInformational",
                                       "Type: \t\tError",
                                       "Type: \t\tStructure",
                                       "Type: \t\tBuffer"};
const gpCHAR*     levelStr[]  = {" ","Support Level: \t1","Support Level: \t2","Support Level: \t3"};
const gpCHAR* mustHonorStr[]  = {"Must Honor: \tNot Set","Must Honer: \tIs Set"};
const gpCHAR* supportedStr[]  = {"Supported: \tNo","Supported: \tYes"};

/*** ------------------------------------------------------------------------------------------------------ */
static pwgVOID _UpdateElementDisplay(

    pwgSTRUCT_DEF* ptr

) {
/*** Declare Variable Local to Routine                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
gpCHAR  dftStr[128];
gpCHAR  setStr[128];
gpINT32 suptFlg;
gpINT32 top, left, width, height;
gpINT32 spc;
gpINT32 dnum, snum;


/*** Initialize Local/Global Variables                                                                      */
/*** ------------------------------------------------------------------------------------------------------ */
    spc    = 12;
    top    = 60;
    left   = windowMetric.border.width + 3*levelButtonWidth + 10;
    width  = windowMetric.frame.width  -
             windowMetric.border.width -
             left;
    height = top + spc;

      gwLabelFrame(selectLabel, left, top, width, height);
      gwLabelTitle(selectLabel, ptr->name);

      top += spc; height += spc; gwLabelFrame(     typeLabel, left, top, width, height);
                                 gwLabelTitle(     typeLabel, elementTypeStr[ptr->type]);
      top += spc; height += spc; gwLabelFrame(    levelLabel, left, top, width, height);
                                 gwLabelTitle(    levelLabel,levelStr[ptr->level]);
      top += spc; height += spc; gwLabelFrame(mustHonorLabel, left, top, width, height);
                                 gwLabelTitle(mustHonorLabel, mustHonorStr[(gpINT32)ptr->mustHonor]);
      suptFlg = 0; if (ptr->supported == pwgSUPPORTED) suptFlg = 1;
      top += spc; height += spc; gwLabelFrame(supportedLabel, left, top, width, height);
                                 gwLabelTitle(supportedLabel, supportedStr[suptFlg]);
      switch (ptr->type) {
        case PWG_ELEMENT_TYPE_NUM:
        case PWG_ELEMENT_TYPE_ARRAY:
        case PWG_ELEMENT_TYPE_IPV4_ADD:
        case PWG_ELEMENT_TYPE_IPV6_ADD:
        case PWG_ELEMENT_TYPE_ERROR:
          sprintf(dftStr, "Default: \t%d",((pwgNUM_DEF*)ptr)->dflt);
          sprintf(setStr, "Setting: \t%d",((pwgNUM_DEF*)ptr)->setting);
          break;

        case PWG_ELEMENT_TYPE_NUM_RNG:
          dnum = ((pwgNUM_RNG_DEF*)ptr)->dflt;
          snum = ((pwgNUM_RNG_DEF*)ptr)->setting;
          sprintf(dftStr, "Default: \t%s",((pwgNUM_RNG_DEF*)ptr)->kwValues[dnum]);
          sprintf(setStr, "Setting: \t%s",((pwgNUM_RNG_DEF*)ptr)->kwValues[snum]);
          break;
        case PWG_ELEMENT_TYPE_STRING:
          sprintf(dftStr, "Default: \t---");
          sprintf(setStr, "Setting: \t%s",((pwgSTR_DEF*)ptr)->values);
          break;

        case PWG_ELEMENT_TYPE_DATE:
          sprintf(dftStr, "Default: \t---");
          sprintf(setStr, "Setting: \tdate");
          break;

        case PWG_ELEMENT_TYPE_TIME:
          sprintf(dftStr, "Default: \t---");
          sprintf(setStr, "Setting: \ttime");
          break;

        case PWG_ELEMENT_TYPE_INFO:
          sprintf(dftStr, "Default: \t%s",((pwgINFO_DEF*)ptr)->dflt);
          sprintf(setStr, "Setting: \t%s",((pwgINFO_DEF*)ptr)->setting);
          break;

        case PWG_ELEMENT_TYPE_STRUCT:
        case PWG_ELEMENT_TYPE_BUF:
        case PWG_ELEMENT_TYPE_IMAGE:
        default:
          sprintf(dftStr, "Default: \t---");
          sprintf(setStr, "Setting: \t---");
          break;
      }
      top += spc; height += spc; gwLabelFrame(  defaultLabel, left, top, width, height);
                                 gwLabelTitle(  defaultLabel, dftStr);
      top += spc; height += spc; gwLabelFrame(  settingLabel, left, top, width, height);
                                 gwLabelTitle(  settingLabel, setStr);

      /*
    gwLABEL*        rangeStartLabel;
    gwLABEL*          rangeEndLabel;
    gwLABEL*         rangeStepLabel;
    gwLABEL*           defaultLabel;
    gwLABEL*           settingLabel;
*/

} /* _UpdateElementDisplay                                                                                  */

/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*        1         2         3         4         5         6         7         8         9         10      */
/*2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567*/
/* ======================================================================================================== */
/*                                                                                                          */
/* ======================================= pwg.main.sample.app.C ========================================== */
/*                                                                                                          */
/*  END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE    END-OF-FILE   */
/* -------------------------------------------------------------------------------------------------------- */
